// $Id$
App.Discovery = Ember.Object.extend({});

App.Discovery.reopenClass({
    viewDiscoveryAudit: function() {
         var ajaxRequestUrl = '/api/pki/Discovery/viewdiscoveryaudit'; //No I18N
                getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
                            var colNamesList = ['DISCOVERYAUDIT ID',I18N.getMsg('js.discovery.hostname'),I18N.getMsg("js.discovery.type"),I18N.getMsg('js.discovery.invokedon'),I18N.getMsg('js.discovery.discoverystatus'),I18N.getMsg('js.table.search')]; //No I18N
                        var colModelList = [
                                {name: 'DISCOVERYAUDIT_ID', index: 'DISCOVERYAUDIT_ID',hidden:true},//No I18N
                                {name: 'Resource(s)', index: 'Resource(s)',formatter:'discoveryFormatter'},//No I18N
                                {name: 'Resource Type',index:'Resource Type'},//NO I18N
                                {name: 'Invoked_On', index: 'Invoked_On'}, //No I18N
                                {name: 'Discovery_Status', index: 'Discovery_Status',search:false}, //No I18N
                                { name: 'search',width:25,sortable: false,search:false}//NO I18N
                        ];
                        var defaultOptions={multiselect:false,rowNumNeeded:false,searchOption:true};//NO I18N
                        loadJQgridWithData("#DiscoveryAuditDetailsList", jsonData.discoveryAudit, colNamesList, colModelList, "", "#DiscoveryAuditListPager", "discoveryAudit",defaultOptions);//No I18N
		});
	},
        displayIndividualDiscoveryAudit:function(discoveryAudit_id)
        {
            var params='discoveryAudit_id='+discoveryAudit_id;//NO I18N
            getDiscoveryAuditStateHolder(params);
            autoReloadGrid(getDiscoveryAuditStateHolder,params,'DiscoveryAuditList');//No I18N
	},
        getDiscoveryTabList: function() {
            var selectedTab = App.SettingsCommonController.selectedTab;
            var availableTopViews= topview.Discovery;
        var ssh = false;
        var ssl = false;
        var ad = false;
        var ms=false,cs=false;
   	var isNotLin=false;
        var smtp = false;
        if(kmpStandAlone)
        {
            isNotLin = (window.isLinux.toLowerCase() != "linux");//No I18N
        }else{
            isNotLin = (isLinux_pmp != true);
        }
        if (selectedTab === "ssh") {ssh= true;} //No I18N
        else if (selectedTab === "ssl") {ssl= true;} //No I18N
        else if (selectedTab === "ad") {ad= true;} //No I18N
        else if (selectedTab === "ms") {ms= true;} //No I18N
        else if (selectedTab === "cs") {cs= true;} //No I18N
        else if (selectedTab === "smtp"){smtp=true;}//NO I18N
        var baseurl = window.apiclientUrl+"Discovery/"; //No I18N
        if(kmpStandAlone){
            baseurl = window.apiclientUrl+"Discovery/"; //No I18N
        }else{
            baseurl = "#/SSLCertificatesView/Discovery/"; //No I18N
        }
        var arr=new Array();
        var jsonObj =   {
	}
        if(!kmpStandAlone && !isNotLin){
            return null;
        }else{
        if ( kmpStandAlone && (availableTopViews.indexOf("Discover_SSH") > -1))
        {
            var object = {"Name": "SSH", "url": baseurl + "SSH", "title": I18N.getMsg("js.ssh.title"), "isSelected": ssh};//No I18N
            arr.push(object);
        }
        if (availableTopViews.indexOf("Discover_SSL") > -1)
        {
            object = {"Name": "SSL", "url": baseurl + "SSL", "title": I18N.getMsg("js.ssl.title"), "isSelected": ssl};//No I18N
            arr.push(object);
        }
        if(availableTopViews.indexOf("SMTP_Certificate")>-1)
        {
            object = {"Name": "SMTP", "url": baseurl + "SMTP", "title": I18N.getMsg("smtp.discovery.title"), "isSelected": smtp};//No I18N
            arr.push(object);
        }
        if (isNotLin || App.ApplicationController.demo)
        {
            if (availableTopViews.indexOf("AD_USER_Certificate") > -1)
            {
                object = {"Name": "Active Directory", "url": baseurl + "AD", "title": I18N.getMsg("js.ad.usercert"), "isSelected": ad};//No I18N
                arr.push(object);
            }
            if (availableTopViews.indexOf("MS_Certificate_Store") > -1)
            {
                object = {"Name": "MS Certificate Store", "url": baseurl + "certStore", "title": I18N.getMsg("js.ms.cert.store"), "isSelected": cs};//No I18N
                arr.push(object);
            }
        }
        }
        jsonObj.menuLinks = arr;
        informationTabList.setProperties(jsonObj);
        return informationTabList;
    }
});

function getDiscoveryAuditStateHolder(params,pgNumber,pgSel)
{
    var ajaxRequestUrl = '/api/pki/Discovery/viewdetaileddiscoveryaudit'; //No I18N
    getAjaxApiRequest(ajaxRequestUrl,params,function(jsonData){       
                                    var colNamesList = ['DISCOVERYID',I18N.getMsg('js.discovery.hostname'),I18N.getMsg('js.discovery.ipaddress'),I18N.getMsg('js.commonstr.status'),I18N.getMsg('js.commonstr.description'),I18N.getMsg('js.table.search')]; //No I18N
                                var restype=jsonData.discSuccessCount[0].resourceType;
                                if(restype!=="SSL Certificate" && restype!=="SSH Servers")
                                {
                                    colNamesList = ['DISCOVERYID',I18N.getMsg('js.commonstr.certificatename'),I18N.getMsg('js.discovery.ipaddress'),I18N.getMsg('js.commonstr.status'),I18N.getMsg('js.commonstr.description'),I18N.getMsg('js.table.search')]; //No I18N
                                }
                                var colModelList = [
                                        {name: 'DISCOVERYID', index: 'DISCOVERYID',hidden:true},//No I18N
                                        {name: 'HOSTNAME', index: 'HOSTNAME'},//No I18N
                                        {name: 'IPADDRESS', index: 'IPADDRESS'}, //No I18N
                                        {name: 'STATUS', index: 'STATUS',formatter:'progressStatusFormatter',search:false}, //No I18N
                                        {name: 'DESCRIPTION', index: 'DESCRIPTION'}, //No I18N
                                        { name: 'search',width:25,sortable: false,search:false}//NO I18N
                                ];
                                var defaultOptions={multiselect:false,rowNumNeeded:false,sortName:'HOSTNAME',searchOption:true};//NO I18N
                                isAutoRefresh=jsonData.autoRefresh;
                                App.DiscoveryDetailedAuditDiscoveryController.isDetailedAuditDiscoveryInprogress=jsonData.autoRefresh;
                                loadJQgridWithData("#DiscoveryAuditList", jsonData.detailedDiscoveryAudit, colNamesList, colModelList, "", "#DiscoveryAuditPager", "",defaultOptions);//No I18N
                                if(pgNumber!=undefined)
                                {
                                    $("#DiscoveryAuditList").trigger("reloadGrid",[{page:pgNumber}]);
                                }
                        });
	}

function getADUserCertificate()
{
    var ajaxRequestUrl = '/api/pki/Discovery/getADUserCertificates'; //No I18N
    getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){       
        var colNamesList = ['ManageID',I18N.getMsg('js.general.username'),I18N.getMsg('js.sslcertificate.domaincontroller'),I18N.getMsg('js.sslcertificate.domainname'),I18N.getMsg('js.general.creationtime'),I18N.getMsg('js.table.search')]; //No I18N
        var colModelList = [
                {name: 'ManageID', index: 'ManageID',hidden:true},//No I18N
                {name: 'UserName', index: 'UserName'},//No I18N
                {name: 'DomainController', index: 'DomainController'}, //No I18N
                {name: 'DomainName', index: 'DomainName'}, //No I18N
                {name: 'CreationTime', index: 'CreationTime',sorttype: 'datetime',datefmt: 'M d, Y H:i'}, //No I18N
                { name: 'search',width:25,sortable: false,search:false}//NO I18N
        ];
        var defaultOptions={multiselect:true,rowNumNeeded:false,sortName:'CreationTime',searchOption:true};//NO I18N
        loadJQgridWithData("#ADUserCertList", jsonData.CertVersion, colNamesList, colModelList, "", "#ADUserCertPager", "",defaultOptions);//No I18N
    });
}

function changeDomainType(){
    $("#domainDiscovery").hide();
    $("#adDetailsForm").hide();
    if($("#DomainType").val()==0)
    {
        $("#domainDiscovery").show()
    }
    else
    {
        $("#adDetailsForm").show()
        App.Settings.getDomains();
    }
    if(!kmpStandAlone)
    {
        $("#userimp_id").hide();
}
}

function selectWindowsDisType()
{
    if($("#windows_dis_type").val()=="cert_store")//NO I18N
    {
        $("#store_name").show();
        $("#CACertTypeDiv").hide();
    }
    else
    {
        $("#store_name").hide();
        $("#CACertTypeDiv").show();
    }
}

function disocoveryLSSelection(value)
{
    if(value==="landingserver")
    {
        var ajaxUrl = '/api/pki/landingserver/discoveryLServers';//NO I18N
        getAjaxApiRequest(ajaxUrl,"",function(jsonData){
            var list = jsonData.LSList;
            if(list.length>0)
            {
                for(var i=0;i<list.length;i++)
                {                    
                    var id = list.get(i).LSId;
                    var name = list.get(i).LSName;
                    var option = new Option(name,id);
                    $("#LSServer").append(option);
                }
            }
        });
    }
}

function DiscoveryLSselected()
        {
    if(document.getElementById("LSServer").value!=="-1")
    {
            var filename = $('#textfile').val();
            if(filename!=="")
            {
                checkForLocalhostinFile();
            }
        }
    }
