// $Id$
/* Settings Routes */
App.RequestListRoute = Ember.Route.extend({
    	model: function(params) {
            App.RequestCertController.selectedTab="req";//No I18N 
        },
	setupController: function(controller) {
            controller.set('content', App.Request.getSSLMgmtTabList());  //No I18N 
	},
	renderTemplate: function() {
            if(kmpStandAlone){
                this.render('RequestList',{into:"sslMgmt", outlet: 'sslmgmt'});//No I18N
            }
            else{
                localStorage.setItem("currentView","SSLMgmt/Request/List");	//NO I18N
                this.render('RequestList',{ outlet: 'keyInfo'});//No I18N
            }   
        }
});

App.LETSMgmtRoute = Ember.Route.extend({        
	model: function(params) {
            App.RequestCertController.selectedTab="account";//No I18N 
        },
	setupController: function(controller) {
            controller.set('content', App.Request.getLetsMgmtTabList());  //No I18N 
	},
	renderTemplate: function() {
                if (kmpStandAlone) {
                    this.render('letsMgmt', {into: 'application', outlet: 'details'});//No I18N
                } else {
                    localStorage.setItem("currentView", "LETSMgmt");	//NO I18N
                    this.render('letsMgmt', {outlet: 'keyInfo'});//No I18N
        } 
        } 
});

App.LETSMgmtDNSProviderRoute = Ember.Route.extend({
    beforeModel: function() {
            
        },
    model: function(){
        App.RequestCertController.selectedTab="dnsprovider";//No I18N 
    },
    setupController: function(controller) {
        controller.set('content', App.Request.getLetsMgmtTabList());  //No I18N 
    },
    renderTemplate: function() {
        if(kmpStandAlone){
                this.render('DNSProvider',{into: 'letsMgmt', outlet: 'letsmgmt'});//No I18N
            }
            else{
                localStorage.setItem("currentView","LETSMgmt/LETSAccount");	//NO I18N
                this.render('DNSProvider',{ outlet: 'letsmgmt'});//No I18N
            }   
    } 
});

App.LETSMgmtLETSAccountRoute = Ember.Route.extend({
    beforeModel: function() {
            if(window.userRole!=="Administrator")
            {
                if(App.RequestCertController.domain!=="")
                {
                    var domain = App.RequestCertController.domain;
                    this.transitionTo('LETSMgmt.LETSDeployFilter',domain);//No I18N
                }
                else
                {
                    this.transitionTo('LETSMgmt.LETSDeploy');//No I18N
                }
            }
        },
    model: function(){
        App.RequestCertController.selectedTab="account";//No I18N 
    },
    setupController: function(controller) {
        controller.set('content', App.Request.getLetsMgmtTabList());  //No I18N 
    },
    renderTemplate: function() {
        if(kmpStandAlone){
                this.render('LetsEncrypt',{into: 'letsMgmt', outlet: 'letsmgmt'});//No I18N
            }
            else{
                localStorage.setItem("currentView","LETSMgmt/LETSAccount");	//NO I18N
                this.render('LetsEncrypt',{ outlet: 'letsmgmt'});//No I18N
            }   
    } 
});

App.LETSMgmtLETSDeployRoute = Ember.Route.extend({
    model: function(params){
        App.RequestCertController.selectedTab="deploy";//No I18N 
        App.RequestCertController.domain="all";//NO I18N
    },
    setupController: function(controller) {
        controller.set('content', App.Request.getLetsMgmtTabList());  //No I18N 
    },
    renderTemplate: function() {
         if(kmpStandAlone){
                this.render('LetsEncryptDeployMapping',{into: 'letsMgmt', outlet: 'letsmgmt'});//No I18N
            }
            else{
                localStorage.setItem("currentView","LETSMgmt/LETSDeploy");	//NO I18N
                this.render('LetsEncryptDeployMapping',{ outlet: 'letsmgmt'});//No I18N
            }  
    } 
});

App.LETSMgmtLETSDeployFilterRoute = Ember.Route.extend({
    model: function(params){
        App.RequestCertController.selectedTab="deploy";//No I18N 
        App.RequestCertController.domain=params.domain;
    },
    setupController: function(controller) {
        controller.set('content', App.Request.getLetsMgmtTabList());  //No I18N 
    },
    renderTemplate: function() {this.render('LetsEncryptDeployMapping',{into: 'letsMgmt', outlet: 'letsmgmt'});} //No I18N
});

App.LETSMgmtWAgentsRoute = Ember.Route.extend({
    model: function(params){
       App.RequestCertController.selectedTab="agents";//No I18N 
    },
    setupController: function(controller) {
        controller.set('content', App.Request.getLetsMgmtTabList());  //No I18N 
    },
    renderTemplate: function() {
        if (kmpStandAlone) {
            this.render('WAgents', {into: 'letsMgmt', outlet: 'letsmgmt'});//No I18N
        } else {
            localStorage.setItem("currentView", "LETSMgmt/WAgents");	//NO I18N
            this.render('WAgents', {outlet: 'letsmgmt'});//No I18N
        }  
    } 
});

App.LETSMgmtNewRegistrationRoute = Ember.Route.extend({       
	model: function(params) {
            App.RequestCertController.selectedTab="account";//No I18N 
	},
	setupController: function(controller) {
            controller.set('content', App.Request.getLetsMgmtTabList());  //No I18N 
	},
	renderTemplate: function() {
            if (kmpStandAlone) {
                this.render('NewRegistration',{into: 'letsMgmt',outlet: 'letsmgmt'});//No I18N
            } else {
                localStorage.setItem("currentView", "LETSMgmt/NewRegistration");	//NO I18N
                this.render('NewRegistration', {outlet: 'letsmgmt'});//No I18N
            }  
        }
});

App.LETSMgmtAddNewAccountRoute = Ember.Route.extend({
        model: function(params) {
            App.RequestCertController.selectedTab="account";//No I18N 
	},
	setupController: function(controller) {
            controller.set('content', App.Request.getLetsMgmtTabList());  //No I18N 
	},
	renderTemplate: function() {
            if (kmpStandAlone) {
                this.render('AddNewAccount',{into: 'letsMgmt',outlet: 'letsmgmt'});//No I18N
            } else {
                localStorage.setItem("currentView", "LETSMgmt/AddNewAccount");	//NO I18N
                this.render('AddNewAccount', {outlet: 'letsmgmt'});//No I18N
            }  
        }
});

App.ImportSignedCertificateView = Ember.View.extend({
    templateName: 'importSignedCertificate',//No I18N
        didInsertElement: function(){
            $(".modal-title").text(I18N.getMsg('js.csr.import.certificate'));//NO I18N
        }
});

App.ImportSignedCertificateController = Ember.ObjectController.extend({
    actions: {
        close: function() {
            return this.send('closeModal');//NO I18N
        },
        importSignedCertificate: function() {
            var params="?csr_id="+App.RequestCertController.newCertId;//NO I18N
            var fileData = new FormData();
            var file1 = document.getElementById("uploadCertFile").files[0];
            fileData.append("File", file1);//NO I18N
            fileData.append("pmpcp",Get_Cookie('pmpcc'));//No I18N
            var ajaxRequestUrl = '/api/pki/request/importSignedCertificate'+params; //No I18N
            var app=this;
            $.ajax({
                url: ajaxRequestUrl,
                type: 'POST',//No I18N
                dataType: 'json',//No I18N
                data: fileData,
                cache:false,
                processData:false,
                contentType:false,
                success: function(jsonData) {
                    if(jsonData.Status==="Success")
                    {
                       messageNotification("messageNotifySuccess",jsonData.Message);//No I18N
                       app.send("close");//No I18N 
                    }
                    else
                    {
                        messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
                    }
                }
            });                        
        }
    }
});

App.RequestDetailsView = Ember.View.extend({
    templateName: 'RequestDetails',//No I18N
        didInsertElement: function(){
            $(".modal-title").text(I18N.getMsg('js.requestdetails'));//NO I18N
            $(".modal-body").css({"max-height":"600px"});
            $(".modal-dialog").css({"width":"600px"});
            $(".modal-body").css({"overflow-y":"auto"});
//            var myGrid = $('#PKIRequestList'),
//            selectedRowId = myGrid.jqGrid('getGridParam', 'selrow'),//NO I18N
//            cellValue = myGrid.jqGrid('getCell', selectedRowId, 'REQUESTID');//NO I18N
            App.Request.getRequestDetails(App.RequestCertController.req_id);
            //$('#CSR_CONTENT').slimscroll({railVisible: true,railBorderRadius: 0,railOpacity: 0.1});
            $('#CSR_CONTENT').width("400");
        }    
});

App.RequestDetailsController = Ember.ObjectController.extend({
    actions: {
        close: function() {
          return this.send('closeModal');//NO I18N
        }        
    }
});

App.SignCertificateView = Ember.View.extend({
    templateName: 'SignCertificate',//No I18N
        didInsertElement: function(){
            var grid = jQuery("#CreatedCertList"); //No I18N
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N
            if(selRowIds == undefined || selRowIds.length != 1)
            {
                var controller = this.get('controller');
                controller.send('closeModal');//NO I18N
                showAlert(I18N.getMsg('js.select.onecsr'));//No I18N
                return;
            }
            if(((isLinux_pmp==null && window.isLinux.toLowerCase()==="linux")||(window.isLinux==null && isLinux_pmp===true )) && !App.ApplicationController.demo)
            {
                $("#sign_type_div").hide();
                $("#sign_type").val("root");//NO I18N
                changeSigningType();
            }
            var encKeyLoc=[];
            encKeyLoc.push("User");
            encKeyLoc.push("EFS");
            encKeyLoc.push("Administrator");
            encKeyLoc.push("EFSRecovery");
            encKeyLoc.push("WebServer");
            encKeyLoc.push("SubCA");
            $(".modal-title").text(I18N.getMsg("js.ssl.sign.certificate"));//NO I18N
            $("#templateNames").autocomplete({
                source: encKeyLoc, minLength: 0
            }).focus(function () {
                $("#templateNames").data("ui-autocomplete").search($("#templateNames").val());
            }).data("ui-autocomplete")._renderItem = function (ul,encKeyLoc) {//NO I18N
                var $el = $("<li>");
                $el.append("<a>" + encKeyLoc.value + "</a>");
                if(!kmpStandAlone){
                    var len=$("#templateNames").css( "width" );//NO I18N
                    $el.css( "width", len );//NO I18N
                }
                return $el.appendTo(ul);
            }
            getMSCertStoreServer(true);
        }    
});

function getMSCertStoreServer(isMSCA)
{
    var ajaxRequestUrl = '/api/pki/request/getMSCertStoreServer'; //No I18N
    var data="isMSCA="+isMSCA;//No I18N
    var encKeyLoc=[];
    getAjaxApiRequest(ajaxRequestUrl, data, function (jsonData) {
        var a;
        if(jsonData.Servers!==undefined)
        {
            for (a = 0; a < jsonData.Servers.length; a++)
            {
                var temp = jsonData.Servers[a].trim();
                encKeyLoc.push(temp);
            }
            $(function () {
             $("#machineName").autocomplete({
                    source: encKeyLoc, minLength: 0
                }).focus(function () {
                    $("#machineName").data("ui-autocomplete").search($("#machineName").val());
                }).data("ui-autocomplete")._renderItem = function (ul, encKeyLoc) {//NO I18N
                    var $el = $("<li>");//NO I18N
                    $el.append("<a href='javascript:getMSCertStoreInfo("+isMSCA+")'>" + encKeyLoc.value + "</a>");//NO I18N
                    if(!kmpStandAlone){
                        var len = $("#machineName").css( "width" );//NO I18N
                        $el.css("width", len);//NO I18N
                    }
                    return $el.appendTo(ul);
                };
            });    
        }
    });
}

function getMSCertStoreInfo(isMSCA)
{
    var ajaxRequestUrl = '/api/pki/request/getMSCertStoreInfo'; //No I18N
    var serverName=$("#machineName").val();
    var data="isMSCA="+isMSCA+"&serverName="+serverName;//No I18N
    getAjaxApiRequest(ajaxRequestUrl, data, function (jsonData) {
        if(jsonData.CANAME!=undefined && jsonData.CANAME!=null && $("#caName")!=undefined)
        {
            $("#caName").val(jsonData.CANAME);
        }
        if(jsonData.TEMPLATENAME!=undefined && jsonData.TEMPLATENAME!=null && $("#templateNames")!=undefined)
        {
            $("#templateNames").val(jsonData.TEMPLATENAME);
        }
        if(jsonData.USERNAME!=undefined && jsonData.USERNAME!=null && $("#userName")!=undefined)
        {
            $("#userName").val(jsonData.USERNAME);
        }
        if(jsonData.PASSWORD!=undefined && jsonData.PASSWORD!=null && $("#password")!=undefined)
        {
            document.getElementById("password").placeholder=jsonData.PASSWORD;
            App.DiscoveryDataController.isPasswordNeeded=false;
        }
        if(jsonData.STORENAME!=undefined && jsonData.STORENAME!=null && $("#storeName")!=undefined)
        {
            $("#storeName").val(jsonData.STORENAME);
        }
            if(jsonData.TemplateList!=undefined)
            {
                var templateList=jsonData.TemplateList;
                $("#templateList").text("");//No I18N
                for(var i=0;i<templateList.length;i++)
                {
                    var value="";//No I18N
                    var templateDetails=templateList[i];
                    if(templateDetails.msPKI_Cert_Template_OID!=undefined)
                    {
                        value=templateDetails.msPKI_Cert_Template_OID;
                    }
                    else
                    {
                        value=templateDetails.distinguishedName;
                    }
                    if(templateDetails.displayName.trim()!="")
                    {
                        $("#templateList").append("<option value='"+value+"'>"+templateDetails.displayName+"</option>");//No I18N
                    }
                }
                $("#templateListDiv").show();
                $("#template_name_div").hide();
            }
    });
}

App.SignCertificateController = Ember.ObjectController.extend({
    actions: {
        close: function() {
            return this.send('closeModal');//NO I18N
        },
        sign: function() {
            var params="";
            var serverName=$("#machineName").val();
            var caName=$("#caName").val();
            var templateName=$("#templateNames").val();
            var sign_type=$("#sign_type").val();
            var isInter=document.getElementById("isIntermediateCert").checked;
            if(sign_type==="msca")
            {
            if(serverName=="" || serverName==null)
            {
                showAlert(I18N.getMsg('js.serverSettings.enterServerName')); //No I18N
                return;
            }
            if(caName=="" || caName==null)
            {
                showAlert(I18N.getMsg('js.sign.enterca')); //No I18N
                return;
            }
            if(templateName=="" || templateName==null)
            {
                showAlert(I18N.getMsg('js.sign.entercertTemplate')); //No I18N
                return;
            }
            params="serverName="+serverName+"&caName="+caName+"&templateName="+templateName;//NO I18N
            }
            else
            {
                var VALIDITY=$("#validity").val().trim();
                if(!validateNumberVal(VALIDITY)){
                    showAlert(I18N.getMsg('js.commonstr.enterValidDays'));//NO I18N
                    return;   
                }
                params="Validity="+VALIDITY;//No I18N
                var root_cert=$("#root_cert").val();
                if (root_cert === undefined || root_cert === "" || root_cert === "message")
                {
                    showAlert(I18N.getMsg('js.select.root.certificate'));//NO I18N
                    return;
                }
                if(root_cert!==undefined && root_cert!=="")
                {
                    params+="&root_cert="+root_cert;//No I18N
                }
            }
            var grid = jQuery("#CreatedCertList"); //No I18N
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            if(selRowIds == undefined || selRowIds.length != 1) 
            {
                showAlert(I18N.getMsg('js.select.onecsr')); //No I18N
                return;
            }
            $.each(selRowIds, function()
            {
                var id = this;
                var csr_id = grid.jqGrid('getCell', id, 'NEWCERTID'); //No I18N
                params+="&newCertId="+csr_id;//NO I18N
            });
            params+="&sign_type="+sign_type+"&isIntermediate="+isInter;//No I18N
            var app=this;
            var ajaxRequestUrl = '/api/pki/request/signCertificate'; //No I18N
            getAjaxApiRequest(ajaxRequestUrl,params,function(jsonData){
                if(jsonData.Status=="Success")
                {
                    messageNotification("messageNotifySuccess",jsonData.Message);//No I18N
                    app.send('closeModal');//NO I18N
                    redirectUrl("SSLMgmt/SSL");//NO I18N
                }
                else
                {
                    messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
                }
            });            
        }
    }
});

App.RequestOpenRoute = Ember.Route.extend({
    	model: function(params) {
            App.ApplicationController.userName=window.userName;
            App.RequestCertController.selectedTab="req";//No I18N 
        },
	setupController: function(controller) {
                App.RequestCertController.flag=true;
                controller.set('content', App.Request.getSSLMgmtTabList());  //No I18N 
	},
	renderTemplate: function() {
            if(kmpStandAlone){
                this.render('RequestOpen',{into:"sslMgmt", outlet: 'sslmgmt'});//No I18N
            }
            else{
                localStorage.setItem("currentView","SSLMgmt/Request/Open");	//NO I18N
                this.render('RequestOpen',{ outlet: 'keyInfo'});//No I18N
            }   
        }
});

App.RequestEditRoute = Ember.Route.extend({
    	model: function(params) {
            App.RequestCertController.selectedTab="req";//No I18N 
            App.RequestCertController.req_id=params.req_id;
        },
	setupController: function(controller) {
            App.RequestCertController.flag=false;
            controller.set('content', App.Request.getSSLMgmtTabList());  //No I18N 
	},
	renderTemplate: function() {
            if(kmpStandAlone){
                this.render('RequestOpen',{into:"sslMgmt", outlet: 'sslmgmt'});//No I18N
            }
            else{
                localStorage.setItem("currentView","SSLMgmt/Request/Edit/"+App.RequestCertController.req_id);	//NO I18N                
                this.render('RequestOpen',{ outlet: 'keyInfo'});//No I18N
            }   
        }
});

/*App.RequestClosedRoute = Ember.Route.extend({
    	model: function(params) {
            App.RequestCertController.selectedTab="req";//No I18N 
            App.RequestCertController.req_id=params.req_id;
        },
	setupController: function(controller) {
            controller.set('content', App.Request.getSSLMgmtTabList());  //No I18N 
            controller.set('temp',App.Request.getRequestDetails(App.RequestCertController.req_id) );  //No I18N
	},
	renderTemplate: function() {this.render('RequestClosed',{into: 'sslMgmt', outlet: 'sslmgmt'});} //No I18N
});
*/

App.RequestClosedView = Ember.View.extend({
    templateName: 'RequestClosed',//No I18N
    didInsertElement: function(){
            $(".modal-title").text('Close Request');//NO I18N
            $('.modal-dialog').css({"width":"660px"});
//            var myGrid = $('#PKIRequestList'),
//            selectedRowId = myGrid.jqGrid('getGridParam', 'selrow'),//NO I18N
//            req_id = myGrid.jqGrid('getCell', selectedRowId, 'REQUESTID');//NO I18N
//            App.RequestCertController.req_id=req_id;
            var ajaxRequestUrl = '/api/pki/request/getrequest?REQ_ID='+App.RequestCertController.req_id; //No I18N
            getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
                $('#annotation').val(jsonData.NOTES);
                $('#domain_Name').text(jsonData.INC_DOMAIN);
                $('#mailID').val(jsonData.MAIL_ID2);
                if(jsonData.REQUEST_TYPE=='New_Domain')
                {
                    $("#req_type").text(I18N.getMsg("js.sslcert.request.newCertificate"));//No I18N
                }
                else
                {
                    $("#req_type").text(I18N.getMsg("js.sslcert.request.domainAddition"));//No I18N
                }
            });
    }
});

App.RequestClosedController = Ember.ObjectController.extend({
    actions: {
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        requestSubmit: function()
	{
            var NOTES=document.getElementById('annotation').value;//No I18N
            var req_id=App.RequestCertController.req_id;
            var fileData = new FormData();
            var browse="";
            var textfield="";
            var FILE_CONTENT=""; 
            var param="";
            if(document.getElementById("filebased").checked===true)
            {
                if ($('#filename').val() == '') {
                    showAlert(I18N.getMsg('js.file.selectaFile'));//NO I18N
                    return;
                }
                    var file = document.getElementById("uploadFile").files[0];
                    fileData.append("File", file);//NO I18N
                param=param+'&TYPE=CERTFILE';//NO I18N
            }
            else if(document.getElementById("keystorebased").checked===true)
            {
                if ($('#textfile').val() == '') {
                    showAlert(I18N.getMsg('js.file.selectaFile'));//NO I18N
                    return;
                }
                if ($('#keyStorePassword').val() == '') {
                    showAlert(I18N.getMsg('js.sshkey.enterKeyStorePassword'));//NO I18N
                    return;
                }
                var file1 = document.getElementById("uploadKeyStoreFile").files[0];
                fileData.append("File", file1);//NO I18N
                browse=$('#uploadKeyStoreFile');
                textfield=document.getElementById("textfile");
                param=param+'&PASSWORD='+encodeURIComponent(document.getElementById("keyStorePassword").value)+'&TYPE=KEYSTORE';//NO I18N
            }
            var mailId=document.getElementById("mailID").value;
            var mail=mailId.split(/,|;/);
            for (var i = 0; i < mail.length; i++) {
                if (!validateEmail(mail[i])) {
                    showAlert(I18N.getMsg('js.email.enteraValidEmailAddress')); //No I18N
                    return;
                }
            }
            var app=this;
            var ajaxRequestUrl = '/api/pki/request/updateRequest?NOTES='+NOTES+'&MAIL_ID='+mailId+'&REQ_ID='+req_id+param;//NO I18N
            fileData.append("pmpcp",Get_Cookie('pmpcc'));//No I18N
            getAjaxApiRequestForFile(ajaxRequestUrl,fileData,browse,textfield,false,function(jsonData){
                    if(jsonData.Status==="Success")//NO I18N
                    {
                        messageNotification("messageNotifySuccess",I18N.getMsg("js.sslcert.request.requestClosedSuccessfully"));//No I18N
                        App.Request.getRequestList();
                        app.send('closeModal');//NO I18N
                    }
                    else
                    {
                        if(jsonData.Message === undefined)
                        {
                        messageNotification("messageNotifyFailure","Failed to Close request ..");//No I18N
                    }
                        else{
                            messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
                }
                    }
            });
        }
        
    }
});

App.SSLMgmtCreateCertificateRoute = Ember.Route.extend({
    	model: function(params) {
            App.RequestCertController.selectedTab="crts";//No I18N 
        },
	setupController: function(controller) {
            controller.set('content', App.Request.getSSLMgmtTabList());  //No I18N 
	},
	renderTemplate: function() {
            if(kmpStandAlone){
                this.render('CreateForm',{into:"sslMgmt", outlet: 'sslmgmt'});//No I18N
            }
            else{
                localStorage.setItem("currentView","SSLMgmt/CreateCertificate");	//NO I18N
                this.render('CreateForm',{ outlet: 'keyInfo'});//No I18N
            }   
        } 
});

App.SSLMgmtLetsEncryptRequestListRoute = Ember.Route.extend({
    	model: function(params) {
            App.RequestCertController.selectedTab="lets";//No I18N 
        },
	setupController: function(controller) {
            controller.set('content', App.Request.getSSLMgmtTabList());  //No I18N 
	},
    renderTemplate: function () {
        if (kmpStandAlone) {
            this.render('LetsEncryptRequestList', {into: 'sslMgmt', outlet: 'sslmgmt'});
        } else {
            localStorage.setItem("currentView", "SSLMgmt/LetsEncryptRequestList");	//NO I18N
            this.render('LetsEncryptRequestList', {outlet: 'keyInfo'});//No I18N
        }
    } 
});

App.SSLMgmtGoDaddyRoute = Ember.Route.extend({
    	model: function(params) {
            App.RequestCertController.selectedTab="godaddy";//No I18N 
        },
	setupController: function(controller) {
            controller.set('content', App.Request.getSSLMgmtTabList());  //No I18N 
	},
    renderTemplate: function () {
        if (kmpStandAlone) {
            this.render('GoDaddy', {into: 'sslMgmt', outlet: 'sslmgmt'});
        } else {
            localStorage.setItem("currentView", "SSLMgmt/godaddy");	//NO I18N
            this.render('GoDaddy', {outlet: 'keyInfo'});//No I18N
        }
    } 
});

App.SSLMgmtGoDaddyOrderRoute = Ember.Route.extend({
    	model: function(params) {
            App.RequestCertController.selectedTab="godaddy";//No I18N 
        },
	setupController: function(controller) {
            controller.set('content', App.Request.getSSLMgmtTabList());  //No I18N 
	},
    renderTemplate: function () {
        if (kmpStandAlone) {
            this.render('GoDaddyOrder', {into: 'sslMgmt', outlet: 'sslmgmt'});
        } else {
            localStorage.setItem("currentView", "SSLMgmt/godaddyOrder");	//NO I18N
            this.render('GoDaddyOrder', {outlet: 'keyInfo'});//No I18N
        }
    } 
});

App.SSLMgmtGoDaddyOrderDetailsRoute = Ember.Route.extend({
    	model: function(params) {
            App.RequestCertController.selectedTab="godaddy";//No I18N 
            App.RequestCertController.order_id=params.id;
        },
	setupController: function(controller) {
            controller.set('content', App.Request.getSSLMgmtTabList());  //No I18N 
	},
    renderTemplate: function () {
        if (kmpStandAlone) {
            this.render('GoDaddyOrderDetails', {into: 'sslMgmt', outlet: 'sslmgmt'});
        } else {
            localStorage.setItem("currentView", "SSLMgmt/godaddyOrderDetails/"+App.RequestCertController.order_id);	//NO I18N
            this.render('GoDaddyOrderDetails', {outlet: 'keyInfo'});//No I18N
        }
    } 
});

App.SSLMgmtGoDaddyHistoryRoute = Ember.Route.extend({
    	model: function(params) {
            App.RequestCertController.selectedTab="godaddy";//No I18N 
            App.RequestCertController.order_id=params.id;
        },
	setupController: function(controller) {
            controller.set('content', App.Request.getSSLMgmtTabList());  //No I18N 
	},
    renderTemplate: function () {
        if (kmpStandAlone) {
            this.render('GoDaddyHistory', {into: 'sslMgmt', outlet: 'sslmgmt'});
        } else {
            localStorage.setItem("currentView", "SSLMgmt/godaddyHistory/"+App.RequestCertController.order_id);	//NO I18N
            this.render('GoDaddyHistory', {outlet: 'keyInfo'});//No I18N
        }
    } 
});

App.SSLMgmtLetsEncryptRequestRoute = Ember.Route.extend({
    	model: function(params) {
            App.RequestCertController.selectedTab="lets";//No I18N 
        },
	setupController: function(controller) {
            controller.set('content', App.Request.getSSLMgmtTabList());  //No I18N 
	},
	renderTemplate: function() {
            if (kmpStandAlone) {
            this.render('LetsEncryptRequest',{into: 'sslMgmt', outlet: 'sslmgmt'}); //No I18N
        } else {
            localStorage.setItem("currentView", "SSLMgmt/LetsEncryptRequest");	//NO I18N
            selectKMPTab("ssl_letsencrypt");//NO I18N
            this.render('LetsEncryptRequest', {outlet: 'keyInfo'});//No I18N
        }
}
});

App.SSLMgmtLetsEncryptChallengesRoute = Ember.Route.extend({
   model: function(params) {
        App.RequestCertController.selectedTab="lets";//No I18N 
        App.RequestCertController.req_id=params.req_id;
    },
    setupController: function(controller) {
        controller.set('content', App.Request.getSSLMgmtTabList());  //No I18N 
    },
    renderTemplate: function() {
        if (kmpStandAlone) {
            this.render('LetsEncryptChallenges',{into: 'sslMgmt', outlet: 'sslmgmt'}); //No I18N
        } else {
            localStorage.setItem("currentView", "SSLMgmt/LetsEncryptChallenges");	//NO I18N
            this.render('LetsEncryptChallenges', {outlet: 'keyInfo'});//No I18N
        }
    }
});

App.SSLMgmtLetsEncryptRequestHistoryRoute = Ember.Route.extend({
    model: function(params) {
        App.RequestCertController.selectedTab="lets";//No I18N 
        App.RequestCertController.req_id=params.req_id;
    },
    setupController: function(controller) {
        controller.set('content', App.Request.getSSLMgmtTabList());  //No I18N 
    },
    renderTemplate: function() {
        if(kmpStandAlone){
                this.render('LetsEncryptRequestHistory',{into: 'sslMgmt', outlet: 'sslmgmt'}); //No I18N
        }
        else{
            localStorage.setItem("currentView", "SSLMgmt/letsHistory");	//NO I18N
            //selectKMPTab("ssl_letsencrypt");//NO I18N
            this.render('LetsEncryptRequestHistory', {outlet: 'keyInfo'});//No I18N
        }  
    }
        
});

App.SSLMgmtSSLRoute = Ember.Route.extend({
    	model: function(params) {
            App.RequestCertController.selectedTab="crts";//No I18N 
        },
	setupController: function(controller) {
            controller.set('content', App.Request.getSSLMgmtTabList());  //No I18N 
            localStorage.setItem("prevViewName",I18N.getMsg("js.sslmgmt.certificates"));//No I18N
	},
	renderTemplate: function() {
            if(kmpStandAlone){
                this.render('InventorySSLResources',{into:"sslMgmt", outlet: 'sslmgmt'});//No I18N
            }
            else{
                if(localStorage.getItem("homeTab")!="PassTrixQuickView")
                {
                   localStorage.setItem("currentView","SSLMgmt/SSL");	//NO I18N
                    App.SettingsCommonController.set("pmpDashHideKeyOptions",true);//No I18N
                    this.render('InventorySSLResources',{ outlet: 'keyInfo'});//No I18N
                }   
                else
                {
                    App.SettingsCommonController.set("pmpDashHideKeyOptions",false);//No I18N
                    this.render('InventorySSLResources',{ outlet: 'kmpdashboard'});//No I18N
                }
            }   
        }
});

App.SSLMgmtCreateCsrRoute = Ember.Route.extend({
    	model: function(params) {
            App.RequestCertController.selectedTab="crt";//No I18N 
        },
	setupController: function(controller) {
            controller.set('content', App.Request.getSSLMgmtTabList());  //No I18N 
	},
	renderTemplate: function() {            
            if(kmpStandAlone){
                this.render({into:"sslMgmt", outlet: 'sslmgmt'});//No I18N
            }
            else{
                localStorage.setItem("currentView","SSLMgmt/CreateCsr");	//NO I18N
                this.render({ outlet: 'keyInfo'});//No I18N
            }   
        } 
});

App.SSLMgmtCreateCertificateListRoute = Ember.Route.extend({
    	model: function(params) {
            App.RequestCertController.selectedTab="crt";//No I18N 
            App.EncryptionKeysCommonController.isCallFromEncKey=false;
        },
	setupController: function(controller) {
            controller.set('content', App.Request.getSSLMgmtTabList());  //No I18N 
	},
	renderTemplate: function() {
            if(kmpStandAlone){
                this.render('CreatedCertList',{into:"sslMgmt", outlet: 'sslmgmt'});//No I18N
            }
            else{
                localStorage.setItem("currentView","SSLMgmt/CreateCertificateList");	//NO I18N
                selectKMPTab("ssl_csr");//NO I18N
                this.render('CreatedCertList',{ outlet: 'keyInfo'});//No I18N
            }   
        }
});

App.WildCardCertDeploymentView = Ember.View.extend({
    templateName: 'CertDeployment',//No I18N
        didInsertElement: function(){
            $(document).on("click",function(event){
                var ele = event.target;
                if(($('#certDeployHelp').attr('aria-describedby') && ($(ele).parents('.popover').length == 0)) || (ele.id == "popovercloseid")){
                  $('.certDeplyClass').popover('destroy');
               } 
            });
            $(".modal-title").text(I18N.getMsg("js.cert.deployment"));//NO I18N
            var widpadHeight=$(".widpad").height()-60; 
            $(".modal-body").css({"max-height":widpadHeight+"px"});
            $(".modal-body").css({"overflow-y":"auto"});
            $("#dep_type").hide();
            var myGrid = $('#wildcardList');
            var selRowIds = myGrid.jqGrid('getGridParam','selarrrow'); //No I18N 
            $.each(selRowIds, function()
            {
                var id = this;
                var serverName = myGrid.jqGrid('getCell', id, 'DomainName'); //No I18N
                $("#serverName").val(serverName);
                $("#serverName").prop('disabled',true);
            });
            
            var ajaxRequestUrl = '/api/pki/request/isKeystoreAvailable';//NO I18N
            var params="cert_id="+App.InventoryListDetailsController.cert_id;//NO I18N
            App.RequestCertController.cert_type=true;
            getAjaxApiRequest(ajaxRequestUrl,params,function(jsonData){
                if(jsonData.isKeystoreAvailable==false)
                {
                    $("#cert_type").hide();
                    App.RequestCertController.cert_type=false;
                    App.RequestCertController.cert_names=jsonData.cNames;
                    $("#server_type option[value='IIS']").remove();
                }    
            });

            //$("#dep_file_name").hide();
            
            var ajaxRequestUrl = '/api/pki/request/isKeystoreAvailable';//NO I18N
            var params="cert_id="+App.InventoryListDetailsController.cert_id;//NO I18N
            getServerCredentialsForDeploment();
             if(((isLinux_pmp==null && window.isLinux.toLowerCase()==="linux")||(window.isLinux==null && isLinux_pmp===true ))&& !App.ApplicationController.demo)
            {
                $("#sel_osType").hide();
                document.getElementById("server_type").value="Linux";//NO I18N
                selectOsType();
            }
            
            //To change button to credential save
            $("#depCert").hide();
            $("#saveDepCred").show();
        }    
});

App.WildCardCertDeploymentController = Ember.ObjectController.extend({
    actions: {
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        saveCredential: function()
        {
            var data = {};
            data.CERTID = App.InventoryListDetailsController.cert_id;
            var serverName=$("#serverName").val();
            var userName=$("#userName").val();
            var pwd=$("#pwd").val();
            var path=$("#path").val();
            if(serverName=="")
            {
                showAlert(I18N.getMsg('js.radius.validserver')); //No I18N
                return;
            }
            if(userName=="" || pwd=="")
            {
                showAlert(I18N.getMsg('js.resourcecredential.invalidusernameorpassword')); //No I18N
                return;
            }
            if(path=="" && document.getElementById("server_type").value!="MSStore" && document.getElementById("server_type").value!="IIS")
            {
                showAlert(I18N.getMsg('js.editpath.validpath')); //No I18N
                return;
            }
            data.serverName=serverName;
            data.userName=userName;
            data.pwd=pwd;
            data.path=path;
            data.dep_type="single";//No I18N

            data.isWindows=true;
            data.serverType=document.getElementById("server_type").value;
            if(document.getElementById("server_type").value=="Linux"){
                if($("#port").val()=="" && document.getElementById("dep_single").checked)
                {
                    showAlert(I18N.getMsg('js.port.specifyaValidPort')); //No I18N
                    return;
                }
                data.port=$("#port").val();
                data.isWindows=false;
            }
            data.isCertificate=document.getElementById("cert").checked;
            data.isStore=document.getElementById("store").checked;
            if(!(data.isStore || data.isCertificate))
            {
                showAlert(I18N.getMsg("js.deploy.cert.type"));//No I18N
                return;
            }
            if(data.dep_type!="multiple")
            {
                if(data.isCertificate)
                {
                    data.certFile=$("#cert_file").val();
                }
                if(data.isStore)
                {
                    data.storeFile=$("#store_file").val();
                }
            }
            
            var ajaxRequestUrl = '/api/pki/request/saveDeploymentCredential';//NO I18N
            data.pmpcp=Get_Cookie('pmpcc');//NO I18N
            var model=this;
            getAjaxApiRequest(ajaxRequestUrl,data,function(jsonData){
                if(jsonData.Status==="Success")
                {
                    model.send('closeModal');//NO I18N
                    messageNotification("messageNotifySuccess",I18N.getMsg(jsonData.Message));//No I18N
                    App.Inventory.getMultipleInstalledServers();
                }
                else
                {
                    messageNotification("messageNotifyFailure",I18N.getMsg(jsonData.Message));//No I18N
                }
            });
        }
    }
});


App.CertDeploymentView = Ember.View.extend({
    templateName: 'CertDeployment',//No I18N
        didInsertElement: function(){
            $(document).on("click",function(event){
                var ele = event.target;
                if(($('#certDeployHelp').attr('aria-describedby') && ($(ele).parents('.popover').length == 0)) || (ele.id == "popovercloseid")){
                  $('.certDeplyClass').popover('destroy');
               } 
            });
            $(".modal-title").text(I18N.getMsg("js.cert.deployment"));//NO I18N
            var widpadHeight=$(".widpad").height()-60; 
            $(".modal-dialog").width("550");//NO I18N
            $(".modal-body").css({"max-height":widpadHeight+"px"});
            $(".modal-body").css({"overflow-y":"auto"});
            var myGrid = $('#PKIInventoryList');
            var selRowIds = myGrid.jqGrid('getGridParam','selarrrow'); //No I18N 
            if(selRowIds == undefined || selRowIds.length == 0) {
                var controller = this.get('controller');
                controller.send('closeModal');//NO I18N
                showAlert(I18N.getMsg('js.resource.selectAtleastOneCertificate')); //No I18N
                return;
            }
            var cert_ids="";
            $.each(selRowIds, function()
            {
                var id = this;
                var res_id = myGrid.jqGrid('getCell', id, 'ResourceID'); //No I18N
                if(cert_ids!=="")
                {
                    cert_ids=cert_ids+","+res_id;//No I18N
            }    
            else
            {
                    cert_ids=res_id;
                }
                });
            if(selRowIds.length != 1) {
                $("#dep_file_name").hide();
            }    
                var ajaxRequestUrl = '/api/pki/request/isKeystoreAvailable';//NO I18N
            var params="cert_id="+cert_ids;//NO I18N
                App.RequestCertController.cert_type=true;
            App.RequestCertController.cert_names="";
                getAjaxApiRequest(ajaxRequestUrl,params,function(jsonData){
                    if(jsonData.isKeystoreAvailable==false)
                    {
                    if(selRowIds.length == 1)
                    {
                        $("#cert_type").hide();
                    }
                        App.RequestCertController.cert_type=false;
                    App.RequestCertController.cert_names=jsonData.cNames;
                    }    
                });
            if(((isLinux_pmp==null && window.isLinux.toLowerCase()==="linux")||(window.isLinux==null && isLinux_pmp===true ))&& !App.ApplicationController.demo)
            {
                $("#sel_osType").hide();
                document.getElementById("server_type").value="Linux";//NO I18N
                selectOsType();
        }    
            
            //For getting windows server names
            getServerNameForDeployment("Windows");//NO I18N
        }    
});

function getPopoverCustomTemplate(className) {
    return '<div style="max-width: 400px !important;" class="popover popover_top"  id="certDeployHelpId" role="tooltip"><div class="arrow"></div><h3 class="popover-title"></h3><div class="popover-content ' + className + '"></div></div>';
}

function getLetsEncryptHelp()
{
    var help=I18N.getMsg("letsnecrypt.globaldns.help");//NO I18N
    var content="<ul><li>"+help+"</li></ul>";
    getPopoverHelpStyle(content,'popOverHelpClass popOverHelpHeight');//NO I18N
    $(".popover").css( 'height', '100', 'important' );
    $(".popover").css( 'width', '600', 'important' );    
}

function getDeploymentHelp(){
   var content=getDeploymentHelpContent();
    getPopoverHelpStyle(content,'popOverHelpClass');//NO I18N
}

function getDeploymentHelpContent()
{
    var content="<ul><li>"+I18N.getMsg("js.help.discovery.deploycert.content1")+"<br>"+I18N.getMsg("js.help.discovery.deploycert.content11")+"</li><li>"+I18N.getMsg("js.help.discovery.deploycert.content2")+"<br>"+I18N.getMsg("js.help.discovery.deploycert.content21")+"<br>"+"<div class=\"helpnotes\">"+I18N.getMsg("js.help.discovery.deploycert.content211")+"</div><br>"//No I18N
                    +I18N.getMsg("js.help.discovery.deploycert.content22")+"<br>"+"<div class=\"helpnotes\">"+I18N.getMsg("js.help.discovery.deploycert.content221")+"</div></li><li>"//No I18N
                    +I18N.getMsg("js.help.discovery.deploycert.content4")+"<br>"+"<div class=\"helpnotes\">"+I18N.getMsg("js.help.discovery.deploycert.content41")+"</div></li><li>"//No I18N
                    +I18N.getMsg("js.help.discovery.deploycert.content3")+"</li></ul>";//No I18N
    return content;
}

App.CertDeploymentController = Ember.ObjectController.extend({
    actions: {
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        saveCredential: function()
        {
            var myGrid = $('#PKIInventoryList');
            var selRowIds = myGrid.jqGrid('getGridParam','selarrrow'); //No I18N 
            var cert_ids="";
            $.each(selRowIds, function()
            {
                var id = this;
                var res_id = myGrid.jqGrid('getCell', id, 'ResourceID'); //No I18N
                if(cert_ids!=="")
                {
                    cert_ids=cert_ids+","+res_id;
                }
                else
                {
                    cert_ids=res_id;
                }
            });
            var data = {};    
            data.CERTID = cert_ids;
            var serverName=$("#serverName").val();
            var userName=$("#userName").val();
            var pwd=$("#pwd").val();
            var path=$("#path").val();
            if(document.getElementById("dep_single").checked)
            {
                if(serverName=="")
                {
                    showAlert(I18N.getMsg('js.radius.validserver')); //No I18N
                    return;
                }
                if(userName=="" || pwd=="")
                {
                    showAlert(I18N.getMsg('js.resourcecredential.invalidusernameorpassword')); //No I18N
                    return;
                }
                if(path=="")
                {
                    showAlert(I18N.getMsg('js.editpath.validpath')); //No I18N
                    return;
                }
                data.serverName=serverName;
                data.userName=userName;
                data.pwd=pwd;
                data.path=path;
                data.dep_type="single";//No I18N
            }
            else
            {
                data.dep_type="multiple";//No I18N
                var FILE_CONTENT=window.FILE_CONTENT;
                if(FILE_CONTENT==="")
                {
                   showAlert(I18N.getMsg('js.file.selectaFileWithProperFormat'));//No I18N
                    return;
                }
                if ($('#textfile').val() == '') {
                    showAlert(I18N.getMsg('js.file.selectaFile'));//NO I18N
                    return;
                }
                data.dep_servers=$('#discoverDomains').val();
            }
            data.isWindows=true;
            data.serverType=document.getElementById("server_type").value;
            if(document.getElementById("server_type").value=="Linux"){
                if($("#port").val()=="" && document.getElementById("dep_single").checked)
                {
                    showAlert(I18N.getMsg('js.port.specifyaValidPort')); //No I18N
                    return;
                }
                data.port=$("#port").val();
                data.isWindows=false;
            }
            else if(document.getElementById("server_type").value=="IIS")
            {
                if(App.RequestCertController.cert_type==false)
                {
                    showAlert(I18N.getMsg('Private Key file not available for this certificates')+" "+App.RequestCertController.cert_names); //No I18N
                    return;
                }    
            }
            data.isCertificate=document.getElementById("cert").checked;
            data.isStore=document.getElementById("store").checked;
            if(!(data.isStore || data.isCertificate))
            {
                if(document.getElementById("server_type").value!="MSStore" && document.getElementById("server_type").value!="IIS")
                {
                    showAlert(I18N.getMsg("js.deploy.cert.type"));//No I18N
                    return;
                }
            }
            if(data.dep_type!="multiple")
            {
                if(data.isCertificate)
                {
                    data.certFile=$("#cert_file").val();
                }
                if(data.isStore)
                {
                    data.storeFile=$("#store_file").val();
                }
            }
            
            var ajaxRequestUrl = '/api/pki/request/saveDeploymentCredential';//NO I18N
            data.pmpcp=Get_Cookie('pmpcc');//NO I18N
            var model=this;
            getAjaxApiRequest(ajaxRequestUrl,data,function(jsonData){
                if(jsonData.Status==="Success")
                {
                    model.send('closeModal');//NO I18N
                    messageNotification("messageNotifySuccess",I18N.getMsg(jsonData.Message));//No I18N                    
                }
                else
                {
                    messageNotification("messageNotifyFailure",I18N.getMsg(jsonData.Message));//No I18N
                }
            });
        },
        deployCertificate: function()
        {
            var myGrid = $('#PKIInventoryList');
            var selRowIds = myGrid.jqGrid('getGridParam','selarrrow'); //No I18N 
            var cert_ids="";
            $.each(selRowIds, function()
            {
                var id = this;
                var res_id = myGrid.jqGrid('getCell', id, 'ResourceID'); //No I18N
                if(cert_ids!=="")
                {
                    cert_ids=cert_ids+","+res_id;
                }
                else
                {
                    cert_ids=res_id;
                }
            });
            var data = {};
            data.CERTIDS = cert_ids;
            var serverName=$("#serverName").val();
            var userName=$("#userName").val();
            var pwd=$("#pwd").val();
            var path=$("#path").val();
            if(document.getElementById("dep_single").checked)
            {
                if(serverName=="")
                {
                    showAlert(I18N.getMsg('js.radius.validserver')); //No I18N
                    return;
                }
                if(userName=="" || pwd=="")
                {
                    showAlert(I18N.getMsg('js.resourcecredential.invalidusernameorpassword')); //No I18N
                    return;
                }
                if(path=="")
                {
                    showAlert(I18N.getMsg('js.editpath.validpath')); //No I18N
                    return;
                }
                data.serverName=serverName;
                data.userName=userName;
                data.pwd=pwd;
                data.path=path;
                data.dep_type="single";//No I18N
            }
            else
            {
                data.dep_type="multiple";//No I18N
                    var FILE_CONTENT=window.FILE_CONTENT;
                    if(FILE_CONTENT==="")
                    {
                       showAlert(I18N.getMsg('js.file.selectaFileWithProperFormat'));//No I18N
                        return;
                    }
                    if ($('#textfile').val() == '') {
                        showAlert(I18N.getMsg('js.file.selectaFile'));//NO I18N
                        return;
                    }
                    data.dep_servers=$('#discoverDomains').val();
            }
            data.isWindows=true;
            data.serverType=document.getElementById("server_type").value;
            if(document.getElementById("server_type").value=="Linux"){
                if($("#port").val()=="" && document.getElementById("dep_single").checked)
                {
                    showAlert(I18N.getMsg('js.port.specifyaValidPort')); //No I18N
                    return;
                }
                data.port=$("#port").val();
                data.isWindows=false;
            }
            else if(document.getElementById("server_type").value=="IIS")
            {
                if(App.RequestCertController.cert_type==false)
                {
                    showAlert(I18N.getMsg('Private Key file not available for this certificates')+" "+App.RequestCertController.cert_names); //No I18N
                    return;
                }    
            }
            data.isCertificate=document.getElementById("cert").checked;
            data.isStore=document.getElementById("store").checked;
            if(!(data.isStore || data.isCertificate))
            {
                if(document.getElementById("server_type").value!="MSStore" && document.getElementById("server_type").value!="IIS")
                {
                showAlert(I18N.getMsg("js.deploy.cert.type"));//No I18N
                return;
            }
            }
            if(data.dep_type!="multiple")
            {
                if(data.isCertificate)
                {
//                    if($("#cert_file").val()=="")
//                    {
//                        $("#cert_file").focus();
//                        return;
//                    }
                    data.certFile=$("#cert_file").val();
                }
                if(data.isStore)
                {
//                    if($("#store_file").val()=="")
//                    {
//                        $("#store_file").focus();
//                        return;
//                    }
                    data.storeFile=$("#store_file").val();
                }
            }
            var ajaxRequestUrl = '/api/pki/request/deployCertificate';//NO I18N
            data.pmpcp=Get_Cookie('pmpcc');//NO I18N
            ajaxapicall(ajaxRequestUrl,data,true,"",this);
        }
    }
});
