//$Id$	
// method to validate number
function validateNumberVal(paramVal)
{
	if (paramVal !== "")
	{
	   	var objRegExp  = /^[0-9]+$/; //No I18N
   		return objRegExp.test(paramVal); 
	}
	else
	{
		return false;
	}
}

function validateFieldIsEmpty(event)
{
    if(!isNotEmpty(event.val()))
    {
        event.focus();
        //event.tooltip({'widh': 'auto'});
        return true;
    }
    else
    {
        return false;
    }
}

function isNotEmpty(str)
{
	var temp = trimAll(str);
	if (temp.length > 0 ) {
		return true;
	}
	return false;
}

function trimAll(str) {
	if (str == null) {
		return "";
	}
	var objRegExp = /^(\s*)$/;
	if (objRegExp.test(str)) {
		str = str.replace(objRegExp, '');
		if (str.length == 0) {
			return str;
		}
	}
	objRegExp = /^(\s*)([\W\w]*)(\b\s*$)/;
	if (objRegExp.test(str)) {
		str = str.replace(objRegExp, '$2');
	}
	return str;
}

// method to validate date
function validateDateVal(paramVal)
{
	//format yyyy-mm-dd
	if (paramVal !== "")
	{
		var objRegExp  = /^(1|2){1}[0-9]{3}-(0|1){1}[0-9]{1}-[0-3]{1}[0-9]{1}$/; //No I18N
   		return objRegExp.test(paramVal); 
	}
	else
	{
		return false;
	}
}
// method to validate email
function validateEmail(paramVal)
{
	if (paramVal !== "")
	{
		var objRegExp  = /^([a-zA-Z0-9_.-][\']*)+@([a-zA-Z0-9_.-])+\.([a-zA-Z])+([a-zA-Z])+/; //No I18N
	   	return objRegExp.test(paramVal); 	
	}
	else
	{
		return false;
	}
}

function isAlphaNumericAndSpace(s)
{
	return /^[\w\d\s]*$/.test(s);
}	

function isAlphaNumeric(s)
{
        var valChar='AaBbCcDdEeFfGgHhIiJjKkLlMmNnOoPpQqRrSsTtUuVvWwXxYyZz0123456789'; //No I18N
        for (var i=0; i < s.length; i++)
        {
                var c=s.charAt(i);
                if( valChar.indexOf(c) === -1 ){
                return false;}                
        }
        return true;
}
function isAlphaNumericWithSpace(s)
{
		var valChar='AaBbCcDdEeFfGgHhIiJjKkLlMmNnOoPpQqRrSsTtUuVvWwXxYyZz0123456789 ';  // No I18N
		for (var i=0; i < s.length; i++)
		{
				var c=s.charAt(i);
				if( valChar.indexOf(c) === -1 ){
				return false;}
		}
		return true;
}

function selectAllChecks(e,targetChecks)
{
	if (targetChecks !== undefined)
	{
		if (targetChecks.length === undefined)
		{
			if (e.checked === true)
			{
				targetChecks.checked = true;
			}
			else
			{
				targetChecks.checked = false;
			}
		}
		else
		{
			if (e.checked === true)
			{			
				for (var i=0; i<targetChecks.length; i++)
				{
					targetChecks[i].checked = true;
				}
			}
			else
			{
				for (var i=0; i<targetChecks.length; i++)
				{
					targetChecks[i].checked = false;
				}
			}
		}
	}
}

function checkAndUncheckSelectAll(e,allChecks,targetAll)
{
	if (targetAll !== undefined)
	{
		if (e.checked === true)
		{
			if(checkIfEveryThingIsChecked(allChecks))
			{
				targetAll.checked = true;
			}
		}
		else
		{
			targetAll.checked = false;
		}
	}
}

function checkAndUncheckHeader(e,divId,targetAll)
{
	if (targetAll !== undefined)
	{
		if (e.checked === true)
		{
			var inputCheck = $("div#subHeader input:checkbox").wrap('<span></span>');
			$.each(inputCheck, function(key, val)
			{
				if($(val).prop("checked") === false)
				{
					targetAll.checked = false;	
					 return false;				
				}
				else
				{
					targetAll.checked = true;
				}
			});
		}
		else
		{
			targetAll.checked = false;
		}
	}
}

function selectAllFromList(e,combo)
{
	if(e.checked === true)
	{
		frmSelectAllIncludingEmpty(combo);
	}
	else
	{
		frmUnSelectAllIncludingEmpty(combo);
	}
}

function frmSelectAllIncludingEmpty(combo)
{
	if(combo===null || combo===undefined)
	{
		return;
	}
	var count = combo.length;
	for(ab=0;ab<parseInt(count);ab++)
	{
		combo.options[ab].selected=true;
	}
}

function frmUnSelectAllIncludingEmpty(combo)
{
	if(combo===null || combo===undefined)
	{
		return;
	}
	var count = combo.length;
	for(ab=0;ab<parseInt(count);ab++)
	{
		combo.options[ab].selected=false;
	}
}

function validateDate(dateVal,dateFormat)
{
	if (dateFormat === "mm/dd/yyyy")
	{
		var objRegExp  = /^(0|1){1}[0-9]{1}\/[0-3]{1}[0-9]{1}\/(1|2){1}[0-9]{3}$/; //No I18N
		return objRegExp.test(dateVal); 
	}
	if (dateFormat === "yyyy-mm-dd")
	{
		var objRegExp  = /^(1|2){1}[0-9]{3}-(0|1){1}[0-9]{1}-[0-3]{1}[0-9]{1}$/; //No I18N
		return objRegExp.test(dateVal); 
	}
	if (dateFormat === "HH:MM:SS AM")
	{
		var objRegExp  = /^[0-2]{1}[0-9]{1}:[0-5]{1}[0-9]{1}:[0-5]{1}[0-9]{1}\s(A|P){1}[M]{1}$/; //No I18N
		return objRegExp.test(dateVal); 
	}
	return true;		
}  

function getValueofSelectedRadioButton(radioBut)
{
	var result = "";
	if (radioBut !== undefined)
	{
		if (radioBut.length !== undefined)
		{
			for(var i=0; i<radioBut.length; i++)
			{
				if(radioBut[i].checked === true)
				{
					result = radioBut[i].value;
					break;
				}
			}
		}
		else
		{
			if(radioBut.checked === true)
			{
				result = radioBut.value;
			}
		}
	}
	return result;
}	

function checkIfAnyThingIsChecked(checkBoxElem)
{
	var result = "";
	if (checkBoxElem !== undefined)
	{
		if (checkBoxElem.length !== undefined)
		{
			for(var i=0; i<checkBoxElem.length; i++)
			{
				if(checkBoxElem[i].checked === true)
				{
					if (result === "")
					{
						result = checkBoxElem[i].value;
					}
					else
					{
						result = result +", "+ checkBoxElem[i].value;
					}
				}
			}
		}
		else
		{
			if(checkBoxElem.checked === true)
			{
				result = checkBoxElem.value;
			}
		}
	}
	return result;
}	

function checkIfEveryThingIsChecked(checkBoxElem)
{
	var result = true;
	if (checkBoxElem !== undefined)
	{
		if (checkBoxElem.length !== undefined)
		{
			for(var i=0; i<checkBoxElem.length; i++)
			{
				if(checkBoxElem[i].checked === false)
				{
					result = false;
					break;
				}
			}
		}
		else
		{
			if(checkBoxElem.checked === false)
			{
				result = false;
			}
		}
	}
	return result;
}	

function getCheckedCount(checkBoxElem)
{
	var count = "";
	if (checkBoxElem !== undefined)
	{
		if (checkBoxElem.length !== undefined)
		{
			for(var i=0; i<checkBoxElem.length; i++)
			{
				if(checkBoxElem[i].checked === true)
				{
					count = count + 1;
				}
			}
		}
		else
		{
			if(checkBoxElem.checked === true)
			{
				count = count + 1;
			}
		}
	}
	return count;
}	
function selectARadioButton(radioElem, selectedVal)
{
	if (radioElem !== undefined)
	{
		if (radioElem.length !== undefined)
		{
			for(var i=0; i<radioElem.length; i++)
			{
				if(radioElem[i].value === selectedVal)
				{
					radioElem[i].checked = true;
					break;
				}
			}
		}
		else
		{
			if(radioElem.value === selectedVal)
			{
				radioElem.checked = true;
			}
		}
	}
}	
function showHideDivOnCheckBoxClick(toShow,divId)
{
	if (toShow)
	{
		if (document.getElementById(divId).style.display === 'none')
		{
			document.getElementById(divId).style.display = 'block';
		}
	}
	else
	{
		if (document.getElementById(divId).style.display === 'block')
		{
			document.getElementById(divId).style.display = 'none';
		}		
	}
}

function showHideDiv1(divId,speed,tis)
{
	var divIdwithHash = "#"+divId;	
	$(divIdwithHash).toggle('fast');
	//console.log($(divIdwithHash).css({'top':($(tis).offset().top + $(tis).height()),'left':$(tis).position().left}).slideDown())
}

function showHideDiv(divId,speed)
{
	var divIdwithHash = "#"+divId;
	if (document.getElementById(divId).style.display === 'none')
	{
		if(speed !== null && speed !== undefined) {
		$(divIdwithHash).show(speed);
		} else {
			$(divIdwithHash).show('slow');
		}
	}
	else
	{
		if(speed !== null && speed !== undefined){
			$(divIdwithHash).hide(speed);
		}else{
			$(divIdwithHash).hide('slow');}
	}
}

function checkIfAValIsValid(val,type)
{
	if (type === "string")
	{
		if (val !== undefined && val !== null && val !== "null" && val !== "")
		{
			return true;
		}
		else
		{
			return false;
		}
	}
	else if (type === "array")
	{
		if (val !== undefined && val !== null && val.length !== undefined && val.length !== 0)
		{
			return true;
		}
		else
		{
			return false;
		}
	}
	else if (type === "json")
	{
		if (val !== undefined && val !== null && val !== 'null' && val !== "")
		{
			var count = Object.keys(val).length;
			if (count === 0)
			{
				return false;
			}
			else
			{
				return true;
			}
		}
		else
		{
			return false;
		}
	}
	else if (type === "includeEmptyJson")
	{
		if (val !== undefined && val !== null && val !== 'null' && val !== "")
		{
			
				return true;
		}
		else
		{
			return false;
		}
	}
	else
	{
		return true;
	}
}


function getCountOfJson(jsonData)
{
	var count = 0;
	if (checkIfAValIsValid(jsonData,'json'))
	{
		count = Object.keys(jsonData).length;
	}
	return count;
}

function showPointer(cellValue, options, rowdata, action)
{
	return "<span class='pointer'> "+cellValue+"</span>";
}

function createRadioInput(name,id,value,checked)
{
	var inputRadio = document.createElement("input"); //No I18N
	inputRadio.setAttribute("type","radio"); //No I18N
	inputRadio.setAttribute("name",name); //No I18N
	inputRadio.setAttribute("id",id); //No I18N
	inputRadio.setAttribute("value",value);	 //No I18N
	if (checked)
	{	
		inputRadio.setAttribute("checked","checked"); //No I18N
	}
	return inputRadio;
}
function createLabel(forVal,classVal,textNodeVal)
{
	var labelElem = document.createElement("label"); //No I18N
	labelElem.setAttribute("for",forVal); //No I18N
       	labelElem.setAttribute("class",classVal); //No I18N
	if (textNodeVal !== undefined)
	{
		var textNode = document.createTextNode(textNodeVal);
		labelElem.appendChild(textNode);
	}
	return labelElem;
}

function createDiv(parentElem,childDivId)
{
	if (parentElem !== undefined)
	{
		var childDiv = document.createElement("div");//No I18N
		childDiv.setAttribute("id",childDivId);//No I18N
		parentElem.appendChild(childDiv);//No I18N
	}
}

function createAndLoadJQgridWithData(jsonData, colNamesList, colModelList, tableProps)
{
	if (checkIfAValIsValid(tableProps) && checkIfAValIsValid(tableProps.tableDetails))
	{
		var mainDiv = tableProps.tableDetails.mainDiv; //No I18N
		var prefix = tableProps.tableDetails.prefix; //No I18N
		if (prefix !== undefined && prefix !== "") {prefix = prefix+"_"; } //No I18N
		if (tableProps.customTitle !== undefined)
		{
			var leftContentTitle = tableProps.customTitle.leftContent; //No I18N
			var rightContentTitle = tableProps.customTitle.rightContent; //No I18N
			var customTitleClass = tableProps.customTitle.divClass; //No I18N
			if (leftContentTitle !== undefined || rightContentTitle !== undefined)
			{
				if (mainDiv !== undefined && mainDiv !== "") //No I18N
				{
					var mainDivElement = document.getElementById(mainDiv);
					var titleDivElem = document.createElement("div"); //No I18N
					titleDivElem.setAttribute("id",prefix+"JQ_Title"); //No I18N
					if (customTitleClass !== undefined && customTitleClass !== "") //No I18N
					{
						titleDivElem.setAttribute("class",customTitleClass); //No I18N
					}
					var h3Elem = document.createElement("h3"); //No I18N
					if (leftContentTitle !== undefined && leftContentTitle !== "")
					{
//						var h3LeftText = document.createTextNode(leftContentTitle);
						h3Elem.innerHTML = leftContentTitle; //No I18N
					}
					if (rightContentTitle !== undefined && rightContentTitle !== "")
					{
						var spanRight = document.createElement("span"); //No I18N
						spanRight.style.cssFloat = "right"; //No I18N
//						var h3RightText = document.createTextNode(rightContentTitle);
						spanRight.innerHTML = rightContentTitle; //No I18N
						h3Elem.appendChild(spanRight); //No I18N
					}
					titleDivElem.appendChild(h3Elem);
					mainDivElement.appendChild(titleDivElem);
				}
			}

		}
		var gridTable = ""; //No I18N
		var gridNavigator = ""; //No I18N
		var captionTitle = ""; //No I18N
		var onSelectFunction = ""; //No I18N
		var defaultOption = {};
		var hiddengrid=false;
		var createTable = tableProps.tableDetails.createTable;
		if (createTable)
		{
//			alert(mainDiv+": "+createTable);
			if(mainDiv !== undefined && mainDiv !== "") //No I18N
			{
				var mainDivElem = document.getElementById(mainDiv);
				var subDivElem = document.createElement("div"); //No I18N

				gridTable = prefix+"JQ_tableList"; //No I18N
				if (tableProps.tableDetails.pagerNeeded !== undefined && tableProps.tableDetails.pagerNeeded)
				{
//					alert("Creating pager");
					gridNavigator = prefix+"JQ_Pager"; //No I18N
					var pagerElem = document.createElement("div"); //No I18N
					pagerElem.setAttribute("id",gridNavigator); //No I18N
					subDivElem.appendChild(pagerElem);
				}

				var tableElem = document.createElement("table"); //No I18N
				tableElem.setAttribute("id",gridTable); //No I18N
				var trElem = document.createElement("tr"); //No I18N
				var tdElem = document.createElement("td"); //No I18N
				trElem.appendChild(tdElem);
				tableElem.appendChild(trElem);

				subDivElem.appendChild(tableElem);
				mainDivElem.appendChild(subDivElem);
			}
		}
		else
		{
			if (tableProps.tableDetails.gridTable !== undefined) { gridTable = tableProps.tableDetails.gridTable; }
			if (tableProps.tableDetails.gridNavigator !== undefined) { gridNavigator = tableProps.tableDetails.gridNavigator; }
		}
		if (tableProps.tableTitle !== undefined) { captionTitle = tableProps.tableTitle; }
		if (tableProps.onSelectFunction !== undefined) {onSelectFunction = tableProps.onSelectFunction; }
		if (tableProps.defaultOption !== undefined) {defaultOption = tableProps.defaultOption; }	
		loadJQgridWithData("#"+gridTable, jsonData, colNamesList, colModelList, captionTitle, "#"+gridNavigator, onSelectFunction, defaultOption); //No I18N	
	}
}

function loadJQgridWithData(gridTable, jsonData, colNamesList, colModelList, captionTitle, gridNavigator, onSelectFunction, defaultOptions,innerDiv)
{
        var widpadHeight=0;
	var defaultSortName = ""; //No I18N
	var defaultSortOrder = "asc"; //No I18N
	var widthOfTable = "100"; //No I18N
	var multiselectVal = false; // No I18N
	var apiUrl = "";// No I18N
	var urlParameter ="";// No I18N// No I18N
  	var deleteName = "";// No I18N
	var rowNumNeeded = true; //No I18N
	var addIcon = false;
	var delIcon = false;
	var selectedMonitorTab = "";
	var deviceName = "";// No I18N
	var deviceNameParameter = "";// No I18N
	var delMsg = "Are you sure you want to delete ?";// No I18N
	var minRowsPerPage = 25;
	var searchOption = false;
	var grouping = false;
	var subGrid = false;
	var hiddengrid=false;
	var hidegrid=false;
	var groupField=['rName'];
	var height = "auto"//No I18N
	var groupText='<b>  {0}  </b>';//NO I18N
	var groupCollapse=true;
        //If Formatter is available
        var app;
	var countOfRows = getCountOfJson(jsonData);
	var grid = $(gridTable);
	var gridDivId = "#gbox_"; //No I18N
	var gridTableIdAlone = gridTable.substring(1);
	gridDivId = gridDivId+gridTableIdAlone;
	var gridDiv = $(gridDivId);
        
        for(var i = 0; i < colModelList.length; i++) {
                var columnModel = colModelList[i];
                if(columnModel.formatter != null && columnModel.formatter != "") {
                        var tmpFunc = new Function('return '+columnModel.formatter);
                        columnModel.formatter = tmpFunc();
                }
        }
        if(innerDiv!==undefined && innerDiv!=true)
        {
            var widpadHeight=$(innerDiv).height();
        }
        else
        {
            if($(".widpad")!= undefined && $(".widpad").length>0)
            {
            widpadHeight=$(".widpad").height(); 
        }
            else
            {
                widpadHeight=$("#Password_View_Div_Id").height(); 
            }
        }
        if(innerDiv == undefined && innerDiv !== true)
        {
            var gridHeight;
            if(jQuery(".widpad").length>0)
            {
                if(jQuery(gridDivId).length>0)
                {
                    gridHeight=widpadHeight-(jQuery(gridDivId).offset().top-jQuery(".widpad").offset().top+80);//No I18N
                }
                else if(jQuery(gridTable).length>0)
                {
                    gridHeight=widpadHeight-(jQuery(gridTable).offset().top-jQuery(".widpad").offset().top+80);//No I18N
                }
            }
            else
            {
                gridHeight=widpadHeight-(jQuery(gridTable).offset().top-jQuery("#Password_View_Div_Id").offset().top+70);//No I18N
            }
            height=gridHeight-20;
        }

	if (defaultOptions !== undefined)
	{
		if(defaultOptions.groupText !== undefined) 	 	
		{ 	 	
			groupText = defaultOptions.groupText; //No I18n 	 	
		}
		if(defaultOptions.subGrid !== undefined)
		{
			subGrid = defaultOptions.subGrid; //No I18n
		}
		if(defaultOptions.groupField !== undefined) 	 	
		{ 	 	
			groupField = defaultOptions.groupField; //No I18n 	 	
		}
		if(defaultOptions.hiddengrid !== undefined) 	 	
		{ 	 	
			hiddengrid = defaultOptions.hiddengrid; //No I18n 	 	
		} 
		if (defaultOptions.searchOption !== undefined)
		{
			searchOption = defaultOptions.searchOption; //No I18N
		}
		if (defaultOptions.sortName !== undefined)
		{
			defaultSortName = defaultOptions.sortName; //No I18N
		}
		if (defaultOptions.sortOrder !== undefined)
		{
			defaultSortOrder = defaultOptions.sortOrder; //No I18N
		}
		if (defaultOptions.widthOfTable !== undefined)
		{
			widthOfTable = defaultOptions.widthOfTable; //No I18N
		}
		if (defaultOptions.multiselect !== undefined)
		{
			multiselectVal = defaultOptions.multiselect; //No I18N
		}
		if (defaultOptions.apiUrl !== undefined)
		{
			apiUrl = defaultOptions.apiUrl; //No I18N
		}
		if (defaultOptions.urlParameter !== undefined)
		{
			urlParameter = defaultOptions.urlParameter; //No I18N
		}
		if (defaultOptions.deleteName !== undefined)
		{
			deleteName = defaultOptions.deleteName; //No I18N
		}
		if (defaultOptions.rowNumNeeded !== undefined)
		{
			rowNumNeeded = defaultOptions.rowNumNeeded; //No I18N
		}
		if (defaultOptions.addIcon !== undefined)
		{
			addIcon = defaultOptions.addIcon; //No I18N
		}
		if (defaultOptions.delIcon !== undefined)
		{
			delIcon = defaultOptions.delIcon; //No I18N
		}
		if (defaultOptions.selectedMonitorTab !== undefined)
		{
			selectedMonitorTab = defaultOptions.selectedMonitorTab; //No I18N
		}
		if (defaultOptions.deviceName !== undefined)
		{
			deviceName = defaultOptions.deviceName; //No I18N
		}
		if (defaultOptions.deviceNameParameter !== undefined)
		{
			deviceNameParameter = defaultOptions.deviceNameParameter; //No I18N
		}
		if (defaultOptions.delConfirmMsg !== undefined)
		{
			delMsg = defaultOptions.delConfirmMsg; //No I18N
		}
		if (defaultOptions.minRowsPerPage !== undefined)
		{
			minRowsPerPage = defaultOptions.minRowsPerPage; //No I18N
		}
		if (defaultOptions.grouping !== undefined)
		{
			grouping = defaultOptions.grouping; //No I18N
		}
		if (defaultOptions.height !== undefined)
		{
			height = defaultOptions.height; //No I18N
		}
		if (defaultOptions.groupCollapse !== undefined)
		{
			groupCollapse = defaultOptions.groupCollapse; //No I18N
		}
		if (defaultOptions.hidegrid !== undefined)
		{
			hidegrid = defaultOptions.hidegrid; //No I18N
		}
	}
	if (gridDiv.length > 0)
	{
		grid.jqGrid('clearGridData'); //No I18N
		grid.jqGrid('setGridParam', { datatype: "jsonstring", datastr: jsonData }); //No I18N
                $('.noRowMsg').remove();
		grid.trigger('reloadGrid'); //No I18N
	}
	else
	{
		if ((gridNavigator === null || gridNavigator === undefined || gridNavigator === "") && countOfRows > minRowsPerPage)
		{
			var gridNavigatorId = gridTableIdAlone+"Pager";//No I18N
			var parentElem = $(gridTable).parent().get(0);//No I18N
			createDiv(parentElem,gridNavigatorId);//No I18N
			gridNavigator = "#"+gridNavigatorId;//No I18N
		}
		var gridviewVal = false;
		if (onSelectFunction === "alarmListColored") //No I18N
		{
			gridviewVal = true;
		}
	grid.jqGrid({
		colNames: colNamesList,
		colModel: colModelList,
                pager: kmpStandAlone ? gridNavigator : false,
		toppager: kmpStandAlone ? false : gridNavigator,
		rowList: [25,50,75,100],
		datatype: "jsonstring", //No I18N
		datastr: jsonData,
		multiselect: multiselectVal,
                multiselectWidth: 30,
                multiboxonly: false,
		loadOnce: false,
                emptyrecords: "",
                recordtext: "Showing {0} - {1} of {2}", //No I18N
		jsonReader: { root: function (obj) { return obj; }, repeatitems: false },
		rownumbers: rowNumNeeded,
		rowNum: minRowsPerPage,
		viewrecords: true,
		grouping: grouping,
		groupingView:
		{
			groupField: [groupField],
			groupColumnShow: [false],
			groupCollapse:groupCollapse,
			groupText:[groupText]
		},
	    caption: captionTitle,
		height: "auto", //No I18N
		autowidth: true,
		shrinkToFit: true,
		hidegrid: hidegrid,
                scrollerbar:true,
		hiddengrid:false,
		ignoreCase: true,
		sortable:true,
		subGrid:subGrid, 	
		sortname: defaultSortName, //No I18N
		sortorder: defaultSortOrder, //No I18N
		gridview: gridviewVal, // If set to true, the event below doesn't fire!
		subGridOptions: 
			{
				"plusicon"  : "ui-icon-triangle-1-e",//No I18N
				"minusicon" : "ui-icon-triangle-1-s", //No I18N
				"openicon"  : "ui-icon-arrowreturn-1-e", //No I18N
				"reloadOnExpand" : false, //No I18N
				"selectOnExpand" : true //No I18N
			},
			subGridRowExpanded: function(subgrid_id, row_id) 
			{
                            if(defaultOptions.subGridType==="KeyRotationReport")
                            {
                                var subgrid_table_id;
                                subgrid_table_id = subgrid_id+"_t";//NO I18N
                                jQuery("#"+subgrid_id).html("<table id='"+subgrid_table_id+"' class='scroll'></table>");//NO I18N
                                var scheduleAudit_id=grid.jqGrid('getCell', row_id,'KeyRotationAuditId'); //No I18N
                                var ajaxRequestUrl = '/api/pki/ssh/getKeyRotationAuditStatus?keyRotationAuditId='+scheduleAudit_id; //No I18N
                                getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
                                    var colNamesList = ['KEYROTATIONID',I18N.getMsg('js.general.resourcename'),I18N.getMsg('js.general.username'),I18N.getMsg('js.commonstr.status'),I18N.getMsg('js.commonstr.description')]; //No I18N
                                    var colModelList = [
                                            {name: 'KEYROTATIONID', index: 'KEYROTATIONID',hidden:true},//No I18N
                                            {name: 'RESOURCE NAME', index: 'RESOURCE NAME'}, //No I18N
                                            {name: 'USER NAME', index: 'USER NAME'}, //No I18N
                                            {name: 'STATUS', index: 'STATUS'}, //No I18N
                                            {name: 'DESCRIPTION', index: 'DESCRIPTION'} //No I18N
                                    ];
                                    var defaultOptions={multiselect:false,rowNumNeeded:false,searchOption:true};
                                    loadJQgridWithData("#"+subgrid_table_id, jsonData.detailedKeyRotationAudit, colNamesList, colModelList, " ","", "",defaultOptions);//No I18N
                                });
                            }
                            else if(defaultOptions.subGridType==="WildcardCertReport")
                            {
                                var subgrid_table_id;
                                subgrid_table_id = subgrid_id + "_t";//NO I18N
                                jQuery("#" + subgrid_id).html("<table id='" + subgrid_table_id + "' class='scroll'></table>");//NO I18N
                                var sslresId = grid.jqGrid('getCell', row_id, 'SSLResourceID'); //No I18N
                                var ajaxRequestUrl = '/api/pki/Inventory/getMultipleInstalledServers?cert_id=' + sslresId; //No I18N
                                getAjaxApiRequest(ajaxRequestUrl, "", function (jsonData) {
                                var colNamesList = ['MappingID', I18N.getMsg('js.sslcertificate.dnsame'), I18N.getMsg('js.discovery.ipaddress'),I18N.getMsg('js.discovery.port')]; //No I18N
                                var colModelList = [
                                    {name: 'MappingID', index: 'MappingID', hidden: true}, //No I18N
                                    {name: 'DomainName', index: 'DomainName'}, //No I18N
                                    {name: 'IPAddress', index: 'IPAddress'}, //No I18N
                                    { name: 'Port', index: 'Port'} //No I18N
                                ];
                                var defaultOptions = {multiselect: false, rowNumNeeded: false};
                                loadJQgridWithData("#" + subgrid_table_id, jsonData.MultipleServers, colNamesList, colModelList, " ", "", "", defaultOptions);//No I18N
                                });
                            }
                            else if(defaultOptions.subGridType === "LandingServerReport")
                            {
                                var subgrid_table_id;
                                subgrid_table_id = subgrid_id + "_t";//NO I18N
                                jQuery("#" + subgrid_id).html("<table id='" + subgrid_table_id + "' class='scroll'></table>");//NO I18N
                                var serverId = grid.jqGrid('getCell', row_id, 'ServerId'); //No I18N
                                var lsname = grid.jqGrid('getCell', row_id, 'ServerName'); //No I18N                                
                                var ajaxRequestUrl = '/api/pki/landingserver/lsAssociationGridView?LSId='+serverId+'&LSName='+lsname+'&view=associated'; //No I18N
                                getAjaxApiRequest(ajaxRequestUrl, "", function (jsonData) {
                                    if(jsonData.Resources.length>0){
                                        var colNamesList = ['Resource_ID',I18N.getMsg('js.general.resourcename'),I18N.getMsg("js.commonstr.description"),I18N.getMsg('js.discovery.ipaddress'),I18N.getMsg('js.general.creationtime'),'','']; //No I18N
                                        var colModelList = [
                                                { name: 'ResourceID', index: 'ResourceID',hidden:true},//No I18N
                                                { name: 'ResourceName', index: 'ResourceName'}, //No I18N
                                                { name: 'Description', index: 'Description'},//NO I18N
                                                { name: 'IPAddress', index: 'IPAddress',formatter:'ipcheckFormatter'}, //No I18N
                                                { name: 'CreationTime', index: 'CreationTime',sorttype: 'datetime',datefmt: 'M d, Y H:i'}, //No I18N
                                                { name: 'isLS', index: 'isLS',hidden:true},//NO I18N
                                                { name: 'ISLS', index: 'ISLS',formatter:'isLSFormatter',width:'35px',search:false,fixed:true}//NO I18N
                                                        ];
                                        var defaultOptions = {multiselect: false, rowNumNeeded: false};
                                        loadJQgridWithData("#" + subgrid_table_id, jsonData.Resources, colNamesList, colModelList, " ", "", "", defaultOptions);//No I18N
                                    }
                                });
                            }
                            else if(defaultOptions.subGridType === "SSLVulnerabilitiesReport")
                            {
                                var subgrid_table_id;
                                subgrid_table_id = subgrid_id + "_t";//NO I18N
                                jQuery("#" + subgrid_id).html("<table id='" + subgrid_table_id + "' style=\"width:100%\" class='scroll'></table>");//NO I18N
                                var cert_id = grid.jqGrid('getCell', row_id, 'ResourceID'); //No I18N                           
                                var ajaxRequestUrl = '/api/pki/Inventory/sslcertvulreportview?cert_id='+cert_id; //No I18N
                                getAjaxApiRequest(ajaxRequestUrl, "", function (jsonData) {                                    
                                        var ele='<div class="cer_wrapper"><div class="commonname">Common name</div><ul>';
                                        var list = jsonData.Vulnerabilities;
                                        var noData = list[0];
                                        if(list.length==1 && noData.ID==="-1" && noData.IpAddress==="")
                                        {
                                            ele='<div class="cer_wrapper" style="font-size:14px">'+noData.CommonName+'</div>';//NO I18N
                            }
                                        else
                            {
                                            for(var z=0;z<list.length;z++)
                                {
                                                var data=list[z];
                                                if(data.Status!=="Failed")
                                                {
                                                    if(data.Flag==="yes")
                                                    {
                                                        ele += '<li><a  style="color:#f54753" href="javascript:showVulPopUp('+data.ID+')">'+data.CommonName+'</a>('+data.IpAddress+')</li>';
                                }
                                                    else
                                                    {
                                                        ele += '<li><a href="javascript:showVulPopUp('+data.ID+')">'+data.CommonName+'</a>('+data.IpAddress+')</li>';
                            }
                                                }
                                                else
                                                {
                                                    ele += '<li title="'+data.Reason+'">'+data.CommonName+' ('+data.IpAddress+')</li>';
                                                }
                                            }
                                            ele+='</ul>';
                                        }
                                        document.getElementById(subgrid_table_id).innerHTML=ele;
                                        
                                });
                            }
			},
                        gridComplete:function(){
                            if(onSelectFunction === "certHistory" || onSelectFunction==="AllResourceUsers" || onSelectFunction==="SSHKeyAssociate" || onSelectFunction==="GeneratedCertList" || onSelectFunction==="EncryptionKey" || onSelectFunction==="SSLEndPointSummary" || onSelectFunction==="GoDaddyRequestsList" || onSelectFunction==="LetsEncryptList" || onSelectFunction==="certDetails")//No I18N
                            {
                                //For more action popup
                                showPopover();
                            }
                            app=this;
			},
			onSelectAll: function(rowIds, allChecked) {
				$("input.groupHeader").attr('checked', allChecked);
			},
		afterInsertRow: function(rowId, rowData, rowElem) {
			// rowElem[nnn] column number to compare with (remember Javascript starts indexes at 0, so rowElem[2] selects the 3rd column)
			// Adapt the if clause to other comparisions if needed
			if(onSelectFunction === "userList")
			{
				if (rowElem.USERNAME === "admin" || rowElem.USERNAME === window.userName) { //No I18N 
					jQuery('tr#'+rowId+' td:last div:first div.ui-inline-del',jQuery(this)).hide();//No I18N
	  			}
   				return true;
			}
		}, 
		rowattr: function (rd) {
			if(onSelectFunction === "alarmListColored") //No I18N
			{
				var severity = rd.severity;				
				var className = "clearBG"; //No I18N
				if (severity.indexOf("Trouble") > -1)//No I18N 
				{
					className = "troubleBG"; //No I18N
	  			}				
				if (severity.indexOf("Attention") > -1)//No I18N 
				{
					className = "attentionBG"; //No I18N					
	  			}				
				if (severity.indexOf("Critical") > -1)//No I18N 
				{
					className = "criticalBG"; //No I18N					
	  			}				
				if (severity.indexOf("Service") > -1)//No I18N 
				{
					className = "servicedownBG"; //No I18N					
				}
				return {"class": className};	 //No I18N			
			}
		},		
		onSelectRow: function(id , status , e){
       			/*if (onSelectFunction == "certDetails")//NO I18N
			{
				var hostId = grid.jqGrid('getCell', id,'ResourceID'); //No I18N
				if (hostId !== null && hostId !== "")
				{
					location.href = "index.jsp#/Inventory/Details/"+hostId; //No I18N
				}

			}*/
		},
		onCellSelect: function(id, col, content, event) 
		{	
			var colMod = jQuery(gridTable).jqGrid("getGridParam", "colModel");	//No I18N
      			if (onSelectFunction === "AllResources" && colMod[col].name === "ResourceName")
			{
				var hostId = grid.jqGrid('getCell', id,'ResourceID'); //No I18N
                                var res_type=grid.jqGrid('getCell', id,'ResourceType'); //No I18N
                                var res_name=grid.jqGrid('getCell', id,'ResourceName'); //No I18N
				if (hostId !== null && hostId !== "")
				{
                                    showResourceDetailsView(hostId,res_type,res_name);
				}
                        }
                        else if(onSelectFunction === "DefaultDNSServer"&& colMod[col].name=="Edit")
                        {
                            var id = grid.jqGrid('getCell',id,'ID');//NO I18N
                            showGlobalDNSDetails(id);
                        }
                        else if(onSelectFunction === "SSHResources" && colMod[col].name === "EditPath")
                        {
                            if(kmpStandAlone)
                            {
                            var res_id = grid.jqGrid('getCell',id,'ResourceID');//NO I18N
                            var description = grid.jqGrid('getCell',id,'Description');//NO I18N
                            var ipaddress = grid.jqGrid('getCell',id,'IPAddress');//NO I18N
                            var resourcename = grid.jqGrid('getCell',id,'ResourceName');//NO I18N
                            var port = grid.jqGrid('getCell',id,'Port');//NO I18N
                            var path = grid.jqGrid('getCell',id,'Path');//NO I18N
                            App.InventoryController.res_Id=res_id;
                            App.InventoryController.description=description;
                            App.InventoryController.port=port;
                            App.InventoryListDetailsController.res_name=resourcename;
                            App.InventoryController.path=path;
                            App.InventoryListDetailsController.ip_address=ipaddress;
                            document.getElementById("editsshdetails").click();
                        }
                        }
      			else if (onSelectFunction === "SSHResources" && colMod[col].name === "ResourceName")
			{
				var hostId = grid.jqGrid('getCell', id,'ResourceID'); //No I18N
                                var res_name=grid.jqGrid('getCell', id,'ResourceName'); //No I18N
				if (hostId !== null && hostId !== "")
				{
                                    //showSSHResourceDetails(hostId);
				}
                        }
      			else if (onSelectFunction === "SSHResources" && colMod[col].name === "Deploy")
			{
				var resid = grid.jqGrid('getCell', id,'ResourceID'); //No I18N
                                var isCredent = grid.jqGrid('getCell', id,'Edit'); //No I18N
				if ((resid !== null && resid !== "" && isCredent=='enabled') || !kmpStandAlone)
				{
                                    App.InventoryController.res_Id=resid;
                                    App.InventoryListDetailsController.deploy=true;
                                    document.getElementById("create_deploy").click();
				}
                        }
                        else if(onSelectFunction === "SSHResources" && colMod[col].name === "ISLS")
                        {
                            var lsId = grid.jqGrid('getCell',id,'LSId');//NO I18N
                            var reload=false;
                            var url = window.location.href;
                            if(url.includes('/SSHMgmt/landingServerAssociation/'))
                            {
                                reload = true;
                            }
                            if(lsId!=="-" && lsId!=="")
                            {
                                location.href = "#/SSHMgmt/landingServerAssociation/"+lsId;//NO I18N
                                if(reload)
                                {
                                    window.location.reload(true);
                                }
                            }                            
                        }
                        else if(onSelectFunction === "LandingServersList" && colMod[col].name === "EDIT")
                        {
                            var lsid = grid.jqGrid('getCell',id,'SERVER_ID');//NO I18N
                            App.InventoryController.lsid=lsid;
                            document.getElementById("LSEdit").click();
                        }
                        else if(onSelectFunction === "LandingServersList" && colMod[col].name === "SERVER_NAME")
                        {
                            var lsid = grid.jqGrid('getCell',id,'SERVER_ID');//NO I18N
                            var lsname = grid.jqGrid('getCell',id,'SERVER_NAME');//NO I18N                            
                            App.InventoryController.lsname=lsname;
                            location.href="#/SSHMgmt/landingServerAssociation/"+lsid;
                        }
      			else if (onSelectFunction === "sshResourceDetails" && colMod[col].name === "Terminal")
			{
				var user_id = grid.jqGrid('getCell', id,'UserID'); //No I18N
                                var key_id=grid.jqGrid('getCell', id,'KeyID'); //No I18N
                                    openTerminal(user_id,key_id);
				}
                        else if (onSelectFunction === "sshResourceDetails" && colMod[col].name === "Export")
			{
				var user_id = grid.jqGrid('getCell', id,'UserID'); //No I18N
                                var key_id=grid.jqGrid('getCell', id,'KeyID'); //No I18N
                                exportSshKey(key_id,user_id);
			}
      			else if (onSelectFunction === "ResourceUsersTerminal" && colMod[col].name === "Connect")
			{
				var user_id = grid.jqGrid('getCell', id,'UserID'); //No I18N
                                var connect=grid.jqGrid('getCell', id,'Connect'); //No I18N
                                if(connect==="true")
                                {
                                    openTerminal(user_id);
                                }
                        }
      			else if (onSelectFunction === "ResourceUsersTerminal" && colMod[col].name === "credential")
			{
                            if(kmpStandAlone)
                            {
				var user_id = grid.jqGrid('getCell', id,'UserID'); //No I18N
                                var credential=grid.jqGrid('getCell', id,'credential'); //No I18N
                                if(credential==="enabled")
                                {
                                    App.SettingsCommonController.isCredentialAvailable="true";
                                }
                                else
                                {
                                    App.SettingsCommonController.isCredentialAvailable="false";
                                }
                                App.SettingsCommonController.isSingleCredential=true;
                                App.SettingsCommonController.user_id=user_id;
                                $("#basicCredentials").show();
                                $("#usersList").hide();
                                getBasicCredential();
                            }

                        }
                        else if (onSelectFunction === "rootCertList" && colMod[col].name === "Common Name")
			{
				var hostId = grid.jqGrid('getCell', id,'ResourceID'); //No I18N
				if (hostId !== null && hostId !== "")
				{
                                    goToPKICertDetailsLink(hostId);
				}
                        }
                        else if (onSelectFunction === "rootCertList" && colMod[col].name === "isUsedToSign")
			{
				var hostId = grid.jqGrid('getCell', id,'ResourceID'); //No I18N
                                var signedBy = grid.jqGrid('getCell', id,'isUsedToSign'); //No I18N
                                App.InventoryListDetailsController.cert_name=grid.jqGrid('getCell', id,'Common Name'); //No I18N
				if (signedBy.indexOf("CECECE")===-1)
				{
                                    redirectUrl("SSLMgmt/SignedCertificate/"+hostId);//No I18N
				}
                        }
      			else if (onSelectFunction === "certDetails" && colMod[col].name === "Common Name")
			{
				var hostId = grid.jqGrid('getCell', id,'ResourceID'); //No I18N
				if (hostId !== null && hostId !== "")
				{
                                    goToPKICertDetailsLink(hostId);
				}
                        }
                        else if (onSelectFunction === "GoDaddyRequestsList" && colMod[col].name === "CommonName")
			{
				var id = grid.jqGrid('getCell', id,'ID'); //No I18N                               
                                goToGoDaddyOrderDetails(id);
                        }
                        else if (onSelectFunction === "GoDaddyRequestsList" && colMod[col].name === "CheckCertificate")
			{
				var id = grid.jqGrid('getCell', id,'ID'); //No I18N                               
                                checkGoDaddyCertificate(id);
                        }
                        else if(onSelectFunction === "certDetails" && colMod[col].name === "Exp_Type")
                        {
                                var hostId = grid.jqGrid('getCell', id,'ResourceID'); //No I18N
				if (hostId !== null && hostId !== "")
				{
                                    goToCertVulnerabilitiesLink(hostId);
				}
                        }
                        else if (onSelectFunction === "certDetails" && colMod[col].name === "DeployedServers")
			{
				var hostId = grid.jqGrid('getCell', id,'ResourceID'); //No I18N
                                var depser = grid.jqGrid('getCell', id,'DeployedServers'); //No I18N
				if (depser.indexOf("Multiple")!=-1)
				{
                                    redirectUrl("SSLMgmt/deployedsevers/"+hostId);//NO I18N
				}
                        }                        
      			else if (onSelectFunction === "certDetails" && colMod[col].name === "History")
			{
				var hostId = grid.jqGrid('getCell', id,'ResourceID'); //No I18N
				if (hostId !== null && hostId !== "")
				{
                                    redirectUrl("SSLMgmt/History/"+hostId);//No I18N
				}
                        }
                        else if (onSelectFunction === "certDetails" && colMod[col].name === "DeployedServers")
			{
                                var hostId = grid.jqGrid('getCell', id,'ResourceID'); //No I18N
                                var certName = grid.jqGrid('getCell', id,'Common Name'); //No I18N
				if (hostId !== null && hostId !== "")
				{
                                    App.InventoryListDetailsController.cert_id=hostId;
                                    App.InventoryListDetailsController.cert_name=certName;
				}
                        }
                        else if (onSelectFunction === "certHistory" && colMod[col].name === "Export")
			{
//				var verId = grid.jqGrid('getCell', id,'VersionID'); //No I18N
//				if (verId !== null && verId !== "")
//				{
//                                    var ajaxRequestUrl = '/api/pki/Inventory/exportCertVersion?certVersionId=' +verId ; //No I18N
//                                    exportCert(ajaxRequestUrl);
//				}
                        }
                        else if (onSelectFunction === "certHistory" && colMod[col].name === "deploy")
			{
				var verId = grid.jqGrid('getCell', id,'VersionID'); //No I18N
				if (verId !== null && verId !== "")
				{
                                    var commonName = grid.jqGrid('getCell',id,'CommonName');//NO I18N
                                    App.InventoryListDetailsController.certVersionId=verId;
                                    App.InventoryListDetailsController.cert_name=commonName;
				}
                        }
                        else if((onSelectFunction === "RequestState" && colMod[col].name === "SubDomain") ||(onSelectFunction === "RequestState" && colMod[col].name === "Status"))
			{
				var req_Id = grid.jqGrid('getCell', id,'REQUESTID'); //No I18N
                                /*var status = grid.jqGrid('getCell', id,'Status'); //No I18N
                                if(status==="Closed")
				{
                                    goToPKICertCloseState(req_Id);
                                }
				else if (req_Id !== null && req_Id !== "")
				{
                                    goToPKICertReqState(req_Id);
				}*/
                                App.RequestCertController.req_id=req_Id;
                        }
                        else if (onSelectFunction === "LetsEncryptList" && colMod[col].name === "STATUS")
			{
                            var req_id = grid.jqGrid('getCell',id,'REQUEST_ID');//NO I18N
                            var status = grid.jqGrid('getCell',id,'STATUS');//NO I18N
                            if($(status).text()==="Pending")
                            {
                                showChallengesPage(req_id);
                            }
                        }
                        else if(onSelectFunction === "LetsEncryptList" && colMod[col].name === "CERT_STATUS")
                        {
                            var status = grid.jqGrid('getCell',id,'CERT_STATUS');//NO I18N
                            var req_id = grid.jqGrid('getCell',id,'REQUEST_ID');//NO I18N
                            status = $(status).text();
                            if(status === "Available" || status==="Renewed")
                            {
                                vConfirmation(I18N.getMsg("letsencrypt.savecertificate.confirm"),function(){//NO I18N
                                    var params="req_id="+req_id;//NO I18N 
                                    saveLetsEncryptCertificate(params);
                                });
                            }
                        }
                        else if(onSelectFunction === "GoDaddyRequestsList" && colMod[col].name === "Status")
                        {
                            var auth = grid.jqGrid('getCell',id,'AUTHORIZATION');//NO I18N
                            var req_id = grid.jqGrid('getCell',id,'ID');//NO I18N                            
                            if(auth === "no")
                            {
                                vConfirmation(I18N.getMsg("letsencrypt.savecertificate.confirm"),function(){//NO I18N
                                    var params="order_id="+req_id;//NO I18N 
                                    saveGoDaddyCertificate(params);
                                });
                            }
                        }
                        else if(onSelectFunction === "LetsEncryptList" && colMod[col].name==="DOMAINS")
                        {
                            var certificate = grid.jqGrid('getCell',id,'CERTIFICATE');//NO I18N
                            var req_id = grid.jqGrid('getCell',id,'REQUEST_ID');//NO I18N
                            if(certificate === "yes")
                            {
                                App.RequestCertController.req_id=req_id;
                                document.getElementById("showCertificate").click();
                            }                            
                        }
                        else if (onSelectFunction === "LetsEncryptList" && colMod[col].name === "History")
			{
				var req_id = grid.jqGrid('getCell',id,'REQUEST_ID');//NO I18N
                                var certificate = grid.jqGrid('getCell',id,'CERTIFICATE');//NO I18N
                                if(certificate ===  'yes')
                                {
                                    redirectUrl("SSLMgmt/letsHistory/"+req_id);//No I18N
                                }
                        }
                        else if (onSelectFunction === "GoDaddyRequestsList" && colMod[col].name === "History")
			{
				var req_id = grid.jqGrid('getCell',id,'ID');//NO I18N
                                var history = grid.jqGrid('getCell',id,'History_Status');//NO I18N
                                if(history ===  'yes')
                                {
                                    redirectUrl("SSLMgmt/godaddyHistory/"+req_id);//No I18N
                                }
                        }
                        else if( onSelectFunction === "LetsEncryptList" && colMod[col].name ==="deploy")
                        {
                            var req_id=grid.jqGrid('getCell',id,'REQUEST_ID');//NO I18N
                            var domains = grid.jqGrid('getCell',id,'DOMAINS');//NO I18N
                            domains=$(domains).text();
                            deployCertificate(req_id,domains);
                        }
                        else if ( onSelectFunction === "LetsEncryptChallenges" && colMod[col].name === 'agentFormatter')
                        {
                            var domain = grid.jqGrid('getCell',id,'domain');//NO I18N
                            var challengeType = grid.jqGrid('getCell',id,'challengeType');//NO I18N
                                App.RequestCertController.domain=domain;
                                App.RequestCertController.sdomain="";
                                App.RequestCertController.challengeType=challengeType;
                                App.RequestCertController.mapping_id="";   
                                App.RequestCertController.agentid="";
                                App.RequestCertController.dns_server="";
                                App.RequestCertController.edit=false;
                                document.getElementById("agentConf").click();
                            }
                        else if ( onSelectFunction === "LetsEncryptChallenges" && colMod[col].name === 'newRequestFormatter')
                        {
                            var domainName = grid.jqGrid('getCell',id,'domain');//NO I18N
                            var challengeId = grid.jqGrid('getCell',id,'challengeId');//NO I18N
                            getNewChallenge(domainName,challengeId);
                        }
                        else if(onSelectFunction === "LetsEncryptChallenges" && colMod[col].name === "deployStatus")
                        {
                            var domainName = grid.jqGrid('getCell',id,'domain');//NO I18N
                            var challengeId = grid.jqGrid('getCell',id,'challengeId');//NO I18N
                            var status = grid.jqGrid('getCell',id,'status');//NO I18N
                            var challengeType = grid.jqGrid('getCell',id,'challengeType');//NO I18N
                            if(status === "pending")
                            {
                            showDomainDeployStatus(domainName,challengeId,challengeType);
                        }
                        }
                        else if( onSelectFunction === "DeployStatus" && colMod[col].name === "deploy")
                        {
                            var challengeId = grid.jqGrid('getCell',id,'challengeId');//NO I18N
                            var agentId = grid.jqGrid('getCell',id,'agentId');//NO I18N
                            var osType = grid.jqGrid('getCell',id,'osType');//NO I18N
                            var domain = grid.jqGrid('getCell',id,'domain');//NO I18N
                            var challengeType = grid.jqGrid('getCell',id,'challengeType');//NO I18N 
                            var dns_server = grid.jqGrid('getCell',id,'dns_server');//NO I18N
                            deployChallengeFile(challengeId,agentId,osType,domain,challengeType,dns_server);
                        }
                        else if(onSelectFunction === "LetsEncryptDeployMapping" && colMod[col].name === 'EditMapping')
                        {
                            var domain = grid.jqGrid('getCell',id,'Domain_Names');//NO I18N
                            var agentId = grid.jqGrid('getCell',id,'Agent_ID');//NO I18N
                            var challengeType = grid.jqGrid('getCell',id,'ChallengeType');//NO I18N
                            var dns_server = grid.jqGrid('getCell',id,'dns_server');//NO I18N
                            App.RequestCertController.sdomain=domain;
                            App.RequestCertController.agentid=agentId;
                            App.RequestCertController.edit=true;
                            App.RequestCertController.challengeType=challengeType;
                            App.RequestCertController.dns_server=dns_server;
                            App.RequestCertController.mapping_id=grid.jqGrid('getCell',id,'Mapping_ID');//NO I18N
                            document.getElementById("addDomainMappingHidden").click();
                        }
                        else if(onSelectFunction === "LetsEncryptChallenges" && colMod[col].name==="challengeContent")
                        {
                            var text = grid.jqGrid('getCell',id,'challengeContent');//NO I18N
                            var textarea = document.createElement("textarea");
                            textarea.id="copyelement";
                            textarea.setAttribute("type","hidden");
                            document.querySelector("body").appendChild(textarea);//NO I18N
                            var tarea = document.getElementById("copyelement");
                            tarea.value=text;
                            tarea.select();
                            if(document.execCommand('copy'))
                            {
                                messageNotification("messageNotifySuccess",I18N.getMsg("copied.to.clipboard"));//No I18N
                            }
                            document.querySelector("body").removeChild(textarea);//NO I18N
                        }
                        else if(onSelectFunction === "LetsEncryptChallenges" && colMod[col].name==="challengeContentPath")
                        {
                            var text = grid.jqGrid('getCell',id,'challengeContentPath');//NO I18N
                            var textarea = document.createElement("textarea");
                            textarea.id="copyelement";
                            textarea.setAttribute("type","hidden");
                            document.querySelector("body").appendChild(textarea);//NO I18N
                            var tarea = document.getElementById("copyelement");
                            tarea.value=text;
                            tarea.select();
                            if(document.execCommand('copy'))
                            {
                                messageNotification("messageNotifySuccess",I18N.getMsg("copied.to.clipboard"));//No I18N
                            }
                            document.querySelector("body").removeChild(textarea);//NO I18N
                        }
                        else if (onSelectFunction === "GeneratedCertList" && colMod[col].name === "DOMAIN_NAME")
			{
				var newCertId = grid.jqGrid('getCell', id,'NEWCERTID'); //No I18N
                                if(newCertId!==null && newCertId !=="")
                                {
                                    App.RequestCertController.newCertId=newCertId;
                                }
                        }
                        else if (onSelectFunction === "GeneratedCertList" && colMod[col].name === "Import")
			{
				var newCertId = grid.jqGrid('getCell', id,'NEWCERTID'); //No I18N
                                if(newCertId!==null && newCertId !=="")
                                {
                                    App.RequestCertController.newCertId=newCertId;
                                }
                        }
                        else if (onSelectFunction === "GeneratedCertList" && colMod[col].name === "Export")
			{
				var newCertId = grid.jqGrid('getCell', id,'NEWCERTID'); //No I18N
                                if(newCertId!==null && newCertId !=="")
                                {
                                    App.RequestCertController.newCertId=newCertId;
                                    var ajaxRequestUrl = '/api/pki/request/exportCreatedCert?createdCertId=' + App.RequestCertController.newCertId; //No I18N
                                    exportCert(ajaxRequestUrl);
                                }
                        }
                        else if (onSelectFunction === "GeneratedCertList" && colMod[col].name === "EMAIL")
			{
				var newCertId = grid.jqGrid('getCell', id,'NEWCERTID'); //No I18N
                                if(newCertId!==null && newCertId !=="")
                                {
                                    App.RequestCertController.newCertId=newCertId;
                                }
                        }
                        else if ((onSelectFunction === "SSHResources" || onSelectFunction === "AllResources") && colMod[col].name === "Edit")
			{
                            if (kmpStandAlone)
                            {
                                var res_Id = grid.jqGrid('getCell', id, 'ResourceID'); //No I18N
                                var res_name = grid.jqGrid('getCell', id, 'ResourceName'); //No I18N
                                var type = grid.jqGrid('getCell', id, 'ResourceType'); //No I18N
                                if (type === 'ssh' || type === 'both')
                                {
                                    App.ApplicationController.res_id = res_Id;
                                document.getElementById("show_cred").click();
                                //showCredentialView(res_Id,res_name);
                        }
                        }
                        }
                        else if ((onSelectFunction === "SSHResources" || onSelectFunction === "AllResources") && colMod[col].name === "SSH")
			{
                            var res_Id = grid.jqGrid('getCell', id,'ResourceID'); //No I18N
                            var type = grid.jqGrid('getCell', id,'ResourceType'); //No I18N
                            var isCredent = grid.jqGrid('getCell', id,'Edit'); //No I18N
                            if (res_Id !== null && res_Id !== "" /*&& isCredent=='enabled'*/)
                            {
                                showResourceUsersDialog(res_Id);
                            }
                        }
                        else if(onSelectFunction === "UsersGroup" && colMod[col].name === "GROUP NAME")
                        {
                            var ugid = grid.jqGrid('getCell', id,'GROUP ID'); //No I18N
                            var groupname = grid.jqGrid('getCell',id,'GROUP NAME');//NO I18N
                            App.SettingsUserController.kGroupId=ugid;
                            sessionStorage.setItem("groupname",groupname);//No I18N
                            redirectUrl("SSHMgmt/usersGroupUsers/"+ugid);//No I18N
                        }
                        else if(onSelectFunction === "UsersGroup" && colMod[col].name === "Edit")
                        {
                            var ugid = grid.jqGrid('getCell', id,'GROUP ID'); //No I18N
                            redirectUrl("SSHMgmt/addUsersGroup/"+ugid);//No I18N
                        }
                        else if(onSelectFunction === "UsersGroup" && colMod[col].name === "EditPath")
                        {
                            var ug_id = grid.jqGrid('getCell', id, 'GROUP ID'); //No I18N
                            var ug_name= grid.jqGrid('getCell',id,'GROUP NAME');//NO I18N
                            App.SettingsCommonController.uGroup=true;
                            App.SettingsCommonController.user_id=ug_id;
                            App.SettingsCommonController.uGroupName=ug_name;
                            document.getElementById("editPath").click();
                        }
                        else if(onSelectFunction === "KeysGroup" && colMod[col].name === "GROUP NAME")
                        {
                            var kgid = grid.jqGrid('getCell', id,'GROUP ID'); //No I18N
                            var groupname = grid.jqGrid('getCell',id,'GROUP NAME');//NO I18N
                            App.SettingsUserController.kGroupId=kgid;
                            sessionStorage.setItem("groupname",groupname);//No I18N
                            redirectUrl("SSHMgmt/keysGroupKeys/"+kgid);//No I18N
                        }
                        else if(onSelectFunction === "KeysGroup" && colMod[col].name === "Edit")
                        {
                            var kgid = grid.jqGrid('getCell', id,'GROUP ID'); //No I18N
                            redirectUrl("SSHMgmt/addKeysGroup/"+kgid);//No I18N
                        }
                        else if (onSelectFunction === "ResourceGroup" && colMod[col].name === "Edit")
			{
                            var rgid = grid.jqGrid('getCell', id,'GROUP_ID'); //No I18N
                            location.href=window.apiclientUrl+"SSHMgmt/addResourceGroup/"+rgid;
                        }
                        else if(onSelectFunction === "ResourceGroup" && colMod[col].name === "EditPath")
                        {
                            var rg_id = grid.jqGrid('getCell', id, 'GROUP_ID'); //No I18N
                            var rgname = grid.jqGrid('getCell',id,'GROUP_NAME');//NO I18N
                            App.SettingsCommonController.rGroup=true;
                            App.InventoryController.res_Id=rg_id;
                            App.InventoryController.rGroupName=rgname;
                            document.getElementById("editPath").click();
                        }
                        else if (onSelectFunction === "ResourceGroup" && colMod[col].name === "GROUP_NAME")
			{
                            var groupname=grid.jqGrid('getCell',id,'GROUP_NAME');//No I18N
                            sessionStorage.setItem("groupname",groupname);//No I18N
                            var rgid = grid.jqGrid('getCell', id,'GROUP_ID'); //No I18N
                            redirectUrl("SSHMgmt/resourceList/"+rgid);//No I18N
                        }
                        else if (onSelectFunction === "SSLGroup" && colMod[col].name === "GROUP_NAME")
			{
                            var groupname=grid.jqGrid('getCell',id,'GROUP_NAME');//No I18N
                            sessionStorage.setItem("groupname",groupname);//No I18N
                            var rgid = grid.jqGrid('getCell', id,'GROUP_ID'); //No I18N                            
                            redirectUrl("SSLMgmt/certificatesList/"+rgid);//No I18N
                        }
                        else if (onSelectFunction === "SSLGroup" && colMod[col].name === "Edit")
			{
                            var rgid = grid.jqGrid('getCell', id,'GROUP_ID'); //No I18N
                            redirectUrl("SSLMgmt/AddCertificateGroup/"+rgid);//No I18N
                        }
                        else if (onSelectFunction === "getresources" && colMod[col].name === "ResourceName")
                        {
                            var res_Id = grid.jqGrid('getCell', id,'ResourceID'); //No I18N                            
				if (res_Id !== null && res_Id !== "")
				{
                                    showAssociateMapper(res_Id);
                                }
                        }        
                        else if(onSelectFunction === "SSHKeyAssociate" && colMod[col].name === "placeKey")
                        {
                            var check = grid.jqGrid('getCell',id,'keyLink');//NO I18N
                            var key_id = grid.jqGrid('getCell', id,'KeyID'); //No I18N
                            var keyName = grid.jqGrid('getCell',id,'KeyName');//NO I18N
                            if(check === "true")
                            {
                                 App.SettingsCommonController.id=id;
                                 App.SettingsCommonController.key_id=key_id;
                                 App.SettingsCommonController.keyName=keyName;
                                 document.getElementById("placeKey").click();
                            }
                        }
                        else if (onSelectFunction === "SSHKeyAssociate" && colMod[col].name === "KeyName")
                        {
                            var key_id = grid.jqGrid('getCell', id,'KeyID'); //No I18N                            
                            App.SettingsCommonController.keyName=grid.jqGrid('getCell', id,'KeyName'); //No I18N
				if (key_id !== null && key_id !== "")
				{
                                    //showAssociateMapper(key_id);
                                }
                        }        
                        else if (onSelectFunction === "SSHKeyAssociate" && colMod[col].name === "Export")
                        {
                            var key_id = grid.jqGrid('getCell', id,'KeyID'); //No I18N                            
				if (key_id !== null && key_id !== "")
				{
                                    exportSshKey(key_id);
                                }
                        }     
                        else if(onSelectFunction === "LetsEncryptAccount" && colMod[col].name === "Export")
                        {
                            var account_id = grid.jqGrid('getCell',id,'ACCOUNT_ID');//NO I18N
                            exportAccountKey(account_id);
                        }
                        else if (onSelectFunction === "scheduledetails" && colMod[col].name === "SCHEDULE_NAME")
                        {
                            var schedule_id = grid.jqGrid('getCell', id,'SCHEDULE_ID'); //No I18N
				if (schedule_id !== null && schedule_id !== "")
				{
                                    updateSchedule(schedule_id);
                                }
                        }
                        else if (onSelectFunction === "scheduleAudit" && colMod[col].name === "Execution Result" && grid.jqGrid('getCell',id,'Execution Result').toLowerCase() !=="success")
                        {
                            var scheduleAudit_id = grid.jqGrid('getCell', id,'SCHEDULEAUDIT_ID'); //No I18N
                            var reportType = grid.jqGrid('getCell', id,'ReportType'); //No I18N
                            displayScheduleReportpdf(scheduleAudit_id,reportType);
                        }
                        else if (onSelectFunction === "discoveryAudit" && colMod[col].name === "Resource(s)")
                        {
                            var status=grid.jqGrid('getCell', id,'Discovery_Status'); //No I18N
                            if(status!=='Inprogress' && status!=='Failure')
                            {
                            var discoveryAudit_id = grid.jqGrid('getCell', id,'DISCOVERYAUDIT_ID'); //No I18N
				if (discoveryAudit_id !== null && discoveryAudit_id !== "")
				{
                                        redirectUrl("Discovery/DetailedAuditDiscovery/"+discoveryAudit_id);   //No I18N
                                }
                        }
                        }
                       else if (onSelectFunction === "AllResourceUsers" && colMod[col].name === "isCredAvailable")
                        {
                            if(kmpStandAlone)
                            {
                            var user_id = grid.jqGrid('getCell', id,'UserID'); //No I18N
                            App.SettingsCommonController.isCredentialAvailable=grid.jqGrid('getCell', id,'isCredAvailable'); //No I18N
				if (user_id !== null && user_id !== "")
				{
                                    App.SettingsCommonController.user_id=user_id;
                                    App.SettingsCommonController.isSingleCredential=true;
                                    document.getElementById("showcred").click();
                                }
                        }
                        }
                        else if(onSelectFunction === "AllResourceUsers" && colMod[col].name === "EditPath")
                        {
                            var user_id = grid.jqGrid('getCell', id,'UserID'); //No I18N
                            var path = grid.jqGrid('getCell',id,'Dir_Path');//NO I18N
                            if (user_id !== null && user_id !== "")
                            {
                                App.SettingsCommonController.user_id=user_id;
                                App.SettingsCommonController.dir_path=path;
                                document.getElementById("editPath").click();
                            }
                            
                        }
                        else if(onSelectFunction === "AllResourceUsers" && colMod[col].name==="EditAuthFile")
                        {
                            var user_id = grid.jqGrid('getCell', id,'UserID'); //No I18N
                            App.SettingsCommonController.user_id=user_id;
                            getKeyAuthFile();
                        }
                        else if(onSelectFunction === "AllResourceUsers" && colMod[col].name === "AuthFile")
                        {
                            var check = grid.jqGrid('getCell',id,'isDissociate');//NO I18N
                            if(check === "true")
                            {
                            var user_id = grid.jqGrid('getCell', id,'UserID'); //No I18N
                            App.SettingsCommonController.user_id=user_id;
                            document.getElementById("editAuthFile").click();
                            }
                        }
                       else if (onSelectFunction === "AllResourceUsers" && colMod[col].name === "terminal")
                        {
                            var user_id = grid.jqGrid('getCell', id,'UserID'); //No I18N
                            var connect = grid.jqGrid('getCell', id,'terminal'); //No I18N
                            if (user_id !== null && user_id !== "" && connect==="true")
                            {
                                openTerminal(user_id);
                            }
                        }
                        else if(onSelectFunction === "AllResourceUsers" && colMod[col].name === "isDissociate")
                        {
                            var check = grid.jqGrid('getCell',id,'isDissociate');//NO I18N
                            var user_id = grid.jqGrid('getCell', id,'UserID'); //No I18N
                            if(check === "true")
                            {
                                 App.SettingsCommonController.user_id=user_id;
                                 document.getElementById("deAssociate").click();
                            }
                            
                        }
                        else if (onSelectFunction === "auditdetailslist" && colMod[col].name === "OPERATIONTYPE")
                        {
                            var audit_id = grid.jqGrid('getCell', id,'AUDITID'); //No I18N
                            var audit_type = grid.jqGrid('getCell', id,'OPERATIONTYPE'); //No I18N
                            if (audit_type.indexOf("Terminal")!=-1)
				{
                                //openTerminalAudit(audit_id);
                                }
                        }
                        else if (onSelectFunction === "terminalAuditlist" && colMod[col].name === "Status")
                        {
                            var audit_id = grid.jqGrid('getCell', id,'TERMINAL AUDITID'); //No I18N
                            var audit_type = grid.jqGrid('getCell', id,'Status'); //No I18N
                            if (audit_type.indexOf("Success")!=-1)
                            {
                                App.AuditCommonController.terminal_audit_id=audit_id;
                                document.getElementById("terminalReportShow").click();
                            }
                        }
                         else if (onSelectFunction === "SSHKeyAssociateAudit" && colMod[col].name === "Key_Name")
                        {
                            var keyRotationAuditId = grid.jqGrid('getCell', id,'KeyRotationAuditId'); //No I18N
                            App.SettingsCommonController.keyName=grid.jqGrid('getCell', id,'Key_Name'); //No I18N
				if (keyRotationAuditId !== null && keyRotationAuditId !== "")
				{
                                    //displayKeyRotationAuditStatus(keyRotationAuditId);
                                    redirectUrl("SSHMgmt/DetailedKeyRotationAudit/"+keyRotationAuditId);//No I18N
                                }
                        }
                        else if (onSelectFunction === "SSHUserAssociateToKey" && colMod[col].name === "Connect")
                        {
                            var user_id = grid.jqGrid('getCell', id,'UserID'); //No I18N
				if (user_id !== null && user_id !== "")
				{
                                    openTerminal(user_id,App.SettingsUserController.key_id);
                                }
                        }
                        else if (onSelectFunction === "keyRotationReportlist" && colMod[col].name === "Key_Name")
                        {
                                grid.jqGrid('toggleSubGridRow',id);//NO I18N
                        }
                        else if(onSelectFunction === "LandignServerReport" && colMod[col].name === "ServerName")
                        {
                            grid.jqGrid('toggleSubGridRow',id);//NO I18N
                        }
                        else if(onSelectFunction === "SSLVulnerabilitiesReport" && colMod[col].name === "Common Name")
                        {
                            grid.jqGrid('toggleSubGridRow',id);//NO I18N
                        }
                        else if(onSelectFunction === "SSLVulnerabilitiesSubGrid" && colMod[col].name === "CommonName")
                        {
                            grid.jqGrid('toggleSubGridRow',id);//NO I18N
                        }
                        else if (onSelectFunction === "sslwildcardCertificateReport" && colMod[col].name === "Common Name")
                        {
                                grid.jqGrid('toggleSubGridRow',id);//NO I18N
                        }
                        else if (onSelectFunction === "EncryptionKey" && colMod[col].name === "Export")
                        {
                            var key_id = grid.jqGrid('getCell', id,'EncKeyID'); //No I18N                            
				if (key_id !== null && key_id !== "")
				{
                                    exportEncryptionKey(key_id);
                                }
                        }  
                        else if (onSelectFunction === "EncryptionKey" && colMod[col].name === "Update")
                        {
                            var key_id = grid.jqGrid('getCell', id,'EncKeyID'); //No I18N 
                             var encKeyName = grid.jqGrid('getCell', id,'Key Name'); //No I18N 
				if (key_id !== null && key_id !== "")
				{
                                    App.EncryptionKeysCommonController.encKeyName=encKeyName;
                                    App.EncryptionKeysCommonController.isEncryptionKeyAdd=false;
                                }
                        }  
                        else if (onSelectFunction === "EncryptionKey" && colMod[col].name === "Version")
                        {
                            var key_id = grid.jqGrid('getCell', id,'EncKeyID'); //No I18N 
                             var encKeyName = grid.jqGrid('getCell', id,'Key Name'); //No I18N 
				if (key_id !== null && key_id !== "")
				{
                                    App.EncryptionKeysCommonController.encKeyName=encKeyName;
                                    location.href= window.apiclientUrl+"EncryptionKeys/History/"+key_id; //No I18N
                                }
                        }  
                        else if (onSelectFunction === "EncryptionKey" && colMod[col].name === "Key Name")
                        {
                            var key_id = grid.jqGrid('getCell', id,'EncKeyID'); //No I18N 
                            if (key_id !== null && key_id !== "")
				{
                                    App.EncryptionKeysCommonController.encKeyId=key_id;
                                    App.EncryptionKeysCommonController.encKeyName=encKeyName;
                                    App.EncryptionKeysCommonController.isEncKeyVersionContentDisplay=false;
                                }
                        }  
                        else if (onSelectFunction === "EncryptionKeyHistory" && colMod[col].name === "Export")
                        {
                            var encKeyVersionID = grid.jqGrid('getCell', id,'EncKeyVersionID'); //No I18N 
                             var version = grid.jqGrid('getCell', id,'Version'); //No I18N 
				if (encKeyVersionID !== null && encKeyVersionID !== "")
				{
                                    App.EncryptionKeysCommonController.versionNumber=version;
                                    exportEncryptionKeyVersion(encKeyVersionID);
                                }
                        }  
                        else if (onSelectFunction === "EncryptionKeyHistory" && colMod[col].name === "Version")
                        {
                            var encKeyVersionID = grid.jqGrid('getCell', id,'EncKeyVersionID'); //No I18N 
				if (encKeyVersionID !== null && encKeyVersionID !== "")
				{
                                    App.EncryptionKeysCommonController.encKeyId=encKeyVersionID;
                                    App.EncryptionKeysCommonController.isEncKeyVersionContentDisplay=true;
                                }
                        }  
		},
                onPaging: function () {
                    if(!kmpStandAlone)
                    {
                    var newNum=$(".ui-pg-selbox").val();
                    $("#rn_"+newNum).addClass("pointer");
                    }
                },
		loadComplete: function () {	
			if(defaultOptions.showAll===true)
			{
				var $grid=$('#'+defaultOptions.tableName)
	    		var subGridOptions = $grid.jqGrid("getGridParam", "subGridOptions"), //No I18N
	    	    plusIcon = subGridOptions.plusicon,
	    	    minusIcon = subGridOptions.minusicon,
	    	    expandAllTitle = "Expand all subgrids", //No I18N
	    	    collapseAllTitle = "Collapse all subgrids"; //No I18N
		    	$("#jqgh_" + $grid[0].id + "_subgrid") //No I18N
		    	    .html('<a style="cursor: pointer;"><span class="ui-icon ' + plusIcon + //No I18N
		    	          '" title="' + expandAllTitle + '"></span></a>') //No I18N
		    	    .click(function () {
		    	        var $spanIcon = $(this).find(">a>span"), //No I18N
		    	            $body = $(this).closest(".ui-jqgrid-view") //No I18N
		    	                .find(">.ui-jqgrid-bdiv>div>.ui-jqgrid-btable>tbody"); //No I18N
		    	        if ($spanIcon.hasClass(plusIcon)) {
		    	            $spanIcon.removeClass(plusIcon)
		    	                .addClass(minusIcon)
		    	                .attr("title", collapseAllTitle); //No I18N
		    	            $body.find(">tr.jqgrow>td.sgcollapsed") //No I18N
		    	                .click();
		    	        } else {
		    	            $spanIcon.removeClass(minusIcon)
		    	                .addClass(plusIcon)
		    	                .attr("title", expandAllTitle); //No I18N
		    	            $body.find(">tr.jqgrow>td.sgexpanded") //No I18N
		    	                .click();
		    	        }
		    	    });
			}
			
                        //Customized paging
                    if(!kmpStandAlone)
                    {
			var $this = $(this);//No I18N
                        var newNum=25;
                        $('.myPager').remove();
                        var myRowListChange = function(e) {
                            newNum = $(e.target).text();
                            grid.jqGrid('setGridParam', { rowNum: newNum, page: 1 }); //No I18N
//                            var totCount=grid.getGridParam('records');
//                            var curPage=$('input.ui-pg-input').val();
//                            if(curPage*newNum>totCount)
//                            {
                                grid.jqGrid('setGridParam', { page: 1 }); //No I18N
                                $(".ui-pg-selbox").val(newNum);
//                            }
                            grid.trigger("reloadGrid"); //No I18N
                            $("#rn_"+newNum).addClass("pointer");
                            e.preventDefault();
                        };
                        $(".ui-pg-selbox").hide();
                        var link = $('<a>', { href:'#', click:myRowListChange, id:'rn_25'});
                        link.text("25");
                        var pagerNextTD = $('<td class="myPager">', { });
                        pagerNextTD.append(link);
                        pagerNextTD.append('<span>,&nbsp;</span>'); //No I18N
                        link = $('<a>', { href:'#', click:myRowListChange, id:'rn_50' });
                        link.text("50");
                        pagerNextTD.append(link);
                        pagerNextTD.append('<span>,&nbsp;</span>');//No I18N
                        link = $('<a>', { href:'#', click:myRowListChange , id:'rn_75'});
                        link.text("75");
                        pagerNextTD.append(link);
                        pagerNextTD.append('<span>,&nbsp;</span>');//No I18N
                        link = $('<a>', { href:'#', click:myRowListChange , id:'rn_100'});
                        link.text("100");
                        pagerNextTD.append(link);
                        $("#last_t_"+gridTableIdAlone+"_toppager").after(pagerNextTD);                        
                        $('input.ui-pg-input').prop( "disabled", true );
		}
		}
	});
	if (gridNavigator !== null || gridNavigator !== undefined || gridNavigator !== "")
		{
			//grid.jqGrid('navGrid', gridNavigator ,{ add: false, edit: false, del: false }); //No I18N
			grid.jqGrid('navGrid', gridNavigator ,{ add: addIcon, edit: false, del: delIcon ,search:false, refresh:false,//No I18N
					addfunc: function(rowid)
					{
						
					 },
					 delfunc: function(rowid){
					  var rows = (""+rowid).split(',');

					  	var dataStr = new Array();
					  	var name = "";
					 	if (rows.length > 0 && apiUrl != "")
						{
	                       
	                        if(confirm(delMsg))
							{

		                        for(var r in rows)
		                        {
		                            var ret = grid.jqGrid('getRowData', rows[r]);
		                            if(ret[deleteName] !== undefined)
		                            {
												/*if(r != 0)
												dataStr += ","+ret[deleteName];
												else
												dataStr += ret[deleteName];*/
											dataStr.push(ret[deleteName]);
									}		
	                            
	                        	}

	                        		 if(dataStr.length > 0)
	                        		 {
	                        		 	name = dataStr.toString();
	                        		 	var url = "";
	                        		 	if(deviceName === "" && deviceNameParameter === "") {
	                        		 		url = apiUrl+"apiKey="+apiKey+"&"+urlParameter+"="+name;//No I18N
	                        		 	}
	                        		 	
	                        		 	else {
	                        		 		url = apiUrl+"apiKey="+apiKey+"&"+deviceNameParameter+"="+deviceName+"&"+urlParameter+"="+name; //No I18N
	                        		 	}
	                        		$.ajax({
											url: url, //No I18N
											type: 'POST', //No I18N
											success: function(response){
													var obj = response;
													var message = ""; //No I18N
													document.getElementById('resDiv').style.display = 'block'; //No I18N

													if (obj.error !== undefined)
													{
														document.getElementById('resDiv').style.backgroundColor = '#FF0000';					
														message = obj.error.message;
													}
													if (obj.result !== undefined)
													{
														document.getElementById('resDiv').style.backgroundColor = '#00FF00';
														message = obj.result.message;
													}
													document.getElementById('resDiv').innerHTML = message;
													$("#resDiv").fadeOut(5000);

										              location.reload();
										        	  },
                                    error: function (error) {
                                            if (error.status === 400)
                                            {
                                                messageNotification("messageNotifyFailure", I18N.getMsg("js.commonstr.Harmfulcontententered"));//No I18N
										        	  } 
                                    } 
													
												});	
	                        	}
	                        	
                   	 }
                }

            }
               },
				{ /* edit options */ },{ /* add options */ },{ /* delete options */ },{ /* search options */
					sopt: ['eq', 'ne','bw','ew','cn', 'nc'] //No I18N
				}); //No I18N
		}
	}
	if(searchOption)
	{
		$(gridTable).jqGrid('filterToolbar',{ stringResult: true, searchOnEnter: false, defaultSearch: 'cn'});
		//$(gridTable)[0].toggleToolbar();
                $(".ui-search-toolbar").hide();
                $(".icon-search-alone").click(function(){
                        if(innerDiv == undefined && innerDiv !== true)
                        {
                            showSearchField();
                        }
                    app.toggleToolbar();
                    if ($.isFunction(app.p._complete)) {
                        if ($('.ui-search-toolbar', app.grid.hDiv).is(':visible'))
                        {
                            $('.ui-search-toolbar', app.grid.fhDiv).show();
                        } else {
                            $('.ui-search-toolbar', app.grid.fhDiv).hide();
                        }
                        app.p._complete.call(app);
                        fixPositionsOfFrozenDivs.call(app);
                    }
                    $(gridTable).setGridWidth($(gridDivId).width(), true);
                });
	}
        if(defaultOptions.sortName!=undefined)
        {
            grid.jqGrid().trigger('reloadGrid');//NO I18N
        }
        if (innerDiv == undefined && innerDiv !== true)
        {
                jQuery('.ui-jqgrid-bdiv').css({'max-height': height, "height": ""});//No I18N
                resizeJqGridWidth(gridTable, gridDivId);
            }
        if(!kmpStandAlone)
        {
            var dgremove="#alertmod_"+gridTableIdAlone;//No I18N
            jQuery(dgremove).remove();
            $("#rn_25").addClass("pointer");
        }
        if (countOfRows == 0) {
                $(".ui-jqgrid-bdiv").prepend('<div class="noRowMsg">'+I18N.getMsg("js.tablegrid.noRecordstoview")+'</div>');//No I18N
                $("#sp_1_"+gridTableIdAlone+"_toppager").text("1");//NO I18N
        } else 
        {
            if(onSelectFunction!=="SSLEndPointSummary")
            {
                $('.ui-jqgrid-bdiv').slimscroll({
                    railVisible: true,
                    railBorderRadius: 0,
                    railOpacity: 0.1
                });
                $(".slimScrollBar").hide();
            }
        }
         $(".ui-icon").removeClass("ui-icon");        
         $(".ui-icon-seek-first").addClass("glyphicon glyphicon-backward");        
         $(".ui-icon-seek-prev").addClass("glyphicon glyphicon-chevron-left");        
         $(".ui-icon-seek-next").addClass("glyphicon glyphicon-chevron-right");        
         $(".ui-icon-seek-end").addClass("glyphicon glyphicon-forward");
}

function resizeJqGridWidth(grid_id,resizeid)
{
    $(window).bind('resize', function() {//NO I18N
        $(grid_id).setGridWidth($(resizeid).width(), true); //Back to original width
     }).trigger('resize');//NO I18N
}

function removeDuplicates(array) {
	var uniqueArray = new Array();
	for (var i = 0; i < array.length; i++) {
		if(uniqueArray.indexOf(array[i]) == -1) {
			uniqueArray.push(array[i]);
		}
	}
	array=null;
	return uniqueArray;
}

function messageNotification(divId,content)
{
    $( "#"+divId ).html( content );
    $('#'+divId).show();
    setTimeout(function() { $("#"+divId).fadeOut(1500); }, 2000);
}

function ajaxapicall(ajaxRequestUrl,params,isNotify,successUrl,modal)
{
    disable_EnableButtonAction(true);
    var loading = document.getElementById("mc_loading");
    if(loading!=null && loading!=undefined)
   	{
        loading.className="mcLoading";
   	}
    var ajaxcall=$.ajax({
        url: ajaxRequestUrl,
        type: 'POST',//No I18N
        dataType: 'json',//No I18N
        data : params,
        success: function(jsonData) {
            checkLoginStatus(jsonData);
            if(isNotify)
            {
                if(jsonData.Status==="Success")//NO I18N
                {
                    messageNotification("messageNotifySuccess",I18N.getMsg(jsonData.Message));//No I18N
                    if(successUrl!=="")
                    {
                        redirectUrl(successUrl);//No I18N
                    }
                    else if(modal!=undefined)
                    {
                        modal.send('closeModal');//NO I18N
                }
                }
                else
                {
                    if(jsonData.Message!==undefined)
                    {
                        messageNotification("messageNotifyFailure",I18N.getMsg(jsonData.Message));//No I18N
                    }
                    else
                    {
                        messageNotification("messageNotifyFailure",I18N.getMsg("js.commonstr.operationFailed"));//No I18N
                    }
                }
            }
        },
        error: function (error) {
                if(error.status===400)
            {
                    messageNotification("messageNotifyFailure",I18N.getMsg("js.commonstr.Harmfulcontententered"));//No I18N
                }
                else{
                messageNotification("messageNotifyFailure",I18N.getMsg("js.commonstr.operationFailed"));//No I18N
            }
        },complete : function (){
        	if(loading!=null && loading!=undefined)
           	{
                loading.className="mcLoaded";
           	}
            disable_EnableButtonAction(false);
        }
    });
    return ajaxcall;
}

function disable_EnableButtonAction(disable){
    if(disable){
    	$(".buttn-action").prop('disabled', true);
    	$(".buttn-action").css('cursor','not-allowed');
    }else{
    	$(".buttn-action").removeAttr("disabled");
        $(".buttn-action").css('cursor','pointer');
    }
}

function ajaxRequestWithCookie(ajaxRequestUrl,params,isNotify,successUrl,isgetAjaxApiRequest,callBackFunc)
{
    //csrf="true"
    params=params+"&pmpcp="+Get_Cookie('pmpcc'); //NO I18N
    if(isgetAjaxApiRequest)
    {
    return getAjaxApiRequest(ajaxRequestUrl,params,callBackFunc);
    }
    else{
        return ajaxapicall(ajaxRequestUrl,params,isNotify,successUrl);
    }
}

function getAjaxApiRequest(ajaxRequestUrl,params,callBackFunc)
{
    disable_EnableButtonAction(true);
    var loading = document.getElementById("mc_loading");
    if(loading!=null && loading!=undefined)
   	{
        loading.className="mcLoading";
   	}
    var ajaxcall=$.ajax({
        url: ajaxRequestUrl,
        type: 'POST',//No I18N
        dataType: 'json',//No I18N
        data : params,
        success: function(jsonData) {
            checkLoginStatus(jsonData);
            if(callBackFunc){
            callBackFunc(jsonData);
            }
        },
        error: function (error) {
                if(error.status===400)
                {
                    messageNotification("messageNotifyFailure",I18N.getMsg("js.commonstr.Harmfulcontententered"));//No I18N
        }
                else{
                messageNotification("messageNotifyFailure",I18N.getMsg("js.commonstr.operationFailed"));//No I18N
                }
        },complete : function (){
        	if(loading!=null && loading!=undefined)
           	{
                loading.className="mcLoaded";
           	}
            disable_EnableButtonAction(false);
        }
    });
        return ajaxcall;
}

function getAjaxApiRequestForFile(ajaxRequestUrl,fileData,browse,textfield,defaultSuccessMsg,callBackFunc)
{
    disable_EnableButtonAction(true);
    var loading = document.getElementById("mc_loading");
    if(loading!=null && loading!=undefined)
   	{
        loading.className="mcLoading";
   	}
    $.ajax({
        url: ajaxRequestUrl,
        type: 'POST', //No I18N
        dataType: 'json', //No I18N
        data: fileData,
        cache: false,
        processData: false,
        contentType: false,
        success: function (jsonData) {
            checkLoginStatus(jsonData);
            if (defaultSuccessMsg) {
                if (jsonData.Status.toLowerCase() === "success")
                {
                    if (browse != null && textfield != null)
                    {
                        clearfileElt(browse, textfield);
                    }
                    messageNotification("messageNotifySuccess", I18N.getMsg(jsonData.Message));//No I18N
                } else
                {
                    messageNotification("messageNotifyFailure",I18N.getMsg( jsonData.Message));//No I18N
                }
            }
            if (callBackFunc){
            callBackFunc(jsonData);
            }
        },
        error: function (error) {
            if (error.status === 400)
            {
                if($.trim(error.responseText)!=="")
                {
                    messageNotification("messageNotifyFailure", error.responseText);//No I18N
                }
                else
                {
                messageNotification("messageNotifyFailure", I18N.getMsg("js.commonstr.Harmfulcontententered"));//No I18N
            }
            }
        },complete : function (){
        	if(loading!=null && loading!=undefined)
           	{
                loading.className="mcLoaded";
           	}
            disable_EnableButtonAction(false);
        }
    });
}

var baseContents = {};

function updateSelectObjects(takeFrom,addTo,addToBaseContents)
{
    var opt,i=0;
    if(takeFrom.selectedIndex != -1)
    {
        while(opt = takeFrom.options[i++] )
        {
            if(opt.selected &&(opt.index >=0))
            {
                addTo.options[addTo.options.length] = new Option(opt.text, opt.value, false, false);
                takeFrom.options[--i] = null;
                if(addToBaseContents)
                {
                    baseContents[opt.value] = null;
                    baseContents[opt.value] = opt.text;
                }
                else
                {
                    baseContents[opt.value] = null;
                }
            }
        }
    }
}

var groupContents = {};
var userGroupContents={};
var sslGroupContents={};
//function updateSelectGroups(takeFrom,addTo,addToBaseContents)
//{
//    var opt,i=0;
//    if(takeFrom.selectedIndex != -1)
//    {
//        while(opt = takeFrom.options[i++] )
//        {
//            if(opt.selected &&(opt.index >=0))
//            {
//                addTo.options[addTo.options.length] = new Option(opt.text, opt.value, false, false);
//                takeFrom.options[--i] = null;
//                if(addToBaseContents)
//                {
//                    groupContents[opt.value] = null;
//                    groupContents[opt.value] = opt.text;
//                }
//                else
//                {
//                    groupContents[opt.value] = null;
//                }
//            }
//        }
//    }
//}

function updateSelectGroups(takeFrom,addTo,addToBaseContents,contentArray)
{
    var opt,i=0;
    if(takeFrom.selectedIndex != -1)
    {
        while(opt = takeFrom.options[i++] )
        {
            if(opt.selected &&(opt.index >=0))
            {
                addTo.options[addTo.options.length] = new Option(opt.text, opt.value, false, false);
                takeFrom.options[--i] = null;
                if(addToBaseContents)
                {
                    contentArray[opt.value] = null;
                    contentArray[opt.value] = opt.text;
                }
                else
                {
                    contentArray[opt.value] = null;
                }
            }
        }
    }
}

function copyContents(objContent,toObj)
{
    clearSelectObj(toObj);
    var count = 0;
    for(var value in objContent)
    {
        var text = objContent[value];
        if(text != null)
        {
            toObj.options[count++] = new Option(objContent[value],value,false,false);
        }
    }
}

function clearSelectObj(selectObj)
{
    while(selectObj.options.length > 0)
    {
        selectObj.selectedIndex = 0;
        selectObj.remove(0); 
    }
}

function doFilter(contents,searchStr) 
{
    if(searchStr.length == 0)
	{
        return contents;
	}
    var tempContent = {};
    var text = '';

    for(var value in contents)
    {
        text = contents[value];
        if(text != null)
        {
            text = text.substring(0,searchStr.length);
            text = text.toLowerCase();
            
            if (searchStr.toLowerCase() == text )
            {
                tempContent[value] = contents[value];
            }
        }
    }
    return tempContent;
}

function searchData(contents,showObj,searchStr)
{
    var currentContent = doFilter(contents,searchStr);
    copyContents(currentContent,showObj);
}

function hideSearchBubble(){
	var element = document.getElementById("searchfield");
	if(element.value.indexOf("--Search Devices--") >= 0)
	{
		element.value="";
	}
}
function selectAllElements(selectComp, selected)
{  
    var options = selectComp.options;
    for(var i=0;i<options.length;i++)
    {
    	options[i].selected = selected;
    }
}

function checkLoginStatus(jsonObj)
{
    if(jsonObj.Status!==undefined)
    {
        if(jsonObj.Status==="Login_Failed")
        {
            location.href="/pkilogin/logout.jsp";
        }
    }
}

function showSearchField()
{
    var widpadHeight;
    var gridHeight;
    if(jQuery(".widpad").length>0)
    {
        widpadHeight=jQuery(".widpad").height();//No I18N
        if (!$('.ui-search-toolbar').is(':visible'))
        {
            gridHeight=widpadHeight-(jQuery(".ui-jqgrid-hbox").offset().top-jQuery(".widpad").offset().top+140);//No I18N
        }
        else
        {
            gridHeight=widpadHeight-(jQuery(".ui-jqgrid-hbox").offset().top-jQuery(".widpad").offset().top+100);//No I18N
        }
    }
    else
    {
        widpadHeight=jQuery("#Password_View_Div_Id").height();//No I18N
        if (!$('.ui-search-toolbar').is(':visible'))
        {
            gridHeight=widpadHeight-(jQuery(".ui-jqgrid-hbox").offset().top-jQuery("#Password_View_Div_Id").offset().top+93);//No I18N
        }
        else
        {
            gridHeight=widpadHeight-(jQuery(".ui-jqgrid-hbox").offset().top-jQuery("#Password_View_Div_Id").offset().top+55);//No I18N
        }
    }
    var heig=gridHeight+"px";//NO I18N
    $(".slimScrollDiv").css({'max-height': heig,"height":""});
    $('.ui-jqgrid-bdiv').css({'max-height': heig,"height":""});
}
    
function setBack()
{
    window.history.back();
}
function ValidateIPaddress(inputText)
 {
 var ipformat = /^(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$/;
 if(inputText.match(ipformat))
 {
 return true;
 }
 else
 {
 return false;
 }
 }
    
 function isValidPort(portNo)
 {
     if(isNaN(portNo)||portNo=="" ||portNo<=0||portNo>65535 || portNo!=parseInt(portNo))
     {
        showAlert(I18N.getMsg('js.port.specifyaValidPort')); //No I18N
        return false;
    }
    else
    {
        return true;
    }
 }
    
function userAssociationGraph(resourcename,user_id)
{
    App.SettingsUserController.user_id=user_id;
    App.SettingsUserController.resource_name=resourcename;
    redirectUrl("SSHMgmt/mappingGraph/user/"+user_id);//No I18N
}                       
                        
//$Id$
function populateRemoteApiClientGrid(gridTable, gridId, paramStr, gridPager, onSelectFunction, defaultOptions) {
        var params="gridId="+gridId+"&pmpcp="+Get_Cookie('pmpcc'); //NO I18N
	var columnURL = '/api/pki/client/apiClientGrid'; //No I18N
	$.ajax({
		url: columnURL,
		dataType: 'json',//No I18N
		type: 'POST',//No I18N
                data : params,
		success: function(jsonData) {
			var remote = jsonData.remote;
			var apiUrl = jsonData.apiUrl;
			var dataUrl = jsonData.dataUrl;
			if(remote == true) {
				var url = apiUrl + "?jqgridLoad=true"; // No I18N
				if(jsonData.timefilterParam != null) {
					url = url + '&TIME_FILTER_FIELD='+jsonData.timefilterParam; // No I18N
				}
				if(defaultOptions != null && defaultOptions != undefined) {
					if(defaultOptions.ignorePaging == true) {
						url = url + '&ignorePaging=true'; // No I18N
					}
				}
				if(paramStr != undefined && paramStr != null && paramStr != "") {
					url = url + paramStr;
				}
				for(var i = 0; i < jsonData.colModelList.length; i++) {
					var columnModel = jsonData.colModelList[i];
					if(columnModel.formatter != null && columnModel.formatter != "") {
						var tmpFunc = new Function('return '+columnModel.formatter);
						columnModel.formatter = tmpFunc();
					}
				}
                                for(var i = 0; i < jsonData.colNamesList.length; i++) {
					jsonData.colNamesList[i] = I18N.getMsg(jsonData.colNamesList[i]);
                                }
				loadJQgridWithRemote("#"+gridTable, url, jsonData.colNamesList, jsonData.colModelList, "", gridPager, onSelectFunction, defaultOptions); //No I18N
			}
		}
	});
}

function loadJQgridWithRemote(gridTable, url, colNamesList, colModelList, captionTitle, gridNavigator, onSelectFunction, defaultOptions,innerDiv)
{
        var widpadHeight=0;
	var defaultSortName = ""; //No I18N
	var defaultSortOrder = "asc"; //No I18N
	var multiselectVal = false;
	var rowNumNeeded = true;
	var addIcon = false;
	var delIcon = false;
	var minRowsPerPage = 25;
	var searchOption = false;
	var grouping = false;
	var subGrid = false;
	var hidegrid=false;
	var groupField=['rName'];
	var height = "auto"//No I18N
	var groupText='<b>  {0}  </b>';//NO I18N
	var groupCollapse=true;
        //If Formatter is available
        var app;
        var countOfRows =0;
        for(var i = 0; i < colModelList.length; i++) {
                var columnModel = colModelList[i];
                if(columnModel.formatter != null && columnModel.formatter != "") {
                        var tmpFunc = new Function('return '+columnModel.formatter);
                        columnModel.formatter = tmpFunc();
                }
        }
        if(innerDiv!==undefined && innerDiv!=true)
        {
            var widpadHeight=$(innerDiv).height();
        }
        else
        {
            if($(".widpad")!= undefined && $(".widpad").length>0)
            {
                widpadHeight=$(".widpad").height(); 
            }
            else
            {
                widpadHeight=$("#Password_View_Div_Id").height(); 
            }
        }
        if(innerDiv == undefined && innerDiv !== true)
        {
            var gridHeight;
            if(jQuery(".widpad").length>0)
            {
                gridHeight=widpadHeight-(jQuery(gridTable).offset().top-jQuery(".widpad").offset().top+80);//No I18N
            }
            else
            {
                gridHeight=widpadHeight-(jQuery(gridTable).offset().top-jQuery("#Password_View_Div_Id").offset().top+70);//No I18N
            }
            height=gridHeight-20;
        }

	if (defaultOptions !== undefined)
	{
		if(defaultOptions.groupText !== undefined) 	 	
		{ 	 	
			groupText = defaultOptions.groupText;
		}
		if(defaultOptions.subGrid !== undefined)
		{
			subGrid = defaultOptions.subGrid;
		}
		if(defaultOptions.groupField !== undefined) 	 	
		{ 	 	
			groupField = defaultOptions.groupField;
		}
		if (defaultOptions.searchOption !== undefined)
		{
			searchOption = defaultOptions.searchOption;
		}
		if (defaultOptions.sortName !== undefined)
		{
			defaultSortName = defaultOptions.sortName;
		}
		if (defaultOptions.sortOrder !== undefined)
		{
			defaultSortOrder = defaultOptions.sortOrder;
		}
		if (defaultOptions.multiselect !== undefined)
		{
			multiselectVal = defaultOptions.multiselect;
		}
		if (defaultOptions.rowNumNeeded !== undefined)
		{
			rowNumNeeded = defaultOptions.rowNumNeeded;
		}
		if (defaultOptions.addIcon !== undefined)
		{
			addIcon = defaultOptions.addIcon;
		}
		if (defaultOptions.delIcon !== undefined)
		{
			delIcon = defaultOptions.delIcon;
		}
		if (defaultOptions.minRowsPerPage !== undefined)
		{
			minRowsPerPage = defaultOptions.minRowsPerPage;
		}
		if (defaultOptions.grouping !== undefined)
		{
			grouping = defaultOptions.grouping;
		}
		if (defaultOptions.height !== undefined)
		{
			height = defaultOptions.height;
		}
		if (defaultOptions.groupCollapse !== undefined)
		{
			groupCollapse = defaultOptions.groupCollapse;
		}
		if (defaultOptions.hidegrid !== undefined)
		{
			hidegrid = defaultOptions.hidegrid;
		}
		}
	var grid = $(gridTable);
	var gridDivId = "#gbox_"; //No I18N
	var gridTableIdAlone = gridTable.substring(1);
	gridDivId = gridDivId+gridTableIdAlone;
	var gridDiv = $(gridDivId);
	if (gridDiv.length > 0)
	{
		grid.jqGrid('clearGridData'); //No I18N
//		grid.jqGrid('setGridParam', { datatype: "jsonstring", datastr: jsonData }); //No I18N
                $('.noRowMsg').remove();
		grid.jqGrid().setGridParam({url : url}).trigger("reloadGrid")//No I18N
	}
	else
	{
		if ((gridNavigator === null || gridNavigator === undefined || gridNavigator === ""))
		{
			var gridNavigatorId = gridTableIdAlone+"Pager";//No I18N
			var parentElem = $(gridTable).parent().get(0);
			createDiv(parentElem,gridNavigatorId);
			gridNavigator = "#"+gridNavigatorId;
		}
		var gridviewVal = false;
		if (onSelectFunction === "alarmListColored") //No I18N
		{
			gridviewVal = true;
		}
	grid.jqGrid({
		url: url,
		mtype: "POST",//No I18N
		datatype: "json", //No I18N
		colNames: colNamesList,
		colModel: colModelList,
                pager: kmpStandAlone ? gridNavigator : false,
		toppager: kmpStandAlone ? false : gridNavigator,
		rowList: [25,50,75,100],
		multiselect: multiselectVal,
                multiselectWidth: 30,
                multiboxonly: true,
		loadOnce: false,
                emptyrecords: "",
                recordtext: "Showing {0} - {1} of {2}", //No I18N
		//jsonReader: { root: function (obj) { return obj; }, repeatitems: false },
		rownumbers: rowNumNeeded,
		rowNum: minRowsPerPage,
		viewrecords: true,
		grouping: grouping,
		groupingView:
		{
			groupField: [groupField],
			groupColumnShow: [false],
			groupCollapse:groupCollapse,
			groupText:[groupText]
		},
	    caption: captionTitle,
		height: "auto",//No I18N
		autowidth: true,
		shrinkToFit: true,
		hidegrid: hidegrid,
                scrollerbar:true,
		hiddengrid:false,
		ignoreCase: true,
		sortable:true,
		subGrid:subGrid, 	
		sortname: defaultSortName,
		sortorder: defaultSortOrder,
		gridview: gridviewVal, // If set to true, the event below doesn't fire!
		subGridOptions: 
			{
				"plusicon"  : "ui-icon-triangle-1-e",//No I18N
				"minusicon" : "ui-icon-triangle-1-s", //No I18N
				"openicon"  : "ui-icon-arrowreturn-1-e", //No I18N
				"reloadOnExpand" : false, //No I18N
				"selectOnExpand" : true //No I18N
			},
			subGridRowExpanded: function(subgrid_id, row_id) 
			{
                            if(defaultOptions.subGridType==="KeyRotationReport")
                            {
                                var subgrid_table_id;
                                subgrid_table_id = subgrid_id+"_t";//NO I18N
                                jQuery("#"+subgrid_id).html("<table id='"+subgrid_table_id+"' class='scroll'></table>");//NO I18N
                                var scheduleAudit_id=grid.jqGrid('getCell', row_id,'KeyRotationAuditId'); //No I18N
                                var ajaxRequestUrl = '/api/pki/ssh/getKeyRotationAuditStatus?keyRotationAuditId='+scheduleAudit_id; //No I18N
                                getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
                                    var colNamesList = ['KEYROTATIONID',I18N.getMsg('js.general.resourcename'),I18N.getMsg('js.general.username'),I18N.getMsg('js.commonstr.status'),I18N.getMsg('js.commonstr.description')]; //No I18N
                                    var colModelList = [
                                            {name: 'KEYROTATIONID', index: 'KEYROTATIONID',hidden:true},//No I18N
                                            {name: 'RESOURCE NAME', index: 'RESOURCE NAME'}, //No I18N
                                            {name: 'USER NAME', index: 'USER NAME'}, //No I18N
                                            {name: 'STATUS', index: 'STATUS'}, //No I18N
                                            {name: 'DESCRIPTION', index: 'DESCRIPTION'} //No I18N
                                    ];
                                    var defaultOptions={multiselect:false,rowNumNeeded:false,searchOption:true};
                                    loadJQgridWithData("#"+subgrid_table_id, jsonData.detailedKeyRotationAudit, colNamesList, colModelList, " ","", "",defaultOptions);//No I18N
                                });
                            }
                            else if(defaultOptions.subGridType==="WildcardCertReport")
                            {
                                var subgrid_table_id;
                                subgrid_table_id = subgrid_id + "_t";//NO I18N
                                jQuery("#" + subgrid_id).html("<table id='" + subgrid_table_id + "' class='scroll'></table>");//NO I18N
                                var sslresId = grid.jqGrid('getCell', row_id, 'SSLResourceID'); //No I18N
                                var ajaxRequestUrl = '/api/pki/Inventory/getMultipleInstalledServers?cert_id=' + sslresId; //No I18N
                                getAjaxApiRequest(ajaxRequestUrl, "", function (jsonData) {
                                var colNamesList = ['MappingID', I18N.getMsg('js.sslcertificate.dnsame'), I18N.getMsg('js.discovery.ipaddress'),I18N.getMsg('js.discovery.port')]; //No I18N
                                var colModelList = [
                                    {name: 'MappingID', index: 'MappingID', hidden: true}, //No I18N
                                    {name: 'DomainName', index: 'DomainName'}, //No I18N
                                    {name: 'IPAddress', index: 'IPAddress'}, //No I18N
                                    { name: 'Port', index: 'Port'} //No I18N
                                ];
                                var defaultOptions = {multiselect: false, rowNumNeeded: false};
                                loadJQgridWithData("#" + subgrid_table_id, jsonData.MultipleServers, colNamesList, colModelList, " ", "", "", defaultOptions);//No I18N
                                });
                            }
                            else if(defaultOptions.subGridType === "LandingServerReport")
                            {
                                var subgrid_table_id;
                                subgrid_table_id = subgrid_id + "_t";//NO I18N
                                jQuery("#" + subgrid_id).html("<table id='" + subgrid_table_id + "' class='scroll'></table>");//NO I18N
                                var serverId = grid.jqGrid('getCell', row_id, 'ServerId'); //No I18N
                                var lsname = grid.jqGrid('getCell', row_id, 'ServerName'); //No I18N                                
                                var ajaxRequestUrl = '/api/pki/landingserver/lsAssociationGridView?LSId='+serverId+'&LSName='+lsname+'&view=associated'; //No I18N
                                getAjaxApiRequest(ajaxRequestUrl, "", function (jsonData) {
                                    if(jsonData.Resources.length>0){
                                        var colNamesList = ['Resource_ID',I18N.getMsg('js.general.resourcename'),I18N.getMsg("js.commonstr.description"),I18N.getMsg('js.discovery.ipaddress'),I18N.getMsg('js.general.creationtime'),'','']; //No I18N
                                        var colModelList = [
                                                { name: 'ResourceID', index: 'ResourceID',hidden:true},//No I18N
                                                { name: 'ResourceName', index: 'ResourceName'}, //No I18N
                                                { name: 'Description', index: 'Description'},//NO I18N
                                                { name: 'IPAddress', index: 'IPAddress',formatter:'ipcheckFormatter'}, //No I18N
                                                { name: 'CreationTime', index: 'CreationTime',sorttype: 'datetime',datefmt: 'M d, Y H:i'}, //No I18N
                                                { name: 'isLS', index: 'isLS',hidden:true},//NO I18N
                                                { name: 'ISLS', index: 'ISLS',formatter:'isLSFormatter',width:'35px',search:false,fixed:true}//NO I18N
                                                        ];
                                        var defaultOptions = {multiselect: false, rowNumNeeded: false};
                                        loadJQgridWithData("#" + subgrid_table_id, jsonData.Resources, colNamesList, colModelList, " ", "", "", defaultOptions);//No I18N
                                    }
                                });
                            }
                            else if(defaultOptions.subGridType === "SSLVulnerabilitiesReport")
                            {
                                var subgrid_table_id;
                                subgrid_table_id = subgrid_id + "_t";//NO I18N
                                jQuery("#" + subgrid_id).html("<table id='" + subgrid_table_id + "' style=\"width:100%\" class='scroll'></table>");//NO I18N
                                var cert_id = grid.jqGrid('getCell', row_id, 'ResourceID'); //No I18N                           
                                var ajaxRequestUrl = '/api/pki/Inventory/sslcertvulreportview?cert_id='+cert_id; //No I18N
                                getAjaxApiRequest(ajaxRequestUrl, "", function (jsonData) {                                    
                                        var ele='<div class="cer_wrapper"><div class="commonname">Common name</div><ul>';
                                        var list = jsonData.Vulnerabilities;
                                        var noData = list[0];
                                        if(list.length==1 && noData.ID==="-1" && noData.IpAddress==="")
                                        {
                                            ele='<div class="cer_wrapper" style="font-size:14px">'+noData.CommonName+'</div>';//NO I18N
                            }
                                        else
                            {
                                            for(var z=0;z<list.length;z++)
                                {
                                                var data=list[z];
                                                if(data.Status!=="Failed")
                                                {
                                                    if(data.Flag==="yes")
                                                    {
                                                        ele += '<li><a  style="color:#f54753" href="javascript:showVulPopUp('+data.ID+')">'+data.CommonName+'</a>('+data.IpAddress+')</li>';
                                }
                                                    else
                                                    {
                                                        ele += '<li><a href="javascript:showVulPopUp('+data.ID+')">'+data.CommonName+'</a>('+data.IpAddress+')</li>';
                            }
                                                }
                                                else
                                                {
                                                    ele += '<li>'+data.CommonName+' ('+data.IpAddress+')</li>';
                                                }
                                            }
                                            ele+='</ul>';
                                        }
                                        document.getElementById(subgrid_table_id).innerHTML=ele;
                                        
                                });
                            }
			},
                        gridComplete:function(){
                            if(onSelectFunction === "certHistory" || onSelectFunction==="AllResourceUsers" || onSelectFunction==="SSHKeyAssociate" || onSelectFunction==="GeneratedCertList" || onSelectFunction==="EncryptionKey" || onSelectFunction==="SSLEndPointSummary" || onSelectFunction==="LetsEncryptList" || onSelectFunction==="certDetails")//No I18N
                            {
                                //For more action popup
                                showPopover();
                            }
                            app=this;
                            
                            //NO Records to view Custom Message and Slimscroll
                            countOfRows = parseInt(grid.jqGrid('getGridParam', 'records'));//No I18N
                            if($(".noRowMsg").length){
                                    $(".noRowMsg").remove();
                                }
                            if (countOfRows <= 0) {
                                $(".ui-jqgrid-bdiv").prepend('<div class="noRowMsg">'+I18N.getMsg("js.tablegrid.noRecordstoview")+'</div>');//No I18N
                                $("#sp_1_"+gridTableIdAlone+"_toppager").text("1");//NO I18N
                            } else 
                            {
                                if(innerDiv==undefined)
                                {
                                    $('.ui-jqgrid-bdiv').slimscroll({
                                        railVisible: true,
                                        railBorderRadius: 0,
                                        railOpacity: 0.1
                                    });
                                    $(".slimScrollBar").hide();
                                }
                            }

			},
		onSelectAll: function(rowIds, allChecked) {
			$("input.groupHeader").attr('checked', allChecked);
		},
		afterInsertRow: function(rowId, rowData, rowElem) {
			// rowElem[nnn] column number to compare with (remember Javascript starts indexes at 0, so rowElem[2] selects the 3rd column)
			// Adapt the if clause to other comparisions if needed
			if(onSelectFunction === "userList")
			{
				if (rowElem.USERNAME === "admin" || rowElem.USERNAME === window.userName) { //No I18N 
					jQuery('tr#'+rowId+' td:last div:first div.ui-inline-del',jQuery(this)).hide();//No I18N
	  			}
   				return true;
			}
		}, 
		rowattr: function (rd) {

		},		
		onSelectRow: function(id , status , e){
       			/*if (onSelectFunction == "certDetails")//NO I18N
			{
				var hostId = grid.jqGrid('getCell', id,'ResourceID'); //No I18N
				if (hostId !== null && hostId !== "")
				{
					location.href = "index.jsp#/Inventory/Details/"+hostId; //No I18N
				}

			}*/
		},                
		onCellSelect: function(id, col, content, event) 
		{
			var colMod = grid.jqGrid("getGridParam", "colModel");	//No I18N
                },
                onPaging: function () {
                    if(!kmpStandAlone)
                    {
                    var newNum=$(".ui-pg-selbox").val();
                    $("#rn_"+newNum).addClass("pointer");
                    }
                },
		loadComplete: function (data) {
			if(defaultOptions.showAll===true)
			{
				var $grid=$('#'+defaultOptions.tableName)
	    		var subGridOptions = $grid.jqGrid("getGridParam", "subGridOptions"), //No I18N
	    	    plusIcon = subGridOptions.plusicon,
	    	    minusIcon = subGridOptions.minusicon,
	    	    expandAllTitle = "Expand all subgrids", //No I18N
	    	    collapseAllTitle = "Collapse all subgrids"; //No I18N
		    	$("#jqgh_" + $grid[0].id + "_subgrid") //No I18N
		    	    .html('<a style="cursor: pointer;"><span class="ui-icon ' + plusIcon + //No I18N
		    	          '" title="' + expandAllTitle + '"></span></a>') //No I18N
		    	    .click(function () {
		    	        var $spanIcon = $(this).find(">a>span"), //No I18N
		    	            $body = $(this).closest(".ui-jqgrid-view") //No I18N
		    	                .find(">.ui-jqgrid-bdiv>div>.ui-jqgrid-btable>tbody"); //No I18N
		    	        if ($spanIcon.hasClass(plusIcon)) {
		    	            $spanIcon.removeClass(plusIcon)
		    	                .addClass(minusIcon)
		    	                .attr("title", collapseAllTitle); //No I18N
		    	            $body.find(">tr.jqgrow>td.sgcollapsed") //No I18N
		    	                .click();
		    	        } else {
		    	            $spanIcon.removeClass(minusIcon)
		    	                .addClass(plusIcon)
		    	                .attr("title", expandAllTitle); //No I18N
		    	            $body.find(">tr.jqgrow>td.sgexpanded") //No I18N
		    	                .click();
				}
		    	    });
			}
			
                    if(!kmpStandAlone)
                    {
                        //Customized paging
                        var newNum=25;
                        $('.myPager').remove();
                        var myRowListChange = function(e) {
                            newNum = $(e.target).text();
                            grid.jqGrid('setGridParam', { rowNum: newNum, page: 1 }); //No I18N
//                            var totCount=grid.getGridParam('records');
//                            var curPage=$('input.ui-pg-input').val();
//                            if(curPage*newNum>totCount)
//                            {
                                grid.jqGrid('setGridParam', { page: 1 }); //No I18N
                                $(".ui-pg-selbox").val(newNum);
//                            }
                            grid.trigger("reloadGrid"); //No I18N
                            $("#rn_"+newNum).addClass("pointer");
                            //window.setTimeout( function(){$("#rn_"+newNum).addClass("pointer");}, 500);
                            
                            e.preventDefault();
                        };
                        $(".ui-pg-selbox").hide();
                        var link = $('<a>', { href:'#', click:myRowListChange, id:'rn_25'});
                        link.text("25");
                        var pagerNextTD = $('<td class="myPager">', { });
                        pagerNextTD.append(link);
                        pagerNextTD.append('<span>,&nbsp;</span>'); //No I18N
                        link = $('<a>', { href:'#', click:myRowListChange, id:'rn_50' });
                        link.text("50");
                        pagerNextTD.append(link);
                        pagerNextTD.append('<span>,&nbsp;</span>');//No I18N
                        link = $('<a>', { href:'#', click:myRowListChange , id:'rn_75'});
                        link.text("75");
                        pagerNextTD.append(link);
                        pagerNextTD.append('<span>,&nbsp;</span>');//No I18N
                        link = $('<a>', { href:'#', click:myRowListChange , id:'rn_100'});
                        link.text("100");
                        pagerNextTD.append(link);
                        $("#last_t_"+gridTableIdAlone+"_toppager").after(pagerNextTD);                        
                        $('input.ui-pg-input').prop( "disabled", true );
				}
                }
	});
	if (gridNavigator !== null || gridNavigator !== undefined || gridNavigator !== "")
		{
			//grid.jqGrid('navGrid', gridNavigator ,{ add: false, edit: false, del: false }); //No I18N
			grid.jqGrid('navGrid', gridNavigator ,{ add: addIcon, edit: false, del: delIcon , refresh:false,//No I18N
					 },
				{ /* edit options */ },{ /* add options */ },{ /* delete options */ },{ /* search options */
					sopt: ['eq', 'ne','bw','ew','cn', 'nc'] //No I18N
				});
		}
	}
	if(searchOption)
	{
		$(gridTable).jqGrid('filterToolbar',{ stringResult: true, searchOnEnter: false, defaultSearch: 'cn'});
		//$(gridTable)[0].toggleToolbar();
                $(".ui-search-toolbar").hide();
                $(".icon-search-alone").click(function(){
                    if(innerDiv == undefined && innerDiv !== true)
                    {
                            showSearchField();
                    }
                    app.toggleToolbar();
                    if ($.isFunction(app.p._complete)) {
                        if ($('.ui-search-toolbar', app.grid.hDiv).is(':visible'))
                        {
                            $('.ui-search-toolbar', app.grid.fhDiv).show();
                        } else {
                            $('.ui-search-toolbar', app.grid.fhDiv).hide();
}
                        app.p._complete.call(app);
                        fixPositionsOfFrozenDivs.call(app);
                    }
                    $(gridTable).setGridWidth($(gridDivId).width(), true);
                });
	}
        if (innerDiv == undefined && innerDiv !== true)
        {
                jQuery('.ui-jqgrid-bdiv').css({'max-height': height, "height": ""});//No I18N
                resizeJqGridWidth(gridTable, gridDivId);
            }
        if(!kmpStandAlone)
        {
            var dgremove="#alertmod_"+gridTableIdAlone;//No I18N
            jQuery(dgremove).remove();
        }
        
         $(".ui-icon").removeClass("ui-icon");        
         $(".ui-icon-seek-first").addClass("glyphicon glyphicon-backward");        
         $(".ui-icon-seek-prev").addClass("glyphicon glyphicon-chevron-left");        
         $(".ui-icon-seek-next").addClass("glyphicon glyphicon-chevron-right");        
         $(".ui-icon-seek-end").addClass("glyphicon glyphicon-forward");
}
