// $Id$

App.ReportController = Ember.ObjectController.extend({
    scheduleType:"",
    fromdate:"",
    todate:"",
    days:"",
    id:"",
    pmpschreportName:""
});


function createSslRequestList(jsonData)
{
            var colNamesList = ['RequestId',I18N.getMsg('js.sslrequest.newdomain'),I18N.getMsg('js.sslrequest.parentdomain'),I18N.getMsg('js.sslrequest.startdate'),I18N.getMsg('js.sslrequest.closeddate'),I18N.getMsg('js.sslrequest.requestername'),I18N.getMsg('js.commonstr.status')]; //No I18N
            var colModelList = [
                { name: 'REQUESTID', index: 'REQUESTID',hidden:true}, //No I18N
                { name: 'SubDomain', index: 'SubDomain'}, //No I18N
                { name: 'ParentDomain', index: 'ParentDomain'}, //No I18N
                { name: 'StartDate', index: 'StartDate'}, //No I18N
                { name: 'ClosedDate', index: 'ClosedDate'}, //No I18N
                { name: 'Requested By', index: 'Requested By'}, //No I18N
                { name: 'Status', index: 'Status'} //No I18N
            ];
        var defaultOptions={multiselect:false,rowNumNeeded:false};
        loadJQgridWithData("#reportView", jsonData.REQ_LIST, colNamesList, colModelList, " ", "#PKIReportPager","sslRequestReport" ,defaultOptions);//No I18N                        

}

function createEncryptionKeysList(jsonData)
{
    var colNamesList = ['EncKeyID',I18N.getMsg("js.ssh.keyname"),I18N.getMsg("js.ssh.keyType"),I18N.getMsg("js.general.instancename"),I18N.getMsg("js.encryptionkey.datacenter"),I18N.getMsg("js.commonstr.description"),I18N.getMsg("js.general.createdby"),I18N.getMsg("js.general.creationtime")]; //No I18N
    var colModelList = [
    {name: 'EncKeyID', index: 'EncKeyID',hidden:true},//No I18N
    {name: 'Key Name', index: 'Key Name'},//No I18N
    {name: 'Key Type', index: 'Key Type'}, //No I18N
    {name: 'InstanceName', index: 'InstanceName'}, //No I18N
    {name: 'Datacenter', index: 'Datacenter'}, //No I18N
    {name: 'Description', index: 'Description'}, //No I18N
    {name: 'Created By', index: 'Created By'}, //No I18N
    {name: 'Created Time', index: 'Created Time'}//NO I18N
    ];

    var defaultOptions={multiselect:false,rowNumNeeded:false};//NO I18N
    loadJQgridWithData("#reportView", jsonData.data, colNamesList, colModelList, "", "#PKIReportPager", "EncryptionKey",defaultOptions);//No I18N
                
}

function createSslExpiryList(jsonData)
{
    var colNamesList = ['ResourceID',I18N.getMsg('js.sslcertificate.certificatename'),I18N.getMsg('js.sslcertificate.dnsame'),I18N.getMsg('js.sslcertificate.issuer'),I18N.getMsg('js.report.timeline.fromdate'),I18N.getMsg('js.sslcertificate.expirydate'),I18N.getMsg('js.sslcertificate.daystoexpire'),I18N.getMsg('js.sslcertificate.keysize'),I18N.getMsg("js.commonstr.description")]; //No I18N
    var colModelList = [
            { name: 'ResourceID', index: 'ResourceID',hidden:true}, //No I18N
            { name: 'Common Name', index: 'Common Name',width: '300'}, //No I18N            
            { name: 'DNS Name/FQDN', index: 'DNS Name/FQDN',width: '200'}, //No I18N
            { name: 'Organization', index: 'Organization',width: '200px'}, //No I18N
            { name: 'FromDate', index: 'FromDate',width:'100px'},//NO I18N
            { name: 'ExpiryDate', index: 'ExpiryDate',width:'100px'}, //No I18N
            { name: 'DaysToExpiry', index: 'DaysToExpiry',width:'80px'}, //No I18N
            { name: 'KeyStrength', index: 'KeyStrength',width:'80px'}, //No I18N
            { name: 'Description', index:'Description'}//NO I18N
    ];
    var defaultOptions={multiselect:false,rowNumNeeded:false};
    loadJQgridWithData("#reportView", jsonData.InventDetails, colNamesList, colModelList, " ", "#PKIReportPager", "sslCertificateReport",defaultOptions);//No I18N
}

function createKeyList(jsonData)
{
                    if(jsonData.SSHKeys.length===0)
                    {
                        $("#chart").hide();
                    }
                    else
                    {
                        $("#chart").show();
                    createStackChart(jsonData);
                    }
                    var colNamesList = ['Key Id',I18N.getMsg('js.ssh.keyname'),I18N.getMsg('js.ssh.keyType'),I18N.getMsg('js.ssh.keylength'),I18N.getMsg('js.ssh.fingerprint'),I18N.getMsg('js.general.createdby'),I18N.getMsg('js.ssh.age')]; //No I18N
                    var colModelList = [
                            { name: 'KeyID', index: 'KeyID',hidden:true}, //No I18N
                            { name: 'KeyName', index: 'KeyName'}, //No I18N
                            { name: 'KeyType', index: 'KeyType',width:'60px'}, //No I18N
                            { name: 'KeyLength', index: 'KeyLength',width:'70px'}, //No I18N
                            { name: 'FingerPrint', index: 'FingerPrint',width:'250px'}, //No I18N
                            { name: 'CreatedBy', index: 'CreatedBy'}, //No I18N
                            { name: 'CreationTime', index: 'CreationTime'}//No I18N
                    ];
                    var defaultOptions={multiselect:false,rowNumNeeded:false,sortName:"CreationTime"}; //No I18N
                    loadJQgridWithData("#reportView", jsonData.SSHKeys, colNamesList, colModelList, " ", "#PKIReportPager", "auditdetailslist",defaultOptions);//No I18N

}
function createKeyDeploymentList(jsonData)
{
            var colNamesList = [I18N.getMsg('js.general.username'),I18N.getMsg('js.general.resourcename'),I18N.getMsg('js.ssh.keyname'),I18N.getMsg('js.ssh.keyType'),I18N.getMsg('js.ssh.keylength')]; //No I18N
            var colModelList = [
                        { name: 'UserName', index: 'UserName'}, //No I18N
                        { name: 'ResourceName', index: 'ResourceName'}, //No I18N
                        { name: 'KeyName', index: 'KeyName'}, //No I18N
                        { name: 'KeyType', index: 'KeyType'}, //No I18N
                        { name: 'KeyLength', index: 'KeyLength',width:'50px'} //No I18N
                ];
            var defaultOptions={multiselect:false,rowNumNeeded:false}; //No I18N
            loadJQgridWithData("#reportView", jsonData.keydepdetails, colNamesList, colModelList, " ", "#PKIReportPager", "auditdetailslist",defaultOptions);//No I18N
}
function createLandingServersReport(jsonData)
{
    var colNamesList = ['ServerId',I18N.getMsg('landingserver.servername'),I18N.getMsg("landingserver.primaryserver"),I18N.getMsg('landingserver.primaryserver.account'),I18N.getMsg('landingserver.secondaryserver'),I18N.getMsg("landingserver.secondaryserver.account"),I18N.getMsg("js.general.createdby"),I18N.getMsg('js.general.creationtime'),I18N.getMsg('js.commonstr.description'),I18N.getMsg('js.table.search')]; //No I18N
    var colModelList = [
            { name: 'ServerId', index: 'ServerId',hidden:true},//No I18N
            { name: 'ServerName', index: 'ServerName',width:'120px',classes:"pointer"}, //No I18N
            { name: 'PrimaryServer', index: 'PrimaryServer',width:'120px'},//NO I18N
            { name: 'PrimaryUser', index: 'PrimaryUser',width:'130px'}, //No I18N
            { name: 'SecondaryServer', index: 'SecondaryServer',width:'120px'},//NO I18N
            { name: 'SecondaryUser', index: 'SecondaryUser',width:'150px'},//NO I18N
            { name: 'CreatedBy', index: 'CreatedBy',width:'80px'},//NO I18N
            { name: 'CreatedTime', index: 'CreatedTime',sorttype: 'datetime',datefmt: 'M d, Y H:i',width:'100px'},//NO I18N
            { name: 'Description', index: 'Description',width:'100px'},//NO I18N
            { name: 'search',width:'30px',sortable: false,search:false,fixed:true}//NO I18N
        ];
    var defaultOptions={multiselect:false,rowNumNeeded:false,searchOption:true,subGrid:true,subGridType:"LandingServerReport"};//NO I18N
    loadJQgridWithData("#reportView", jsonData.LandingServers, colNamesList, colModelList, "", "#PKIReportPager", "LandignServerReport",defaultOptions);//No I18N     
}
function createGoDaddyOrderList(jsonData)
{
    var colNamesList = [I18N.getMsg('js.commonstr.certificatename'),I18N.getMsg("js.ssl.certificatetype"),I18N.getMsg('js.general.creationtime'),I18N.getMsg('js.report.timeline.fromdate'),I18N.getMsg('js.report.timeline.todate'),I18N.getMsg('js.sslrequest.requestername'),I18N.getMsg('lets.encrypt.authorizedby'),I18N.getMsg("certificate.status"),I18N.getMsg('js.table.search')]; //No I18N
    var colModelList = [
            { name: 'CommonName', index: 'CommonName'}, //No I18N
            { name: 'CertType',index:'CertType',width:'130px'},//NO I18N
            { name: 'CREATIONTIME',index:'CREATIONTIME',width:'130px'},//NO I18N
            { name: 'VALID_FROM', index:'VALID_FROM',width:'130px'},//NO I18N
            { name: 'VALID_TO', index:'VALID_TO',width:'130px'},//NO I18N
            { name: 'USERNAME', index: 'USERNAME'}, //No I18N                    
            { name: 'AUTHORIZEDBY' , index:'AUTHORIZEDBY',width:"120px",hidden:true},//NO I18N
            { name: 'STATUS', index: 'STATUS',formatter:'godaddyReportStatusFormatter',width:"200px"}, //No I18N
            { name: 'search',width:30,sortable: false,search:false}//NO I18N
        ];
    var defaultOptions={multiselect:false,rowNumNeeded:false,searchOption:true};
    loadJQgridWithData("#reportView", jsonData.requestsList, colNamesList, colModelList, " ", "#PKIReportPager","GoDaddyOrdersReport" ,defaultOptions);//No I18N   
}
function createLetsEncryptRequestsList(jsonData)
{
    var colNamesList = [I18N.getMsg('js.sslcertificate.domainnames'),I18N.getMsg('js.general.creationtime'),I18N.getMsg('js.report.timeline.fromdate'),I18N.getMsg('js.report.timeline.todate'),I18N.getMsg('js.sslrequest.requestername'),I18N.getMsg('lets.encrypt.authorizedby'),I18N.getMsg('js.sslrequest.processedby'),I18N.getMsg('request.status'),I18N.getMsg("certificate.status"),I18N.getMsg('js.table.search')]; //No I18N
    var colModelList = [
            { name: 'DOMAINS', index: 'DOMAINS'}, //No I18N
            { name: 'CREATIONTIME',index:'CREATIONTIME',width:'130px'},//NO I18N
            { name: 'VALID_FROM', index:'VALID_FROM',width:'130px'},//NO I18N
            { name: 'VALID_TO', index:'VALID_TO',width:'130px'},//NO I18N
            { name: 'USERNAME', index: 'USERNAME'}, //No I18N
            { name: 'AUTHORIZEDBY' , index:'AUTHORIZEDBY'},//NO I18N
            { name: 'CLOSEDBY', index: 'CLOSEDBY'}, //No I18N                    
            { name: 'STATUS', index: 'STATUS',width:"125px"}, //No I18N
            { name: "CERT_STATUS",index:'CERT_STATUS',formatter:'certStatusFormatter',width:'130px'},//NO I18N
            { name: 'search',width:30,sortable: false,search:false}//NO I18N
        ];
    var defaultOptions={multiselect:false,rowNumNeeded:false,searchOption:true};
    loadJQgridWithData("#reportView", jsonData.requestsList, colNamesList, colModelList, " ", "#PKIReportPager","LetsRequestsReport" ,defaultOptions);//No I18N   
}
function createUserAuditList(params)
{
            var defaultOptions={multiselect:false,rowNumNeeded:false,searchOption:true,sortName:"PKIAudit__OPERATIONAUDITTIME"}; //No I18N
    populateRemoteApiClientGrid("reportView","PKIAuditDetailsListReport" ,params, "#PKIReportPager", "userAuditlist", defaultOptions); //No I18N
}
function createServerAccessAuditList(jsonData)
{
            var colNamesList = ['TERMINAL AUDITID',I18N.getMsg('js.general.resourcename'),I18N.getMsg('js.general.username'),I18N.getMsg('js.general.executedon'),I18N.getMsg('js.commonstr.status')]; //No I18N
            var colModelList = [
                        { name: 'TERMINAL AUDITID', index: 'TERMINAL AUDITID',hidden:true}, //No I18N
                        { name: 'ResourceName', index: 'ResourceName'}, //No I18N
                        { name: 'UserName', index: 'UserName'}, //No I18N
                        { name: 'Executed On', index: 'Executed On'}, //No I18N
                        { name: 'Status', index: 'Status',width:'100px',classes:'pointer',formatter:"statusFormatter"} //No I18N
                ];
            var defaultOptions={multiselect:false,rowNumNeeded:false}; //No I18N
            loadJQgridWithData("#reportView", jsonData.termial_status, colNamesList, colModelList, " ", "#PKIReportPager", "terminalAuditlist",defaultOptions);//No I18N
        
}
function createInventoryList(jsonData)
{
            var colNamesList = ['Resource_ID',I18N.getMsg('js.general.resourcename'),I18N.getMsg("js.commonstr.description"),I18N.getMsg('js.discovery.ipaddress'),I18N.getMsg('js.discovery.resourcetype'),'',I18N.getMsg('js.general.creationtime')]; //No I18N
            var colModelList = [
                    { name: 'ResourceID', index: 'ResourceID',hidden:true},//No I18N
                    { name: 'ResourceName', index: 'ResourceName'}, //No I18N
                    { name: 'Description', index: 'Description',hidden:true},//NO I18N
                    { name: 'IPAddress', index: 'IPAddress',formatter:'ipcheckFormatter'}, //No I18N
                    { name: 'ResourceType', index: 'ResourceType'}, //No I18N
                    { name: 'SSH', index: 'SSH',width:'50px',formatter:'sshEnabledFormatter',search:false,hidden:true}, //No I18N
                    { name: 'CreationTime', index: 'CreationTime'} //No I18N
                ];
            var defaultOptions={multiselect:false,rowNumNeeded:false};
            loadJQgridWithData("#reportView", jsonData.Resources, colNamesList, colModelList, " ", "#PKIReportPager", "inventoryReport",defaultOptions);//No I18N                    
       
}
function createSSHResourceList(jsonData)
{
    var colNamesList = ['Resource_ID',I18N.getMsg('js.general.resourcename'),I18N.getMsg("js.commonstr.description"),I18N.getMsg('js.discovery.ipaddress'),I18N.getMsg('js.general.creationtime'),I18N.getMsg("landingserver.heading"),I18N.getMsg("landingserver.heading")]; //No I18N
    var colModelList = [
            { name: 'ResourceID', index: 'ResourceID',hidden:true},//No I18N
            { name: 'ResourceName', index: 'ResourceName'}, //No I18N
            { name: 'Description', index: 'Description'},//NO I18N
            { name: 'IPAddress', index: 'IPAddress',formatter:'ipcheckFormatter'}, //No I18N
            { name: 'CreationTime', index: 'CreationTime'}, //No I18N
            { name: 'LSName', index: 'LSName'},//NO I18N
            { name: 'isLS', index: 'isLS',hidden:true}//NO I18N
        ];
    var defaultOptions={multiselect:false,rowNumNeeded:false};
    loadJQgridWithData("#reportView", jsonData.Resources, colNamesList, colModelList, " ", "#PKIReportPager", "inventoryReport",defaultOptions);//No I18N   
}
function createKeyRotationList(jsonData)
{
                if(jsonData.keyRotationAudit.length!==0)
                {
                    $("#chart").show();
                    createBarChart(jsonData);
                }
                else
                {
                    $("#chart").hide();
                }
                var colNamesList = ['KeyRotationAuditId',I18N.getMsg('js.ssh.keyname'),I18N.getMsg('js.ssh.keyrotationinvokedon'),I18N.getMsg('js.general.finishtime'),I18N.getMsg('js.commonstr.status')]; //No I18N
                var colModelList = [
                        { name: 'KeyRotationAuditId', index: 'KeyRotationAuditId',hidden:true}, //No I18N
                        { name: 'Key_Name', index: 'Key_Name',classes:"pointer"}, //No I18N
                        { name: 'KeyRotationInvokedOn', index: 'KeyRotationInvokedOn'}, //No I18N
                        { name: 'FinishTime', index: 'FinishTime'}, //No I18N
                        { name: 'KeyRotation_Status', index: 'KeyRotation_Status'} //No I18N
                ];
            var defaultOptions={multiselect:false,rowNumNeeded:false,sortName:"OPERATIONAUDITTIME",subGrid:true,subGridType:"KeyRotationReport"}; //No I18N
            loadJQgridWithData("#reportView", jsonData.keyRotationAudit, colNamesList, colModelList, " ", "#PKIReportPager", "keyRotationReportlist",defaultOptions);//No I18N
        
}
function createSslList(jsonData)
{
            var colNamesList = ['ResourceID',I18N.getMsg('js.sslcertificate.certificatename'),I18N.getMsg('js.sslcertificate.dnsame'),I18N.getMsg('js.sslcertificate.issuer'),I18N.getMsg('js.report.timeline.fromdate'),I18N.getMsg('js.sslcertificate.expirydate'),I18N.getMsg('js.sslcertificate.keysize'),I18N.getMsg('js.ssl.certificate.keyalgorithm'),I18N.getMsg('js.general.creationtime'),I18N.getMsg("js.commonstr.description"),'']; //No I18N
            var colModelList = [
                    { name: 'ResourceID', index: 'ResourceID',hidden:true}, //No I18N
                    { name: 'Common Name', index: 'Common Name'}, //No I18N                    
                    { name: 'DNS Name/FQDN', index: 'DNS Name/FQDN'}, //No I18N
                    { name: 'Organization', index: 'Organization'}, //No I18N
                    { name: 'FromDate', index: 'FromDate',hidden:true},//NO I18N
                    { name: 'ExpiryDate', index: 'ExpiryDate',width:'100px'}, //No I18N
                    { name: 'KeyStrength', index: 'KeyStrength',width:'80px'}, //No I18N
                    { name: 'signatureAlgorithm', index: 'signatureAlgorithm',width:'150px'}, //No I18N
                    { name: 'keyAlgorithm', index: 'keyAlgorithm',width:'90px',width: '150'}, //No I18N
                    { name: 'CreationTime', index:'CreationTime',width:'120px'},//NO I18N
                    { name: 'Description',index: 'Description'},//NO I18N
                    { name: 'Flag' , index: 'Flag',hidden:true}//NO I18N
            ];
            var defaultOptions={multiselect:false,rowNumNeeded:false};
            loadJQgridWithData("#reportView", jsonData.InventDetails, colNamesList, colModelList, " ", "#PKIReportPager", "sslCertificateReport",defaultOptions);//No I18N
       
}
function createADSSLlist(jsonData)
{
    var colNamesList = [I18N.getMsg('js.sslcertificate.certificatename'),I18N.getMsg('js.sslcertificate.domainname'),I18N.getMsg('js.sslcertificate.domaincontroller'),I18N.getMsg("js.userreport.username"),I18N.getMsg('js.report.timeline.fromdate'),I18N.getMsg('js.sslcertificate.expirydate'),I18N.getMsg('js.common.daystoexpiry'),I18N.getMsg('js.general.creationtime'),I18N.getMsg('js.table.search')]; //No I18N
            var colModelList = [
                    { name: 'Common_Name', index: 'Common_Name'}, //No I18N      
                    { name: 'Domain_Name',index:'Domain_Name'},//NO I18N
                    { name: 'Domain_Controller', index: 'Domain_Controller'}, //No I18N
                    { name: 'User_Name', index: 'User_Name'}, //No I18N
                    { name: 'From_Date', index: 'From_Date',width:'100px',sorttype: 'datetime',datefmt: 'M d, Y H:i'},//NO I18N
                    { name: 'To_Date', index: 'To_Date',width:'100px',sorttype: 'datetime',datefmt: 'M d, Y H:i'}, //No I18N
                    { name: 'Days_Expiry', index: 'Days_Expiry',width:'80px'}, //No I18N
                    { name: 'Created_Time', index:'Created_Time',width:'120px',sorttype: 'datetime',datefmt: 'M d, Y H:i'},//NO I18N
                    { name: 'search',width:'20px',sortable: false,search:false,width:'30px',fixed:true}//NO I18N
            ];
            var defaultOptions={multiselect:false,rowNumNeeded:false};
            loadJQgridWithData("#reportView", jsonData.InventDetails, colNamesList, colModelList, " ", "#PKIReportPager", "ADsslCertificateReport",defaultOptions);//No I18N
}
function createSSLWildcardCertList(jsonData)
{
               var colNamesList = ['SSLResourceID', I18N.getMsg('js.sslcertificate.certificatename'), I18N.getMsg('js.sslcertificate.issuer'), I18N.getMsg('js.report.timeline.fromdate'), I18N.getMsg('js.sslcertificate.expirydate'), I18N.getMsg('js.sslcertificate.keysize'),I18N.getMsg('js.ssl.certificate.keyalgorithm'), I18N.getMsg('js.general.creationtime'), I18N.getMsg("js.commonstr.description"), I18N.getMsg('js.table.search')]; //No I18N
    var colModelList = [
        {name: 'SSLResourceID', index: 'SSLResourceID', hidden: true}, //No I18N
        {name: 'Common Name', index: 'Common Name',classes:"pointer"}, //No I18N                    
        {name: 'Organization', index: 'Organization'}, //No I18N
        {name: 'FromDate', index: 'FromDate', width: '100px',sorttype: 'datetime',datefmt: 'M d, Y H:i'}, //NO I18N
        {name: 'ExpiryDate', index: 'ExpiryDate', width: '100px',sorttype: 'datetime',datefmt: 'M d, Y H:i'}, //No I18N
        {name: 'KeyStrength', index: 'KeyStrength', width: '80px'}, //No I18N
        { name: 'keyAlgorithm', index: 'keyAlgorithm',width:'90px',width: '150'}, //No I18N
        {name: 'CreationTime', index: 'CreationTime', width: '120px',sorttype: 'datetime',datefmt: 'M d, Y H:i'}, //NO I18N
        {name: 'Description', index: 'Description'}, //NO I18N
        {name: 'search', width: '20px', sortable: false, search: false, width:'30px', fixed: true}//NO I18N
    ];
    var defaultOptions = {multiselect: false, rowNumNeeded: false, searchOption: true,subGrid:true,subGridType:"WildcardCertReport"};//No I18N
    loadJQgridWithData("#reportView", jsonData.wildcardCertificates, colNamesList, colModelList, " ", "#PKIReportPager", "sslwildcardCertificateReport", defaultOptions);//No I18N                        
}

function createDeploymentReportList(jsonData)
{
   var colNamesList = ['DepID', I18N.getMsg('js.sslcertificate.certificatename'), I18N.getMsg('js.discovery.hostname'), I18N.getMsg('js.cert.deploy.by'), I18N.getMsg('js.cert.deploy.time'), I18N.getMsg('js.cert.deploy.type'),I18N.getMsg('js.commonstr.status'), I18N.getMsg('js.commonstr.description'),I18N.getMsg('js.table.search')]; //No I18N
    var colModelList = [
        {name: 'DepID', index: 'DepID', hidden: true}, //No I18N
        {name: 'CommonName', index: 'CommonName', width: '100px'}, //No I18N                    
        {name: 'HostName', index: 'HostName', width: '100px'}, //No I18N
        {name: 'DeployedBy', index: 'DeployedBy', width: '100px'}, //NO I18N
        {name: 'DeployedDate', index: 'DeployedDate', width: '100px',sorttype: 'datetime',datefmt: 'M d, Y H:i'}, //No I18N
        {name: 'DeploymentType', index: 'DeploymentType', width: '100px'}, //No I18N
        { name: 'Status', index: 'Status',width:'90px',width: '80',formatter:"progressStatusFormatter",search:false}, //No I18N
        {name: 'Description', index: 'Description', width: '120px',sorttype: 'datetime',datefmt: 'M d, Y H:i'}, //NO I18N
        {name: 'search', width: '20px', sortable: false, search: false, width:'30px', fixed: true}//NO I18N
    ];
    var defaultOptions = {multiselect: false, rowNumNeeded: false, searchOption: true};
    loadJQgridWithData("#reportView", jsonData.deployedCertificates, colNamesList, colModelList, " ", "#PKIReportPager", "sslwildcardCertificateReport", defaultOptions);//No I18N                        
}

function createSHA1dCertList(jsonData)
{
    var colNamesList = ['ResourceID',I18N.getMsg('js.sslcertificate.certificatename'),I18N.getMsg('js.sslcertificate.dnsame'),I18N.getMsg('js.sslcertificate.issuer'), I18N.getMsg('js.report.timeline.fromdate'),I18N.getMsg('js.sslcertificate.expirydate'),I18N.getMsg('js.sslcertificate.keysize'),I18N.getMsg('js.cert.sigAlgorithm'),I18N.getMsg('js.ssl.certificate.keyalgorithm'),I18N.getMsg('js.sslcertificate.daystoexpire'),I18N.getMsg('js.table.search')]; //No I18N
    var colModelList = [
            { name: 'ResourceID', index: 'ResourceID',hidden:true}, //No I18N
            { name: 'Common Name', index: 'Common Name'}, //No I18N
            { name: 'DNS Name/FQDN', index: 'DNS Name/FQDN'}, //No I18N                            
            { name: 'Organization', index: 'Organization'}, //No I18N
            {name: 'FromDate', index: 'FromDate', width: '100px',sorttype: 'datetime',datefmt: 'M d, Y H:i'}, //NO I18N
            { name: 'ExpiryDate', index: 'ExpiryDate',sorttype: 'datetime',datefmt: 'M d, Y H:i'}, //No I18N
            { name: 'KeyStrength', index: 'KeyStrength'}, //No I18N
            { name: 'signatureAlgorithm', index: 'signatureAlgorithm',hidden:true}, //No I18N
            { name: 'keyAlgorithm', index: 'keyAlgorithm',width:'90px',width: '100'}, //No I18N
            { name: 'DaysToExpiry', index: 'DaysToExpiry'}, //No I18N
            { name: 'search',width:25,sortable: false,search:false}//NO I18N
    ];
    var defaultOptions={multiselect:false,rowNumNeeded:false,searchOption:true};
    loadJQgridWithData("#reportView", jsonData.InventDetails, colNamesList, colModelList, " ", "#PKIReportPager", "",defaultOptions);//No I18N
}
function createUsersList(jsonData)
{
            var colNamesList = ['User_ID',I18N.getMsg('js.userreport.username'),I18N.getMsg('js.userreport.resourcename'),I18N.getMsg('js.userreport.associatedkeys'),I18N.getMsg('js.table.search')]; //No I18N
            var colModelList = [
                    { name: 'UserID', index: 'UserID',hidden:true},//No I18N
                    { name: 'UserName', index: 'UserName'}, //No I18N
                    { name: 'ResourceName', index: 'ResourceName'},//NO I18N
                    { name: 'AssociatedKeys', index: 'AssociatedKeys'},//No I18N                    
                    { name: 'search',width:'20px',sortable: false,search:false}//NO I18N
                ];
            var defaultOptions={multiselect:false,rowNumNeeded:false};
            loadJQgridWithData("#reportView", jsonData.users, colNamesList, colModelList, "", "#PKIReportPager", "userreport",defaultOptions);//No I18N                    
}
function createAllKeysList(jsonData)
{
    var colNamesList = ['Key Id',I18N.getMsg('js.ssh.keyname'),I18N.getMsg('js.general.type'),I18N.getMsg('js.general.createdby'),I18N.getMsg('js.general.creationtime'),I18N.getMsg('js.table.search')];//NO I18N
    var colModelList = [
        {name: 'Key Id',index:'Key Id',hidden:true},//NO I18N
        {name: 'Key Name',index:'Key Name'},//NO I18N
        {name: 'Type',index:'Type'},//NO I18N
        {name: 'Created By',index:'Created By'},//NO I18N
        {name: 'Created Time',index:'Created Time'},//NO I18N
        {name: 'search',width:'25px',sortable:false,search:false}//NO I18N
    ];
    var defaultOptions={multiselect:false,rowNumNeeded:false};//NO I18N
    loadJQgridWithData("#reportView", jsonData.allkeyslist, colNamesList, colModelList, "", "#PKIReportPager", "allkeyslist",defaultOptions);//No I18N
       
}

App.ReportLetsEncryptRequestsController = Ember.ObjectController.extend({
    needs:'application',//NO I18N
    actions:{
        close:function(){
            return this.send('closeModal');//NO I18N
        },
        go:function()
        {
            if(validateCriteria())
            {
                var domainNames = document.getElementById("gs_DOMAINS").value;
                var createdTime = document.getElementById("gs_CREATIONTIME").value;
                var validFrom = document.getElementById("gs_VALID_FROM").value;
                var validTo = document.getElementById("gs_VALID_TO").value;
                var requestedBy = document.getElementById("gs_USERNAME").value;
                var authorizedBy = document.getElementById("gs_AUTHORIZEDBY").value;
                var processedBy = document.getElementById("gs_CLOSEDBY").value;
                var requestStatus = document.getElementById("gs_STATUS").value;
                var certificateStatus = document.getElementById("gs_CERT_STATUS").value;
                var sday=App.ReportController.fromdate;
                var eday=App.ReportController.todate;
                var ajaxRequestUrl = '/api/pki/letsencrypt/getRequestsReport'; //No I18N
                var params = 'domains='+domainNames+'&createdTime='+createdTime+'&validFrom='+validFrom+'&validTo='+validTo+'&requestedBy='+requestedBy+'&authorizedBy='+//NO I18N
                        authorizedBy+'&processedBy='+processedBy+'&requestStatus='+requestStatus+'&certificateStatus='+certificateStatus+'&sday='+sday+'&eday='+eday;//NO I18N
                getAjaxApiRequest(ajaxRequestUrl,params,function(jsonData){
                    createLetsEncryptRequestsList(jsonData);
                     });
            }
        },
        exportPdf:function()
        {
            if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
            var domainNames = document.getElementById("gs_DOMAINS").value;
            var createdTime = document.getElementById("gs_CREATIONTIME").value;
            var validFrom = document.getElementById("gs_VALID_FROM").value;
            var validTo = document.getElementById("gs_VALID_TO").value;
            var requestedBy = document.getElementById("gs_USERNAME").value;
            var authorizedBy = document.getElementById("gs_AUTHORIZEDBY").value;
            var processedBy = document.getElementById("gs_CLOSEDBY").value;
            var requestStatus = document.getElementById("gs_STATUS").value;
            var certificateStatus = document.getElementById("gs_CERT_STATUS").value;
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate;
            var ajaxRequestUrl = '/api/pki/letsencrypt/getRequestsReport'; //No I18N
            var params = '&domains='+domainNames+'&createdTime='+createdTime+'&validFrom='+validFrom+'&validTo='+validTo+'&requestedBy='+requestedBy+'&authorizedBy='+//NO I18N
                    authorizedBy+'&processedBy='+processedBy+'&requestStatus='+requestStatus+'&certificateStatus='+certificateStatus+'&sday='+sday+'&eday='+eday;//NO I18N
            if(sday!==""&&eday!==""&&!validateCriteria())
            {
                return;
            }
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                locReplaceURL("/apiclient/ajaxResponse.jsp?RequestType=exportPdf&ReportType=LetsRequestReport"+params);//NO I18N
            }
            else{
                messageNotification("messageNotifyFailure",I18N.getMsg("js.report.export.noDataAvailableToExport"));//No I18N
            }    
        },
        exportCsv:function()
        {
            if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
            var domainNames = document.getElementById("gs_DOMAINS").value;
            var createdTime = document.getElementById("gs_CREATIONTIME").value;
            var validFrom = document.getElementById("gs_VALID_FROM").value;
            var validTo = document.getElementById("gs_VALID_TO").value;
            var requestedBy = document.getElementById("gs_USERNAME").value;
            var authorizedBy = document.getElementById("gs_AUTHORIZEDBY").value;
            var processedBy = document.getElementById("gs_CLOSEDBY").value;
            var requestStatus = document.getElementById("gs_STATUS").value;
            var certificateStatus = document.getElementById("gs_CERT_STATUS").value;
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate;
            var ajaxRequestUrl = '/api/pki/letsencrypt/getRequestsReport'; //No I18N
            var params = '&domains='+domainNames+'&createdTime='+createdTime+'&validFrom='+validFrom+'&validTo='+validTo+'&requestedBy='+requestedBy+'&authorizedBy='+//NO I18N
                    authorizedBy+'&processedBy='+processedBy+'&requestStatus='+requestStatus+'&certificateStatus='+certificateStatus+'&sday='+sday+'&eday='+eday;//NO I18N
            if(sday!==""&&eday!==""&&!validateCriteria())
            {
                return;
            }
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                locReplaceURL("/apiclient/ajaxResponse.jsp?RequestType=exportCsv&ReportType=LetsRequestReport"+params);//NO I18N
            }
            else{
                messageNotification("messageNotifyFailure",I18N.getMsg("js.report.export.noDataAvailableToExport"));//No I18N
            }    
        },
        dataCheck:function()
        {
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate;
            var app=this.get('controllers.application');
            if(sday!==""&&eday!==""&&!validateCriteria())
            {
                return;
            }
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                app.send('opendialog','EmailNotify');//NO I18N
            }else{
             messageNotification("messageNotifyFailure",I18N.getMsg("js.report.datacheck.noDataAvailable"));//No I18N
            }
        }
    }
});

App.ReportGoDaddyOrdersReportController = Ember.ObjectController.extend({
    needs:'application',//NO I18N
    actions:{
        close:function(){
            return this.send('closeModal');//NO I18N
        },
        go:function()
        {
            if(validateCriteria())
            {
                var domainNames = document.getElementById("gs_CommonName").value;
                var authorizedby = document.getElementById("gs_AUTHORIZEDBY").value;
                var certType = document.getElementById("gs_CertType").value;
                var createdTime = document.getElementById("gs_CREATIONTIME").value;
                var validFrom = document.getElementById("gs_VALID_FROM").value;
                var validTo = document.getElementById("gs_VALID_TO").value;
                var requestedBy = document.getElementById("gs_USERNAME").value;
                var status = document.getElementById("gs_STATUS").value;
                var sday=App.ReportController.fromdate;
                var eday=App.ReportController.todate;
                var ajaxRequestUrl = '/api/pki/godaddy/godaddyOrdersReport'; //No I18N
                var params = '&authorizedby='+authorizedby+'&commonName='+domainNames+'&certType='+certType+'&createdTime='+createdTime+'&validFrom='+validFrom+'&validTo='+validTo+'&requestedBy='+requestedBy+'&status='+status+'&sday='+sday+'&eday='+eday;//NO I18N
                getAjaxApiRequest(ajaxRequestUrl,params,function(jsonData){
                    createGoDaddyOrderList(jsonData);
                     });
            }
        },
        exportPdf:function()
        {
            if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
            var domainNames = document.getElementById("gs_CommonName").value;
            var authorizedby = document.getElementById("gs_AUTHORIZEDBY").value;
            var certType = document.getElementById("gs_CertType").value;
            var createdTime = document.getElementById("gs_CREATIONTIME").value;
            var validFrom = document.getElementById("gs_VALID_FROM").value;
            var validTo = document.getElementById("gs_VALID_TO").value;
            var requestedBy = document.getElementById("gs_USERNAME").value;
            var status = document.getElementById("gs_STATUS").value;
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate;
            var params = '&authorizedby='+authorizedby+'&commonName='+domainNames+'&certType='+certType+'&createdTime='+createdTime+'&validFrom='+validFrom+'&validTo='+validTo+'&requestedBy='+requestedBy+'&status='+status+'&sday='+sday+'&eday='+eday;//NO I18N
            if(sday!==""&&eday!==""&&!validateCriteria())
            {
                return;
            }
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                locReplaceURL("/apiclient/ajaxResponse.jsp?RequestType=exportPdf&ReportType=GoDaddyOrdersReport"+params);//NO I18N
            }
            else{
                messageNotification("messageNotifyFailure",I18N.getMsg("js.report.export.noDataAvailableToExport"));//No I18N
            }    
        },
        exportCsv:function()
        {
            if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
            var domainNames = document.getElementById("gs_CommonName").value;
            var authorizedby = document.getElementById("gs_AUTHORIZEDBY").value;
            var certType = document.getElementById("gs_CertType").value;
            var createdTime = document.getElementById("gs_CREATIONTIME").value;
            var validFrom = document.getElementById("gs_VALID_FROM").value;
            var validTo = document.getElementById("gs_VALID_TO").value;
            var requestedBy = document.getElementById("gs_USERNAME").value;
            var status = document.getElementById("gs_STATUS").value;
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate;
            var params = '&authorizedby='+authorizedby+'&commonName='+domainNames+'&certType='+certType+'&createdTime='+createdTime+'&validFrom='+validFrom+'&validTo='+validTo+'&requestedBy='+requestedBy+'&status='+status+'&sday='+sday+'&eday='+eday;//NO I18N
            if(sday!==""&&eday!==""&&!validateCriteria())
            {
                return;
            }
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                locReplaceURL("/apiclient/ajaxResponse.jsp?RequestType=exportCsv&ReportType=GoDaddyOrdersReport"+params);//NO I18N
            }
            else{
                messageNotification("messageNotifyFailure",I18N.getMsg("js.report.export.noDataAvailableToExport"));//No I18N
            }    
        },
        dataCheck:function()
        {
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate;
            var app=this.get('controllers.application');
            if(sday!==""&&eday!==""&&!validateCriteria())
            {
                return;
            }
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                app.send('opendialog','EmailNotify');//NO I18N
            }else{
             messageNotification("messageNotifyFailure",I18N.getMsg("js.report.datacheck.noDataAvailable"));//No I18N
            }
        }
    }
});

App.ReportUserAuditReportController = Ember.ObjectController.extend({
    needs:'application',//NO I18N
    actions : {
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        go:function()
        {                    
            if(validateCriteria())
            {
                var sday=App.ReportController.fromdate;
                var eday=App.ReportController.todate;
                App.ReportController.scheduleType="UserAuditReport";//No I18N
                var reqParams='&scheduleType='+'UserAuditReport'+'&TIME_FILTER_FIELD=PKIAudit__OPERATIONAUDITTIME'+'&TIME_DURATION='+sday+','+eday;//No I18N
                createUserAuditList(reqParams);
            }
        },
        exportPdf:function()
        {
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate;
            if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            exportPdfReport(ids,sday,eday);
        },
        exportCsv:function()
        {
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate;
            if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
           var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            exportCsvReport(ids,sday,eday);
        },
        dataCheck:function()
        {
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate;
            var app=this.get('controllers.application');
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            App.ReportController.scheduleType="UserAuditReport";//No I18N
            if(sday!==""&&eday!==""&&!validateCriteria())
            {
                return;
            }
            if(ids.length>0)
            {
                app.send('opendialog','EmailNotify');//NO I18N
            }else{
             messageNotification("messageNotifyFailure",I18N.getMsg("js.report.datacheck.noDataAvailable"));//No I18N
            }
        }
    }
});



App.ReportKeyStoreReportController = Ember.ObjectController.extend({
    needs:'application',//NO I18N
    actions:{
        close:function(){
            return this.send('closeModal');//NO I18N
        },
        go: function()
        {
            if(validateCriteria())
            {
                App.ReportController.scheduleType="EncryptionKeysReport";//No I18N      
                var sday=App.ReportController.fromdate;
                var eday=App.ReportController.todate;
                var keyname=document.getElementById("gs_Key Name").value;//NO I18N
                var keytype=document.getElementById("gs_Key Type").value;//NO I18N
                var instancename=document.getElementById("gs_Instance Name").value;//NO I18N
                var datacenter=document.getElementById("gs_Datacenter").value;//NO I18N
                var description=document.getElementById("gs_Description").value;//NO I18N
                var createdby=document.getElementById("gs_Created By").value;//NO I18N
                var createdtime=document.getElementById("gs_Created Time").value;//NO I18N
                var reqParams = "&SDAY="+sday+"&EDAY="+eday+"&keyname="+keyname+"&keytype="+keytype+"&instancename="+instancename+"&datacenter="+datacenter+"&description="+description+"&createdby="+createdby+"&createdtime="+createdtime;//NO I18N
                var ajaxRequestUrl = '/api/pki/encryptionKey/getEncryptionKeys'; //No I18N
                getAjaxApiRequest(ajaxRequestUrl,reqParams,function(jsonData){
                    createEncryptionKeysList(jsonData);
                });
            }
        },
        exportPdf:function()
        {
            App.ReportController.scheduleType="EncryptionKeysReport";//No I18N      
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate;
            if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
            var keyname=document.getElementById("gs_Key Name").value;//NO I18N
            var keytype=document.getElementById("gs_Key Type").value;//NO I18N
            var instancename=document.getElementById("gs_Instance Name").value;//NO I18N
            var datacenter=document.getElementById("gs_Datacenter").value;//NO I18N
            var description=document.getElementById("gs_Description").value;//NO I18N
            var createdby=document.getElementById("gs_Created By").value;//NO I18N
            var createdtime=document.getElementById("gs_Created Time").value;//NO I18N
            var reqParams = "&SDAY="+sday+"&EDAY="+eday+"&keyname="+keyname+"&keytype="+keytype+"&instancename="+instancename+"&datacenter="+datacenter+"&description="+description+"&createdby="+createdby+"&createdtime="+createdtime;//NO I18N
            if(sday!==""&&eday!==""&&!validateCriteria())
            {
                return;
            }
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                locReplaceURL("/apiclient/ajaxResponse.jsp?RequestType=exportPdf&ReportType=EncryptionKeysReport"+reqParams);//NO I18N
            }else{
                messageNotification("messageNotifyFailure",I18N.getMsg("js.report.export.noDataAvailableToExport"));//No I18N
            }    
        },
        exportCsv:function()
        {
            App.ReportController.scheduleType="EncryptionKeysReport";//No I18N      
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate;
            if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
            var keyname=document.getElementById("gs_Key Name").value;//NO I18N
            var keytype=document.getElementById("gs_Key Type").value;//NO I18N
            var instancename=document.getElementById("gs_Instance Name").value;//NO I18N
            var datacenter=document.getElementById("gs_Datacenter").value;//NO I18N
            var description=document.getElementById("gs_Description").value;//NO I18N
            var createdby=document.getElementById("gs_Created By").value;//NO I18N
            var createdtime=document.getElementById("gs_Created Time").value;//NO I18N
            var reqParams = "&SDAY="+sday+"&EDAY="+eday+"&keyname="+keyname+"&keytype="+keytype+"&instancename="+instancename+"&datacenter="+datacenter+"&description="+description+"&createdby="+createdby+"&createdtime="+createdtime;//NO I18N
            if(sday!==""&&eday!==""&&!validateCriteria())
            {
                return;
            }
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                locReplaceURL("/apiclient/ajaxResponse.jsp?RequestType=exportCsv&ReportType=EncryptionKeysReport"+reqParams);//NO I18N
            }else{
                messageNotification("messageNotifyFailure",I18N.getMsg("js.report.export.noDataAvailableToExport"));//No I18N
            }    
        },
        dataCheck:function()
        {
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate;
            App.ReportController.scheduleType="EncryptionKeysReport";//No I18N
            var app=this.get('controllers.application');
            if(sday!==""&&eday!==""&&!validateCriteria())
            {
                return;
            }
                var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                app.send('opendialog','EmailNotify');//NO I18N
            }else{
             messageNotification("messageNotifyFailure",I18N.getMsg("js.report.datacheck.noDataAvailable"));//No I18N
            }
        }
        
    }
});


App.ReportAllKeysReportController = Ember.ObjectController.extend({
    needs:'application',//NO I18N
    actions: {
        close: function(){
            return this.send('closeModal');//NO I18N
        },
        go:function()
        {
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate;
            App.ReportController.scheduleType="AllKeysReport";//No I18N        
            var keyname = document.getElementById("gs_Key Name").value;//NO I18N
            var keytype = document.getElementById("gs_Type").value;//NO I18N
            var createdby = document.getElementById("gs_Created By").value;//NO I18N
            var createdtime = document.getElementById("gs_Created Time").value;//NO I18N
            var reqParams = "&SDAY="+sday+"&EDAY="+eday+"&keyname="+keyname+"&keytype="+keytype+"&createdby="+createdby+"&createdtime="+createdtime;//NO I18N
            var ajaxRequestUrl = '/api/pki/Inventory/listallkeys';//NO I18N
            getAjaxApiRequest(ajaxRequestUrl,reqParams,function(jsonData){
                    createAllKeysList(jsonData);
                });
        },
        exportPdf: function()
        {
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate;
            App.ReportController.scheduleType="AllKeysReport";//No I18N        
            if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
            var keyname = document.getElementById("gs_Key Name").value;//NO I18N
            var keytype = document.getElementById("gs_Type").value;//NO I18N
            var createdby = document.getElementById("gs_Created By").value;//NO I18N
            var createdtime = document.getElementById("gs_Created Time").value;//NO I18N
            var reqParams = "&SDAY="+sday+"&EDAY="+eday+"&keyname="+keyname+"&keytype="+keytype+"&createdby="+createdby+"&createdtime="+createdtime;//NO I18N
            if(sday!==""&&eday!==""&&!validateCriteria())
            {
                return;
            }
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                locReplaceURL("/apiclient/ajaxResponse.jsp?RequestType=exportPdf&ReportType=AllKeysReport"+reqParams);//NO I18N
            }else{
                messageNotification("messageNotifyFailure",I18N.getMsg("js.report.export.noDataAvailableToExport"));//No I18N
            }
        },
        exportCsv:function()
        {
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate;
            App.ReportController.scheduleType="AllKeysReport";//No I18N        
            if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
            var keyname = document.getElementById("gs_Key Name").value;//NO I18N
            var keytype = document.getElementById("gs_Type").value;//NO I18N
            var createdby = document.getElementById("gs_Created By").value;//NO I18N
            var createdtime = document.getElementById("gs_Created Time").value;//NO I18N
            var reqParams = "&SDAY="+sday+"&EDAY="+eday+"&keyname="+keyname+"&keytype="+keytype+"&createdby="+createdby+"&createdtime="+createdtime;//NO I18N
            if(sday!==""&&eday!==""&&!validateCriteria())
            {
                return;
            }
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                locReplaceURL("/apiclient/ajaxResponse.jsp?RequestType=exportCsv&ReportType=AllKeysReport"+reqParams);//NO I18N
            }else{
                messageNotification("messageNotifyFailure",I18N.getMsg("js.report.export.noDataAvailableToExport"));//No I18N
            }
        },
        dataCheck:function()
        {
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate;
            App.ReportController.scheduleType="AllKeysReport";//No I18N
            var app=this.get('controllers.application');
            if(sday!==""&&eday!==""&&!validateCriteria())
            {
                return;
            }
                var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                app.send('opendialog','EmailNotify');//NO I18N
            }else{
             messageNotification("messageNotifyFailure",I18N.getMsg("js.report.datacheck.noDataAvailable"));//No I18N
            }
        }
        
    }
    
});



App.ReportKeyDeplotmentController = Ember.ObjectController.extend({
     needs:'application',//NO I18N
    actions : {
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        go:function()
        {
            if(validateCriteria())
            {
                
                var sday=App.ReportController.fromdate;
                var eday=App.ReportController.todate;
                var username=document.getElementById("gs_UserName").value;//NO I18N                
                var keyname=document.getElementById("gs_KeyName").value;
                var resname=document.getElementById("gs_ResourceName").value;
                var keytype=document.getElementById("gs_KeyType").value;
                var keylength=document.getElementById("gs_KeyLength").value;
                var ajaxRequestUrl = '/api/pki/report/keydepdetail'; //No I18N
                App.ReportController.scheduleType="PublicKeyDeploymentReport";//No I18N                          
                var reqParams="&UserName="+username+"&KeyName="+keyname+"&ResourceName="+resname+"&KeyType="+keytype+"&KeyLength="+keylength+'&SDAY='+sday+'&EDAY='+eday;//No I18N
                getAjaxApiRequest(ajaxRequestUrl,reqParams,function(jsonData){
                    createKeyDeploymentList(jsonData);
                });
                                
            }
          
        },
        exportPdf:function()
        {
            if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
            var username=document.getElementById("gs_UserName").value;//NO I18N
            var keyname=document.getElementById("gs_KeyName").value;
            var resname=document.getElementById("gs_ResourceName").value;
            var keytype=document.getElementById("gs_KeyType").value;
            var keylength=document.getElementById("gs_KeyLength").value;
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate;
            var params="&UserName="+username+"&KeyName="+keyname+"&ResourceName="+resname+"&KeyType="+keytype+"&KeyLength="+keylength+'&SDAY='+sday+'&EDAY='+eday;//NO I18N
            var ajaxRequestUrl = '/api/pki/report/keydepdetail'; //No I18N
            App.ReportController.scheduleType="PublicKeyDeploymentReport";//No I18N
            if(sday!==""&&eday!==""&&!validateCriteria())
            {
                return;
            }
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                locReplaceURL("/apiclient/ajaxResponse.jsp?RequestType=exportPdf&ReportType=KeyDeployment"+params);//NO I18N
            }else{
                messageNotification("messageNotifyFailure",I18N.getMsg("js.report.export.noDataAvailableToExport"));//No I18N
            }
        },
        exportCsv:function()
        {
            if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
            var username=document.getElementById("gs_UserName").value;//NO I18N
            var keyname=document.getElementById("gs_KeyName").value;
            var resname=document.getElementById("gs_ResourceName").value;
            var keytype=document.getElementById("gs_KeyType").value;
            var keylength=document.getElementById("gs_KeyLength").value;
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate;
            var params="&UserName="+username+"&KeyName="+keyname+"&ResourceName="+resname+"&KeyType="+keytype+"&KeyLength="+keylength+'&SDAY='+sday+'&EDAY='+eday;//NO I18N
            var ajaxRequestUrl = '/api/pki/report/keydepdetail'; //No I18N
            App.ReportController.scheduleType="PublicKeyDeploymentReport";//No I18N
            if(sday!==""&&eday!==""&&!validateCriteria())
            {
                return;
            }
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                locReplaceURL("/apiclient/ajaxResponse.jsp?RequestType=exportCsv&ReportType=KeyDeployment"+params);//NO I18N
            }else{
                messageNotification("messageNotifyFailure",I18N.getMsg("js.report.export.noDataAvailableToExport"));//No I18N
            }
                        
        },
        dataCheck:function()
        {
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate;
            App.ReportController.scheduleType="PublicKeyDeploymentReport";//No I18N
            var app=this.get('controllers.application');
            if(sday!==""&&eday!==""&&!validateCriteria())
            {
                return;
            }
                var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                app.send('opendialog','EmailNotify');//NO I18N
            }else{
             messageNotification("messageNotifyFailure",I18N.getMsg("js.report.datacheck.noDataAvailable"));//No I18N
            }
        }
    }
});

App.ReportPrivatekeyReportController = Ember.ObjectController.extend({
     needs:'application',//NO I18N
    actions : {
        go:function()
        {                    
            if(validateCriteria())
            {
                var select = $('#GROUPS');
                var groupId = select.val();
                var groupName = $( "#GROUPS option:selected" ).text();
                if(groupId === "allgroups")
                {
                    groupId="";
                    groupName="";
                }
                var keyname=document.getElementById("gs_KeyName").value;//NO I18N                
                var keytype=document.getElementById("gs_KeyType").value;
                var keylength=document.getElementById("gs_KeyLength").value;
                var fingerprint=document.getElementById("gs_FingerPrint").value;
                var createdby=document.getElementById("gs_CreatedBy").value;
                var creationtime=document.getElementById("gs_CreationTime").value;                
                var sday=App.ReportController.fromdate;
                var eday=App.ReportController.todate;
                var reqParams="groupId="+groupId+"&groupName="+groupName+"keyname="+keyname+"&keytype="+keytype+"&keylength="+keylength+"&fingerprint="+fingerprint+"&createdby="+createdby+"&creationtime="+creationtime+"&SDAY="+sday+"&EDAY="+eday+"&scheduletype="+"PrivateKeyReport";//NO I18N
                var ajaxRequestUrl = '/api/pki/ssh/getSSHKeysReport'; //No I18N
                App.ReportController.scheduleType="PrivateKeyReport";//No I18N
                getAjaxApiRequest(ajaxRequestUrl,reqParams,function(jsonData){
                    createKeyList(jsonData);
                });
                                
            }
          
        },
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        exportPdf:function()
        {
            if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
            var select = $('#GROUPS');
            var groupId = select.val();
            var groupName = $( "#GROUPS option:selected" ).text();
            if(groupId === "allgroups")
            {
                groupId="";
                groupName="";
            }
            var keyname=document.getElementById("gs_KeyName").value;//NO I18N                
            var keytype=document.getElementById("gs_KeyType").value;
            var keylength=document.getElementById("gs_KeyLength").value;
            var fingerprint=document.getElementById("gs_FingerPrint").value;
            var createdby=document.getElementById("gs_CreatedBy").value;
            var creationtime=document.getElementById("gs_CreationTime").value;            
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate;
            var ajaxRequestUrl = '/api/pki/ssh/getSSHKeysReport'; //No I18N
            App.ReportController.scheduleType="PrivateKeyReport";//No I18N
            var reqParams="&groupName="+groupName+"&groupId="+groupId+"&keyname="+keyname+"&keytype="+keytype+"&keylength="+keylength+"&fingerprint="+fingerprint+"&createdby="+createdby+"&creationtime="+creationtime+"&SDAY="+sday+"&EDAY="+eday+"&scheduleType="+"PrivateKeyReport";//NO I18N
            if(sday!==""&&eday!==""&&!validateCriteria())
            {
                return;
            }
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                locReplaceURL("/apiclient/ajaxResponse.jsp?RequestType=exportPdf&ReportType=PrivateKeyReport"+reqParams);//NO I18N
            }else{
                messageNotification("messageNotifyFailure",I18N.getMsg("js.report.export.noDataAvailableToExport"));//No I18N
            }           
           
        },
        exportCsv:function()
        {
            if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
            var select = $('#GROUPS');
            var groupId = select.val();
            var groupName = $( "#GROUPS option:selected" ).text();
            if(groupId === "allgroups")
            {
                groupId="";
                groupName="";
            }
            var keyname=document.getElementById("gs_KeyName").value;//NO I18N                
            var keytype=document.getElementById("gs_KeyType").value;
            var keylength=document.getElementById("gs_KeyLength").value;
            var fingerprint=document.getElementById("gs_FingerPrint").value;
            var createdby=document.getElementById("gs_CreatedBy").value;
            var creationtime=document.getElementById("gs_CreationTime").value;            
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate;
            var ajaxRequestUrl = '/api/pki/ssh/getSSHKeysReport'; //No I18N
            App.ReportController.scheduleType="PrivateKeyReport";//No I18N
            var reqParams="&groupName="+groupName+"&groupId="+groupId+"&keyname="+keyname+"&keytype="+keytype+"&keylength="+keylength+"&fingerprint="+fingerprint+"&createdby="+createdby+"&creationtime="+creationtime+"&SDAY="+sday+"&EDAY="+eday+"&scheduleType="+"PrivateKeyReport";//NO I18N
            if(sday!==""&&eday!==""&&!validateCriteria())
            {
                return;
            }
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                locReplaceURL("/apiclient/ajaxResponse.jsp?RequestType=exportCsv&ReportType=PrivateKeyReport"+reqParams);//NO I18N
            }else{
                messageNotification("messageNotifyFailure",I18N.getMsg("js.report.export.noDataAvailableToExport"));//No I18N
            }
              
        },
        dataCheck:function()
        {
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate;
            App.ReportController.scheduleType="PrivateKeyReport";//No I18N
            var app=this.get('controllers.application');
            if(sday!==""&&eday!==""&&!validateCriteria())
            {
              return;
            }
                var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                app.send('opendialog','EmailNotify');//NO I18N
            }else{
             messageNotification("messageNotifyFailure",I18N.getMsg("js.report.datacheck.noDataAvailable"));//No I18N
            }
    }
    }
});

App.ReportKeyRotationReportController = Ember.ObjectController.extend({
    needs:'application',//NO I18N
    actions : {
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        go: function(){
            if(validateCriteria())
            {
                var keyname=document.getElementById("gs_Key_Name").value;
                var invokedon=document.getElementById("gs_KeyRotationInvokedOn").value;
                var finishtime=document.getElementById("gs_FinishTime").value;
                var status=document.getElementById("gs_KeyRotation_Status").value;
                var sday=App.ReportController.fromdate;
                var eday=App.ReportController.todate;       
                App.ReportController.scheduleType="PrivateKeyRotationReport";//No I18N
                var ajaxRequestUrl = '/api/pki/ssh/getKeyRotationAudit?keyStateId=2'; //No I18N
                var reqParams='&keyname='+keyname+'&invokedon='+invokedon+'&finishtime='+finishtime+'&status='+status+'&scheduleType='+"PrivateKeyRotationReport"+'&SDAY='+sday+'&EDAY='+eday;//No I18N
                getAjaxApiRequest(ajaxRequestUrl,reqParams,function(jsonData){
                    createKeyRotationList(jsonData);
                });
                                
            }
            
        },
        exportPdf:function()
        {
            if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
            var keyname=document.getElementById("gs_Key_Name").value;
            var invokedon=document.getElementById("gs_KeyRotationInvokedOn").value;
            var finishtime=document.getElementById("gs_FinishTime").value;
            var status=document.getElementById("gs_KeyRotation_Status").value;
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate; 
            App.ReportController.scheduleType="PrivateKeyRotationReport";//No I18N
            var ajaxRequestUrl = '/api/pki/ssh/getKeyRotationAudit?keyStateId=2'; //No I18N
            var reqParams='&keyname='+keyname+'&invokedon='+invokedon+'&finishtime='+finishtime+'&status='+status+'&scheduleType='+"PrivateKeyRotationReport"+'&SDAY='+sday+'&EDAY='+eday;//No I18N
            if(sday!==""&&eday!==""&&!validateCriteria())
            {
                return;
            }
           var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                locReplaceURL("/apiclient/ajaxResponse.jsp?RequestType=exportPdf&ReportType=KeyRotationReport"+reqParams);//NO I18N
            }else{
                messageNotification("messageNotifyFailure",I18N.getMsg("js.report.export.noDataAvailableToExport"));//No I18N
            }
             
        },
        exportCsv:function(){
            if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
            var keyname=document.getElementById("gs_Key_Name").value;
            var invokedon=document.getElementById("gs_KeyRotationInvokedOn").value;
            var finishtime=document.getElementById("gs_FinishTime").value;
            var status=document.getElementById("gs_KeyRotation_Status").value;
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate;
            App.ReportController.scheduleType="PrivateKeyRotationReport";//No I18N
            var ajaxRequestUrl = '/api/pki/ssh/getKeyRotationAudit?keyStateId=2'; //No I18N
            var reqParams='&keyname='+keyname+'&invokedon='+invokedon+'&finishtime='+finishtime+'&status='+status+'&scheduleType='+"PrivateKeyRotationReport"+'&SDAY='+sday+'&EDAY='+eday;//No I18N
            if(sday!==""&&eday!==""&&!validateCriteria())
            {
                return;
            }
           var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                locReplaceURL("/apiclient/ajaxResponse.jsp?RequestType=exportCsv&ReportType=KeyRotationReport"+reqParams);//NO I18N
            }else{
                messageNotification("messageNotifyFailure",I18N.getMsg("js.report.export.noDataAvailableToExport"));//No I18N
            }
               
        },
        dataCheck:function()
        {
           var sday=App.ReportController.fromdate;
           var eday=App.ReportController.todate;
            App.ReportController.scheduleType="PrivateKeyRotationReport";//No I18N
            var app=this.get('controllers.application');
            if(sday!==""&&eday!==""&&!validateCriteria())
            {
                return;
            }            
               var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                app.send('opendialog','EmailNotify');//NO I18N
            }else{
             messageNotification("messageNotifyFailure",I18N.getMsg("js.report.datacheck.noDataAvailable"));//No I18N
            }
        }
    }
});

App.ReportServerAccessAuditController = Ember.ObjectController.extend({
     needs:'application',//NO I18N
    actions : {
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        go: function(){
            if(validateCriteria())
            {
                var resourcename=document.getElementById("gs_ResourceName").value;
                var username=document.getElementById("gs_UserName").value;
                var executedon=document.getElementById("gs_Executed On").value;
                var status=document.getElementById("gs_Status").value;
                var sday=App.ReportController.fromdate;
                var eday=App.ReportController.todate;     
                App.ReportController.scheduleType="ServerAccessAuditReport";//No I18N
                var ajaxRequestUrl = '/api/pki/report/getServerAccessAuditView'; //No I18N
                var reqParams='resourcename='+resourcename+'&username='+username+'&executedon='+executedon+'&status='+status+'&scheduleType='+"ServerAccessAuditReport"+'&SDAY='+sday+'&EDAY='+eday;//No I18N
                getAjaxApiRequest(ajaxRequestUrl,reqParams,function(jsonData){
                    createServerAccessAuditList(jsonData);
                });
                                
            }
            
        },
        exportPdf:function()
        {
            if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
            var resourcename=document.getElementById("gs_ResourceName").value;
            var username=document.getElementById("gs_UserName").value;
            var executedon=document.getElementById("gs_Executed On").value;
            var status=document.getElementById("gs_Status").value;
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate;      
            App.ReportController.scheduleType="ServerAccessAuditReport";//No I18N
            var ajaxRequestUrl = '/api/pki/report/getServerAccessAuditView'; //No I18N
            var reqParams='&resourcename='+resourcename+'&username='+username+'&executedon='+executedon+'&status='+status+'&scheduleType='+"ServerAccessAuditReport"+'&SDAY='+sday+'&EDAY='+eday;//No I18N
            if(sday!==""&&eday!==""&&!validateCriteria())
            {
                return;
            }
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                locReplaceURL("/apiclient/ajaxResponse.jsp?RequestType=exportPdf&ReportType=ServerAccessAudit"+reqParams);//NO I18N
            }else{
                messageNotification("messageNotifyFailure",I18N.getMsg("js.report.export.noDataAvailableToExport"));//No I18N
            }
                   
            
        },
        exportCsv:function()
        {
            if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
            var resourcename=document.getElementById("gs_ResourceName").value;
            var username=document.getElementById("gs_UserName").value;
            var executedon=document.getElementById("gs_Executed On").value;
            var status=document.getElementById("gs_Status").value;
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate;
            App.ReportController.scheduleType="ServerAccessAuditReport";//No I18N
            var ajaxRequestUrl = '/api/pki/report/getServerAccessAuditView'; //No I18N
            var reqParams='&resourcename='+resourcename+'&username='+username+'&executedon='+executedon+'&status='+status+'&scheduleType='+"ServerAccessAuditReport"+'&SDAY='+sday+'&EDAY='+eday;//No I18N
            if(sday!==""&&eday!==""&&!validateCriteria())
            {
                return;
            }
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                locReplaceURL("/apiclient/ajaxResponse.jsp?RequestType=exportCsv&ReportType=ServerAccessAudit"+reqParams);//NO I18N
            }else{
                messageNotification("messageNotifyFailure",I18N.getMsg("js.report.export.noDataAvailableToExport"));//No I18N
            }
                
        },
        dataCheck:function()
        {
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate;
            App.ReportController.scheduleType="ServerAccessAuditReport";//No I18N
            var app=this.get('controllers.application');
            if(sday!==""&&eday!==""&&!validateCriteria())
            {
                return;
            }            
                var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                app.send('opendialog','EmailNotify');//NO I18N
            }else{
             messageNotification("messageNotifyFailure",I18N.getMsg("js.report.datacheck.noDataAvailable"));//No I18N
            }
        }
    }
});

App.ReportSSLRequestController = Ember.ObjectController.extend({
     needs:'application',//NO I18N
    actions : {
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        go: function(){
            if(validateCriteria())
            {
                var subdomain = document.getElementById("gs_SubDomain").value;
                var parentdomain= document.getElementById("gs_ParentDomain").value;
                var startdate= document.getElementById("gs_StartDate").value;
                var closedate= document.getElementById("gs_ClosedDate").value;
                var requestname= document.getElementById("gs_Requested By").value;
                var status = document.getElementById("gs_Status").value;
                var sday=App.ReportController.fromdate;
                var eday=App.ReportController.todate;   
                App.ReportController.scheduleType="SSLRequestReport";//No I18N
                var ajaxRequestUrl = '/api/pki/request/RequestList'; //No I18N
                var reqParams='&SDAY='+sday+'&EDAY='+eday+'&subdomain='+subdomain+'&parentdomain='+parentdomain+'&startdate='+startdate+'&closedate='+closedate+'&requestname='+requestname+'&status='+status;//No I18N
                getAjaxApiRequest(ajaxRequestUrl,reqParams,function(jsonData){
                    createSslRequestList(jsonData);
                });
                                
            }
            
        },
        exportPdf:function()
        {
            if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
            var subdomain = document.getElementById("gs_SubDomain").value;
            var parentdomain= document.getElementById("gs_ParentDomain").value;
            var startdate= document.getElementById("gs_StartDate").value;
            var closedate= document.getElementById("gs_ClosedDate").value;
            var requestname= document.getElementById("gs_Requested By").value;
            var status = document.getElementById("gs_Status").value;
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate;
            App.ReportController.scheduleType="SSLRequestReport";//No I18N
            var reqParams='&SDAY='+sday+'&EDAY='+eday+'&subdomain='+subdomain+'&parentdomain='+parentdomain+'&startdate='+startdate+'&closedate='+closedate+'&requestname='+requestname+'&status='+status;//No I18N
            if(sday!==""&&eday!==""&&!validateCriteria())
            {
                return;
            }
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                locReplaceURL("/apiclient/ajaxResponse.jsp?RequestType=exportPdf&ReportType=SSLRequestReport"+reqParams);//NO I18N
            }else{
                messageNotification("messageNotifyFailure",I18N.getMsg("js.report.export.noDataAvailableToExport"));//No I18N
            }  
        },
        exportCsv:function()
                    {
            if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
            var subdomain = document.getElementById("gs_SubDomain").value;
            var parentdomain= document.getElementById("gs_ParentDomain").value;
            var startdate= document.getElementById("gs_StartDate").value;
            var closedate= document.getElementById("gs_ClosedDate").value;
            var requestname= document.getElementById("gs_Requested By").value;
            var status = document.getElementById("gs_Status").value;
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate;   
            App.ReportController.scheduleType="SSLRequestReport";//No I18N
            var reqParams='&SDAY='+sday+'&EDAY='+eday+'&subdomain='+subdomain+'&parentdomain='+parentdomain+'&startdate='+startdate+'&closedate='+closedate+'&requestname='+requestname+'&status='+status;//No I18N
            if(sday!==""&&eday!==""&&!validateCriteria())
                    {
                return;
            }
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                locReplaceURL("/apiclient/ajaxResponse.jsp?RequestType=exportCsv&ReportType=SSLRequestReport"+reqParams);//NO I18N
            }else{
                messageNotification("messageNotifyFailure",I18N.getMsg("js.report.export.noDataAvailableToExport"));//No I18N
            }  
        },
        dataCheck:function()
        {
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate;
            App.ReportController.scheduleType="SSLRequestReport";//No I18N
            var app=this.get('controllers.application');
            if(sday!==""&&eday!==""&&!validateCriteria())
            {
                return;
            }            
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                app.send('opendialog','EmailNotify');//NO I18N
            }else{
                messageNotification("messageNotifyFailure",I18N.getMsg("js.report.datacheck.noDataAvailable"));//No I18N
    }
        }
    }
});

App.ReportSSLCertificateController = Ember.ObjectController.extend({
     needs:'application',//NO I18N
    actions : {
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        go: function(){
            if(validateCriteria())
            {
                var groupId="";
                var groupName="";
                if(window.userRole === "Administrator")
                {
                    var select = $('#GROUPS');
                    var group = select.attr("name");//NO I18N
                    groupId = select.val();
                    groupName = $( "#GROUPS option:selected" ).text();
                    if(groupId === 'allgroups')
                    {
                        groupId="";
                        groupName="";
                    }
                }
                var resourcename=document.getElementById("gs_Common Name").value;
                var description = document.getElementById("gs_Description").value;
                var domainname=document.getElementById("gs_DNS Name/FQDN").value;
                var organization=document.getElementById("gs_Organization").value;
                var fromdate=document.getElementById("gs_FromDate").value;
                var expirydate=document.getElementById("gs_ExpiryDate").value;
                var keylength=document.getElementById("gs_KeyStrength").value;
                var keyAlgorithm=document.getElementById("gs_keyAlgorithm").value;
                var signatureAlgorithm=document.getElementById("gs_signatureAlgorithm").value;
                var creationtime = document.getElementById("gs_CreationTime").value;
                var sday=App.ReportController.fromdate;
                var eday=App.ReportController.todate;        
                App.ReportController.scheduleType="SslCertificateReport";//No I18N
                var ajaxRequestUrl = '/api/pki/Inventory/listsslSummary'; //No I18N
                var reqParams='&groupId='+groupId+'&groupName='+groupName+'&description='+description+'&SDAY='+sday+'&EDAY='+eday+'&fromdate='+fromdate+'&creationtime='+creationtime+'&resourcename='+resourcename+'&domainname='+domainname+'&organization='+organization+'&expirydate='+expirydate+'&keylength='+keylength+'&keyAlgorithm='+keyAlgorithm+'&signatureAlgorithm='+signatureAlgorithm;//No I18N
                getAjaxApiRequest(ajaxRequestUrl,reqParams,function(jsonData){
                    createSslList(jsonData);
                });
                                
            }
            
        },
        exportPdf:function()
        {
            if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
            var groupId="";
            var groupName="";
            if(window.userRole === "Administrator")
            {
                var select = $('#GROUPS');
                var group = select.attr("name");//NO I18N
                groupId = select.val();
                groupName = $( "#GROUPS option:selected" ).text();
                if(groupId === 'allgroups')
                {
                    groupId="";
                    groupName="";
                }
            }
            var resourcename=document.getElementById("gs_Common Name").value;
            var description = document.getElementById("gs_Description").value;
            var domainname=document.getElementById("gs_DNS Name/FQDN").value;
            var organization=document.getElementById("gs_Organization").value;
            var fromdate=document.getElementById("gs_FromDate").value;
            var expirydate=document.getElementById("gs_ExpiryDate").value;
            var keylength=document.getElementById("gs_KeyStrength").value;
            var keyAlgorithm=document.getElementById("gs_keyAlgorithm").value;
            var signatureAlgorithm=document.getElementById("gs_signatureAlgorithm").value;
            var creationtime = document.getElementById("gs_CreationTime").value;
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate;    
            App.ReportController.scheduleType="SslCertificateReport";//No I18N
            var reqParams='&groupId='+groupId+'&groupName='+groupName+'&description='+description+'&SDAY='+sday+'&EDAY='+eday+'&fromdate='+fromdate+'&creationtime='+creationtime+'&resourcename='+resourcename+'&domainname='+domainname+'&organization='+organization+'&expirydate='+expirydate+'&keylength='+keylength+'&keyAlgorithm='+keyAlgorithm+'&signatureAlgorithm='+signatureAlgorithm;//No I18N
            if(sday!==""&&eday!==""&&!validateCriteria())
            {
                return;
            }
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                locReplaceURL("/apiclient/ajaxResponse.jsp?RequestType=exportPdf&ReportType=SSLCertificateReport"+reqParams);//NO I18N
            }else{
                messageNotification("messageNotifyFailure",I18N.getMsg("js.report.export.noDataAvailableToExport"));//No I18N
            }                      
            
        },
        exportCsv:function()
                    {
            if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
            var groupId="";
            var groupName="";
            if(window.userRole === "Administrator")
            {
                var select = $('#GROUPS');
                var group = select.attr("name");//NO I18N
                groupId = select.val();
                groupName = $( "#GROUPS option:selected" ).text();
                if(groupId === 'allgroups')
                {
                    groupId="";
                    groupName="";
                }
            }
            var resourcename=document.getElementById("gs_Common Name").value;
            var description = document.getElementById("gs_Description").value;
            var domainname=document.getElementById("gs_DNS Name/FQDN").value;
            var organization=document.getElementById("gs_Organization").value;
            var fromdate=document.getElementById("gs_FromDate").value;
            var expirydate=document.getElementById("gs_ExpiryDate").value;
            var keylength=document.getElementById("gs_KeyStrength").value;
            var signatureAlgorithm=document.getElementById("gs_signatureAlgorithm").value;
            var keyAlgorithm=document.getElementById("gs_keyAlgorithm").value;
            var creationtime = document.getElementById("gs_CreationTime").value;
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate;
            App.ReportController.scheduleType="SslCertificateReport";//No I18N
            var reqParams='&groupId='+groupId+'&groupName='+groupName+'&description='+description+'&SDAY='+sday+'&EDAY='+eday+'&fromdate='+fromdate+'&creationtime='+creationtime+'&signatureAlgorithm='+signatureAlgorithm+'&resourcename='+resourcename+'&domainname='+domainname+'&organization='+organization+'&expirydate='+expirydate+'&keylength='+keylength+'&keyAlgorithm='+keyAlgorithm;//No I18N
            if(sday!==""&&eday!==""&&!validateCriteria())
                    {
                return;
            }
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                locReplaceURL("/apiclient/ajaxResponse.jsp?RequestType=exportCsv&ReportType=SSLCertificateReport"+reqParams);//NO I18N
            }else{
                messageNotification("messageNotifyFailure",I18N.getMsg("js.report.export.noDataAvailableToExport"));//No I18N
            }           
        },
        dataCheck:function()
        {
           var sday=App.ReportController.fromdate;
           var eday=App.ReportController.todate;
            App.ReportController.scheduleType="SslCertificateReport";//No I18N
            var app=this.get('controllers.application');
            if(sday!==""&&eday!==""&&!validateCriteria())
            {
                return;
            }
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                app.send('opendialog','EmailNotify');//NO I18N
            }else{
             messageNotification("messageNotifyFailure",I18N.getMsg("js.report.datacheck.noDataAvailable"));//No I18N
            }            
        }
    }
});

App.VulnerabilitiesPopUpController = Ember.ObjectController.extend({
   needs:'application',//NO I18N
   actions:{
       close:function(){
           clearTimeout(timoutFunction);
           return this.send('closeModal');//NO I18N
       }
   }
});

App.ReportSSLVulnerabilitiesReportController = Ember.ObjectController.extend({
     needs:'application',//NO I18N
    actions : {
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        go: function(){
            if(validateCriteria())
            {
                var groupId="";
                var groupName="";
                if(window.userRole === "Administrator")
                {
                    var select = $('#GROUPS');
                    var group = select.attr("name");//NO I18N
                    groupId = select.val();
                    groupName = $( "#GROUPS option:selected" ).text();
                    if(groupId === 'allgroups')
                    {
                        groupId="";
                        groupName="";
                    }
                }
                var resourcename=document.getElementById("gs_Common Name").value;
                var description = document.getElementById("gs_Description").value;
                var domainname=document.getElementById("gs_DNS Name/FQDN").value;
                var organization=document.getElementById("gs_Organization").value;
                var fromdate=document.getElementById("gs_FromDate").value;
                var expirydate=document.getElementById("gs_ExpiryDate").value;
                var keylength=document.getElementById("gs_KeyStrength").value;
                var keyAlgorithm=document.getElementById("gs_keyAlgorithm").value;
                var signatureAlgorithm=document.getElementById("gs_signatureAlgorithm").value;
                var creationtime = document.getElementById("gs_CreationTime").value;
                var sday=App.ReportController.fromdate;
                var eday=App.ReportController.todate;        
                App.ReportController.scheduleType="SSLVulnerabilitiesReport";//No I18N
                var ajaxRequestUrl = '/api/pki/Inventory/listsslSummary'; //No I18N
                var reqParams='&groupId='+groupId+'&groupName='+groupName+'&description='+description+'&SDAY='+sday+'&EDAY='+eday+'&fromdate='+fromdate+'&creationtime='+creationtime+'&resourcename='+resourcename+'&domainname='+domainname+'&organization='+organization+'&expirydate='+expirydate+'&keylength='+keylength+'&keyAlgorithm='+keyAlgorithm+'&signatureAlgorithm='+signatureAlgorithm;//No I18N
                getAjaxApiRequest(ajaxRequestUrl,reqParams,function(jsonData){
                    createSslList(jsonData);
                });
                                
            }
            
        },
        exportPdf:function()
        {
            if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
            var groupId="";
            var groupName="";
            if(window.userRole === "Administrator")
            {
                var select = $('#GROUPS');
                var group = select.attr("name");//NO I18N
                groupId = select.val();
                groupName = $( "#GROUPS option:selected" ).text();
                if(groupId === 'allgroups')
                {
                    groupId="";
                    groupName="";
                }
            }
            var resourcename=document.getElementById("gs_Common Name").value;
            var description = document.getElementById("gs_Description").value;
            var domainname=document.getElementById("gs_DNS Name/FQDN").value;
            var organization=document.getElementById("gs_Organization").value;
            var fromdate=document.getElementById("gs_FromDate").value;
            var expirydate=document.getElementById("gs_ExpiryDate").value;
            var keylength=document.getElementById("gs_KeyStrength").value;
            var keyAlgorithm=document.getElementById("gs_keyAlgorithm").value;
            var signatureAlgorithm=document.getElementById("gs_signatureAlgorithm").value;
            var creationtime = document.getElementById("gs_CreationTime").value;
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate;    
            App.ReportController.scheduleType="SSLVulnerabilitiesReport";//No I18N
            var reqParams='&groupId='+groupId+'&groupName='+groupName+'&description='+description+'&SDAY='+sday+'&EDAY='+eday+'&fromdate='+fromdate+'&creationtime='+creationtime+'&resourcename='+resourcename+'&domainname='+domainname+'&organization='+organization+'&expirydate='+expirydate+'&keylength='+keylength+'&keyAlgorithm='+keyAlgorithm+'&signatureAlgorithm='+signatureAlgorithm;//No I18N
            if(sday!==""&&eday!==""&&!validateCriteria())
            {
                return;
            }
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                      locReplaceURL("/apiclient/ajaxResponse.jsp?RequestType=exportPdf&ReportType=SSLVulnerabilitiesReport"+reqParams);//NO I18N
            }else{
                messageNotification("messageNotifyFailure",I18N.getMsg("js.report.export.noDataAvailableToExport"));//No I18N
            }                      
            
        },
        dataCheck:function()
        {
           var sday=App.ReportController.fromdate;
           var eday=App.ReportController.todate;
            App.ReportController.scheduleType="SSLVulnerabilitiesReport";//No I18N
            var app=this.get('controllers.application');
            if(sday!==""&&eday!==""&&!validateCriteria())
            {
                return;
            }
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                app.send('opendialog','EmailNotify');//NO I18N
            }else{
             messageNotification("messageNotifyFailure",I18N.getMsg("js.report.datacheck.noDataAvailable"));//No I18N
            }            
        }
    }
});

App.ReportMSCARenewalReportController = Ember.ObjectController.extend({
     needs:'application',//NO I18N
    actions : {
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        go: function(){
            if(validateCriteria())
            {
                var groupId="";
                var groupName="";
                if(window.userRole === "Administrator")
                {
                    var select = $('#GROUPS');
                    var group = select.attr("name");//NO I18N
                    groupId = select.val();
                    groupName = $( "#GROUPS option:selected" ).text();
                    if(groupId === 'allgroups')
                    {
                        groupId="";
                        groupName="";
                    }
                }
                var commonName=document.getElementById("gs_COMMON_NAME").value;
                var hostName = document.getElementById("gs_HOSTNAME").value;
                var caName=document.getElementById("gs_CANAME").value;
                var templateName=document.getElementById("gs_TEMPLATENAME").value;
                var sday=App.ReportController.fromdate;
                var eday=App.ReportController.todate;
                App.ReportController.scheduleType="MSCARenewalReport";//No I18N
                var ajaxRequestUrl = '/api/pki/report/mscaRenewalReport'; //No I18N
                var reqParams='&groupId='+groupId+'&groupName='+groupName+'&commonName='+commonName+'&SDAY='+sday+'&EDAY='+eday+'&hostName='+hostName+'&caName='+caName+'&templateName='+templateName;//No I18N
                getAjaxApiRequest(ajaxRequestUrl,reqParams,function(jsonData){
                    mscaRenewalReportList(jsonData);
                });
            }
        },
        exportPdf:function()
        {
            if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
            var groupId="";
            var groupName="";
            if(window.userRole === "Administrator")
            {
                var select = $('#GROUPS');
                var group = select.attr("name");//NO I18N
                groupId = select.val();
                groupName = $( "#GROUPS option:selected" ).text();
                if(groupId === 'allgroups')
                {
                    groupId="";
                    groupName="";
                }
            }
            var commonName=document.getElementById("gs_COMMON_NAME").value;
            var hostName = document.getElementById("gs_HOSTNAME").value;
            var caName=document.getElementById("gs_CANAME").value;
            var templateName=document.getElementById("gs_TEMPLATENAME").value;
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate;    
            App.ReportController.scheduleType="MSCARenewalReport";//No I18N
            var reqParams='&groupId='+groupId+'&groupName='+groupName+'&commonName='+commonName+'&SDAY='+sday+'&EDAY='+eday+'&hostName='+hostName+'&caName='+caName+'&templateName='+templateName;//No I18N
            if(sday!==""&&eday!==""&&!validateCriteria())
            {
                return;
            }
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                      locReplaceURL("/apiclient/ajaxResponse.jsp?RequestType=exportPdf&ReportType=MSCARenewalReport"+reqParams);//NO I18N
            }else{
                messageNotification("messageNotifyFailure",I18N.getMsg("js.report.export.noDataAvailableToExport"));//No I18N
            }                      
            
        },
        exportCsv:function()
        {
            if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
            var groupId="";
            var groupName="";
            if(window.userRole === "Administrator")
            {
                var select = $('#GROUPS');
                var group = select.attr("name");//NO I18N
                groupId = select.val();
                groupName = $( "#GROUPS option:selected" ).text();
                if(groupId === 'allgroups')
                {
                    groupId="";
                    groupName="";
                }
            }
            var commonName=document.getElementById("gs_COMMON_NAME").value;
            var hostName = document.getElementById("gs_HOSTNAME").value;
            var caName=document.getElementById("gs_CANAME").value;
            var templateName=document.getElementById("gs_TEMPLATENAME").value;
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate;
            App.ReportController.scheduleType="MSCARenewalReport";//No I18N
            var reqParams='&groupId='+groupId+'&groupName='+groupName+'&commonName='+commonName+'&SDAY='+sday+'&EDAY='+eday+'&hostName='+hostName+'&caName='+caName+'&templateName='+templateName;//No I18N
            if(sday!==""&&eday!==""&&!validateCriteria())
            {
                return;
            }
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                      locReplaceURL("/apiclient/ajaxResponse.jsp?RequestType=exportCsv&ReportType=MSCARenewalReport"+reqParams);//NO I18N
            }else{
                messageNotification("messageNotifyFailure",I18N.getMsg("js.report.export.noDataAvailableToExport"));//No I18N
            }           
        },
        dataCheck:function()
        {
           var sday=App.ReportController.fromdate;
           var eday=App.ReportController.todate;
            App.ReportController.scheduleType="MSCARenewalReport";//No I18N
            var app=this.get('controllers.application');
            if(sday!==""&&eday!==""&&!validateCriteria())
            {
                return;
            }
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                app.send('opendialog','EmailNotify');//NO I18N
            }else{
             messageNotification("messageNotifyFailure",I18N.getMsg("js.report.datacheck.noDataAvailable"));//No I18N
            }            
        }
    }
});

App.ReportSignReportController = Ember.ObjectController.extend({
     needs:'application',//NO I18N
    actions : {
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        go: function(){
            if(validateCriteria())
            {
                var groupId="";
                var groupName="";
                var sday=App.ReportController.fromdate;
                var eday=App.ReportController.todate;
                App.ReportController.scheduleType="SignReport";//No I18N
                var ajaxRequestUrl = '/api/pki/report/signedReport'; //No I18N
                var reqParams='SDAY='+sday+'&EDAY='+eday;//No I18N
                getAjaxApiRequest(ajaxRequestUrl,reqParams,function(jsonData){
                    signedReportList(jsonData);
                });
            }
        },
        exportPdf:function()
        {
            if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
            var commonName=document.getElementById("gs_COMMON_NAME").value;
            var rootName = document.getElementById("gs_ROOT_NAME").value;
            var signedby=document.getElementById("gs_SIGNED_BY").value;
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate;    
            App.ReportController.scheduleType="SignReport";//No I18N
            var reqParams='&commonName='+commonName+'&SDAY='+sday+'&EDAY='+eday+'&rootName='+rootName;//No I18N
            if(sday!==""&&eday!==""&&!validateCriteria())
            {
                return;
            }
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                      locReplaceURL("/apiclient/ajaxResponse.jsp?RequestType=exportPdf&ReportType=SignReport"+reqParams);//NO I18N
            }else{
                messageNotification("messageNotifyFailure",I18N.getMsg("js.report.export.noDataAvailableToExport"));//No I18N
            }                      
        },
        exportCsv:function()
        {
            if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
            var commonName=document.getElementById("gs_COMMON_NAME").value;
            var rootName = document.getElementById("gs_ROOT_NAME").value;
            var signedby=document.getElementById("gs_SIGNED_BY").value;
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate;    
            App.ReportController.scheduleType="SignReport";//No I18N
            var reqParams='&commonName='+commonName+'&SDAY='+sday+'&EDAY='+eday+'&rootName='+rootName;//No I18N
            if(sday!==""&&eday!==""&&!validateCriteria())
            {
                return;
            }
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                      locReplaceURL("/apiclient/ajaxResponse.jsp?RequestType=exportCsv&ReportType=SignReport"+reqParams);//NO I18N
            }else{
                messageNotification("messageNotifyFailure",I18N.getMsg("js.report.export.noDataAvailableToExport"));//No I18N
            }           
        },
        dataCheck:function()
        {
           var sday=App.ReportController.fromdate;
           var eday=App.ReportController.todate;
            App.ReportController.scheduleType="SignReport";//No I18N
            var app=this.get('controllers.application');
            if(sday!==""&&eday!==""&&!validateCriteria())
            {
                return;
            }
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                app.send('opendialog','EmailNotify');//NO I18N
            }else{
             messageNotification("messageNotifyFailure",I18N.getMsg("js.report.datacheck.noDataAvailable"));//No I18N
            }            
        }
    }
});

App.ReportLetsEncryptCertsReportController = Ember.ObjectController.extend({
     needs:'application',//NO I18N
    actions : {
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        go: function(){
            if(validateCriteria())
            {
                var resourcename=document.getElementById("gs_Common Name").value;
                var description = document.getElementById("gs_Description").value;
                var domainname=document.getElementById("gs_DNS Name/FQDN").value;
                var organization=document.getElementById("gs_Organization").value;
                var fromdate=document.getElementById("gs_FromDate").value;
                var expirydate=document.getElementById("gs_ExpiryDate").value;
                var keylength=document.getElementById("gs_KeyStrength").value;
                var keyAlgorithm=document.getElementById("gs_keyAlgorithm").value;
                var signatureAlgorithm=document.getElementById("gs_signatureAlgorithm").value;
                var creationtime = document.getElementById("gs_CreationTime").value;
                var sday=App.ReportController.fromdate;
                var eday=App.ReportController.todate;        
                App.ReportController.scheduleType="LetsCertificatesReport";//No I18N
                var ajaxRequestUrl = '/api/pki/Inventory/listsslSummary'; //No I18N
                var reqParams='&letsEncrypt=yes'+'&description='+description+'&SDAY='+sday+'&EDAY='+eday+'&fromdate='+fromdate+'&creationtime='+creationtime+'&resourcename='+resourcename+'&domainname='+domainname+'&organization='+organization+'&expirydate='+expirydate+'&keylength='+keylength+'&keyAlgorithm='+keyAlgorithm+'&signatureAlgorithm='+signatureAlgorithm;//No I18N
                getAjaxApiRequest(ajaxRequestUrl,reqParams,function(jsonData){
                    createSslList(jsonData);
                });
                                
            }
            
        },
        exportPdf:function()
        {
            if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
            var resourcename=document.getElementById("gs_Common Name").value;
            var description = document.getElementById("gs_Description").value;
            var domainname=document.getElementById("gs_DNS Name/FQDN").value;
            var organization=document.getElementById("gs_Organization").value;
            var fromdate=document.getElementById("gs_FromDate").value;
            var expirydate=document.getElementById("gs_ExpiryDate").value;
            var keylength=document.getElementById("gs_KeyStrength").value;
            var keyAlgorithm=document.getElementById("gs_keyAlgorithm").value;
            var signatureAlgorithm=document.getElementById("gs_signatureAlgorithm").value;
            var creationtime = document.getElementById("gs_CreationTime").value;
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate;    
            App.ReportController.scheduleType="LetsCertificatesReport";//No I18N
            var reqParams='&letsEncrypt=yes'+'&description='+description+'&SDAY='+sday+'&EDAY='+eday+'&fromdate='+fromdate+'&creationtime='+creationtime+'&resourcename='+resourcename+'&domainname='+domainname+'&organization='+organization+'&expirydate='+expirydate+'&keylength='+keylength+'&keyAlgorithm='+keyAlgorithm+'&signatureAlgorithm='+signatureAlgorithm;//No I18N
            if(sday!==""&&eday!==""&&!validateCriteria())
            {
                return;
            }
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                locReplaceURL("/apiclient/ajaxResponse.jsp?RequestType=exportPdf&ReportType=SSLCertificateReport"+reqParams);//NO I18N
            }else{
                messageNotification("messageNotifyFailure",I18N.getMsg("js.report.export.noDataAvailableToExport"));//No I18N
            }                      
            
        },
        exportCsv:function()
                    {
                        
            if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
            var resourcename=document.getElementById("gs_Common Name").value;
            var description = document.getElementById("gs_Description").value;
            var domainname=document.getElementById("gs_DNS Name/FQDN").value;
            var organization=document.getElementById("gs_Organization").value;
            var fromdate=document.getElementById("gs_FromDate").value;
            var expirydate=document.getElementById("gs_ExpiryDate").value;
            var keylength=document.getElementById("gs_KeyStrength").value;
            var signatureAlgorithm=document.getElementById("gs_signatureAlgorithm").value;
            var keyAlgorithm=document.getElementById("gs_keyAlgorithm").value;
            var creationtime = document.getElementById("gs_CreationTime").value;
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate;
            App.ReportController.scheduleType="LetsCertificatesReport";//No I18N
            var reqParams='&letsEncrypt=yes'+'&description='+description+'&SDAY='+sday+'&EDAY='+eday+'&fromdate='+fromdate+'&creationtime='+creationtime+'&signatureAlgorithm='+signatureAlgorithm+'&resourcename='+resourcename+'&domainname='+domainname+'&organization='+organization+'&expirydate='+expirydate+'&keylength='+keylength+'&keyAlgorithm='+keyAlgorithm;//No I18N
            if(sday!==""&&eday!==""&&!validateCriteria())
                    {
                return;
            }
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                locReplaceURL("/apiclient/ajaxResponse.jsp?RequestType=exportCsv&ReportType=SSLCertificateReport"+reqParams);//NO I18N
            }else{
                messageNotification("messageNotifyFailure",I18N.getMsg("js.report.export.noDataAvailableToExport"));//No I18N
            }           
        },
        dataCheck:function()
        {
           var sday=App.ReportController.fromdate;
           var eday=App.ReportController.todate;
            App.ReportController.scheduleType="LetsCertificatesReport";//No I18N
            var app=this.get('controllers.application');
            if(sday!==""&&eday!==""&&!validateCriteria())
            {
                return;
            }
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                app.send('opendialog','EmailNotify');//NO I18N
            }else{
             messageNotification("messageNotifyFailure",I18N.getMsg("js.report.datacheck.noDataAvailable"));//No I18N
            }            
        }
    }
});

App.ReportDeploymentReportController = Ember.ObjectController.extend({
     needs:'application',//NO I18N
    actions : {
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        go: function(){
            if(validateCriteria())
            {
                var commonName=document.getElementById("gs_CommonName").value;
                var hostName=document.getElementById("gs_HostName").value;
                var description = document.getElementById("gs_Description").value;
                var deptime = document.getElementById("gs_DeployedDate").value;
                var depBy=document.getElementById("gs_DeployedBy").value;
                var depType=document.getElementById("gs_DeploymentType").value;
                var sday=App.ReportController.fromdate;
                var eday=App.ReportController.todate;    
                App.ReportController.scheduleType="DeploymentReport";//No I18N
                var reqParams='&description='+description+'&deptime='+deptime+'&commonName='+commonName+'&hostName='+hostName+'&depBy='+depBy+'&depType='+depType+'&SDAY='+sday+'&EDAY='+eday;//No I18N
                var ajaxRequestUrl = '/api/pki/report/getDeploymentReportView'; //No I18N
                getAjaxApiRequest(ajaxRequestUrl,reqParams,function(jsonData){
                    createDeploymentReportList(jsonData);
                });  
            }
        },
        exportPdf:function()
        {
            if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
            var commonName=document.getElementById("gs_CommonName").value;
            var hostName=document.getElementById("gs_HostName").value;
            var description = document.getElementById("gs_Description").value;
            var deptime = document.getElementById("gs_DeployedDate").value;
            var depBy=document.getElementById("gs_DeployedBy").value;
            var depType=document.getElementById("gs_DeploymentType").value;
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate;    
            App.ReportController.scheduleType="DeploymentReport";//No I18N
            var reqParams='&description='+description+'&deptime='+deptime+'&commonName='+commonName+'&hostName='+hostName+'&depBy='+depBy+'&depType='+depType+'&SDAY='+sday+'&EDAY='+eday;//No I18N
            if(sday!==""&&eday!==""&&!validateCriteria())
            {
                return;
            }
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                locReplaceURL("/apiclient/ajaxResponse.jsp?RequestType=exportPdf&ReportType=DeploymentReport"+reqParams);//NO I18N
            }else{
                messageNotification("messageNotifyFailure",I18N.getMsg("js.report.export.noDataAvailableToExport"));//No I18N
            }                      
            
        },
        exportCsv:function()
        {
            if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
            var commonName=document.getElementById("gs_CommonName").value;
            var hostName=document.getElementById("gs_HostName").value;
            var description = document.getElementById("gs_Description").value;
            var deptime = document.getElementById("gs_DeployedDate").value;
            var depBy=document.getElementById("gs_DeployedBy").value;
            var depType=document.getElementById("gs_DeploymentType").value;
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate;    
            App.ReportController.scheduleType="DeploymentReport";//No I18N
            var reqParams='&description='+description+'&deptime='+deptime+'&commonName='+commonName+'&hostName='+hostName+'&depBy='+depBy+'&depType='+depType+'&SDAY='+sday+'&EDAY='+eday;//No I18N
            if(sday!==""&&eday!==""&&!validateCriteria())
                    {
                return;
            }
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                locReplaceURL("/apiclient/ajaxResponse.jsp?RequestType=exportCsv&ReportType=DeploymentReport"+reqParams);//NO I18N
            }else{
                messageNotification("messageNotifyFailure",I18N.getMsg("js.report.export.noDataAvailableToExport"));//No I18N
            }           
        },
        dataCheck:function()
        {
           var sday=App.ReportController.fromdate;
           var eday=App.ReportController.todate;
            App.ReportController.scheduleType="DeploymentReport";//No I18N
            var app=this.get('controllers.application');
            if(sday!==""&&eday!==""&&!validateCriteria())
            {
                return;
            }
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                app.send('opendialog','EmailNotify');//NO I18N
            }else{
                messageNotification("messageNotifyFailure",I18N.getMsg("js.report.datacheck.noDataAvailable"));//No I18N
            }            
        }
    }
});

App.ReportAdUserCertificatesController = Ember.ObjectController.extend({
     needs:'application',//NO I18N
    actions : {
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        go: function(){
            if(validateCriteria())
            {
                var common_name=document.getElementById("gs_Common_Name").value;
                var domain_name = document.getElementById("gs_Domain_Name").value;
                var domain_controller = document.getElementById("gs_Domain_Controller").value;
                var user_name = document.getElementById("gs_User_Name").value;
                var from_date = document.getElementById("gs_From_Date").value;
                var to_date = document.getElementById("gs_To_Date").value;
                var day_expiry = document.getElementById("gs_Days_Expiry").value;
                var created_time = document.getElementById("gs_Created_Time").value;
                var sday=App.ReportController.fromdate;
                var eday=App.ReportController.todate;        
                App.ReportController.scheduleType="ADSslCertificateReport";//No I18N
                var ajaxRequestUrl = '/api/pki/Inventory/listadsslSummary'; //No I18N
                var reqParams='username='+user_name+'&SDAY='+sday+'&EDAY='+eday+'&fromdate='+from_date+'&creationtime='+created_time+'&commonname='+common_name+'&domainname='+domain_name+'&domaincontroller='+domain_controller+'&todate='+to_date+'&expirydays='+day_expiry;//No I18N
                getAjaxApiRequest(ajaxRequestUrl,reqParams,function(jsonData){
                    createADSSLlist(jsonData);
                });                                
            }            
        },
        exportPdf:function()
        {
            if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
            var common_name=document.getElementById("gs_Common_Name").value;
            var domain_name = document.getElementById("gs_Domain_Name").value;
            var domain_controller = document.getElementById("gs_Domain_Controller").value;
            var user_name = document.getElementById("gs_User_Name").value;
            var from_date = document.getElementById("gs_From_Date").value;
            var to_date = document.getElementById("gs_To_Date").value;
            var day_expiry = document.getElementById("gs_Days_Expiry").value;
            var created_time = document.getElementById("gs_Created_Time").value;
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate;        
            App.ReportController.scheduleType="ADSslCertificateReport";//No I18N
            var reqParams='&username='+user_name+'&SDAY='+sday+'&EDAY='+eday+'&fromdate='+from_date+'&creationtime='+created_time+'&commonname='+common_name+'&domainname='+domain_name+'&domaincontroller='+domain_controller+'&todate='+to_date+'&expirydays='+day_expiry;//No I18N
            if(sday!==""&&eday!==""&&!validateCriteria())
            {
                return;
            }
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                locReplaceURL("/apiclient/ajaxResponse.jsp?RequestType=exportPdf&ReportType=ADSSLCertificateReport"+reqParams);//NO I18N
            }else{
                messageNotification("messageNotifyFailure",I18N.getMsg("js.report.export.noDataAvailableToExport"));//No I18N
            }                      
            
        },
        exportCsv:function()
                    {
            if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
            var common_name=document.getElementById("gs_Common_Name").value;
            var domain_name = document.getElementById("gs_Domain_Name").value;
            var domain_controller = document.getElementById("gs_Domain_Controller").value;
            var user_name = document.getElementById("gs_User_Name").value;
            var from_date = document.getElementById("gs_From_Date").value;
            var to_date = document.getElementById("gs_To_Date").value;
            var day_expiry = document.getElementById("gs_Days_Expiry").value;
            var created_time = document.getElementById("gs_Created_Time").value;
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate;        
            App.ReportController.scheduleType="ADSslCertificateReport";//No I18N
            var reqParams='&username='+user_name+'&SDAY='+sday+'&EDAY='+eday+'&fromdate='+from_date+'&creationtime='+created_time+'&commonname='+common_name+'&domainname='+domain_name+'&domaincontroller='+domain_controller+'&todate='+to_date+'&expirydays='+day_expiry;//No I18N
            if(sday!==""&&eday!==""&&!validateCriteria())
            {
                return;
            }
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                locReplaceURL("/apiclient/ajaxResponse.jsp?RequestType=exportCsv&ReportType=ADSSLCertificateReport"+reqParams);//NO I18N
            }else{
                messageNotification("messageNotifyFailure",I18N.getMsg("js.report.export.noDataAvailableToExport"));//No I18N
            }           
        },
        dataCheck:function()
        {
           var sday=App.ReportController.fromdate;
           var eday=App.ReportController.todate;
            App.ReportController.scheduleType="ADSslCertificateReport";//No I18N
            var app=this.get('controllers.application');
            if(sday!==""&&eday!==""&&!validateCriteria())
            {
                return;
            }
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                app.send('opendialog','EmailNotify');//NO I18N
            }else{
             messageNotification("messageNotifyFailure",I18N.getMsg("js.report.datacheck.noDataAvailable"));//No I18N
            }            
        }
    }
});


App.ReportWildcardCertificateController = Ember.ObjectController.extend({
     needs:'application',//NO I18N
    actions : {
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        go: function(wild){
            if(validateCriteria())
            {
                var commonname=document.getElementById("gs_Common Name").value;
                var description = document.getElementById("gs_Description").value;
                var issuername=document.getElementById("gs_Organization").value;
                var validfrom=document.getElementById("gs_FromDate").value;
                var validto=document.getElementById("gs_ExpiryDate").value;
                var keylength=document.getElementById("gs_KeyStrength").value;
                var keyAlgorithm=document.getElementById("gs_keyAlgorithm").value;
                var creationtime = document.getElementById("gs_CreationTime").value;
                var sday=App.ReportController.fromdate;
                var eday=App.ReportController.todate;        
                App.ReportController.scheduleType="WildcardCertificateReport";//No I18N
                var ajaxRequestUrl = '/api/pki/report/getWildcardCertificateView'; //No I18N
                var reqParams='&description='+description+'&SDAY='+sday+'&EDAY='+eday+'&validfrom='+validfrom+'&creationtime='+creationtime+'&commonname='+commonname+'&issuername='+issuername+'&validto='+validto+'&keylength='+keylength+'&keyAlgorithm='+keyAlgorithm;//No I18N
                if(wild !="deploy")
                {
                    reqParams+='&wildcard=wildcard';//NO I18N
                }
                getAjaxApiRequest(ajaxRequestUrl,reqParams,function(jsonData){
                    createSSLWildcardCertList(jsonData);
                });
            }
        },
        exportPdf:function(wild)
        {
            if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
            var commonname=document.getElementById("gs_Common Name").value;
            var description = document.getElementById("gs_Description").value;
            var issuername=document.getElementById("gs_Organization").value;
            var validfrom=document.getElementById("gs_FromDate").value;
            var validto=document.getElementById("gs_ExpiryDate").value;
            var keylength=document.getElementById("gs_KeyStrength").value;
            var creationtime = document.getElementById("gs_CreationTime").value;
            var keyAlgorithm=document.getElementById("gs_keyAlgorithm").value;
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate;    
            App.ReportController.scheduleType="WildcardCertificateReport";//No I18N
            var reqParams='&description='+description+'&SDAY='+sday+'&EDAY='+eday+'&validfrom='+validfrom+'&creationtime='+creationtime+'&commonname='+commonname+'&issuername='+issuername+'&validto='+validto+'&keylength='+keylength+'&keyAlgorithm='+keyAlgorithm;//No I18N
            if(wild !="deploy")
            {
                reqParams+='&wildcard=wildcard';//NO I18N
            }
            if(sday!==""&&eday!==""&&!validateCriteria())
            {
                return;
            }
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                locReplaceURL("/apiclient/ajaxResponse.jsp?RequestType=exportPdf&ReportType=WildcardCertificateReport"+reqParams);//NO I18N
            }else{
                messageNotification("messageNotifyFailure",I18N.getMsg("js.report.export.noDataAvailableToExport"));//No I18N
            }                      
            
        },
        exportCsv:function(wild)
                    {
            if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
            var commonname=document.getElementById("gs_Common Name").value;
            var description = document.getElementById("gs_Description").value;
            var issuername=document.getElementById("gs_Organization").value;
            var validfrom=document.getElementById("gs_FromDate").value;
            var validto=document.getElementById("gs_ExpiryDate").value;
            var keylength=document.getElementById("gs_KeyStrength").value;
            var creationtime = document.getElementById("gs_CreationTime").value;
            var keyAlgorithm=document.getElementById("gs_keyAlgorithm").value;
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate;    
            App.ReportController.scheduleType="WildcardCertificateReport";//No I18N
            var reqParams='&description='+description+'&SDAY='+sday+'&EDAY='+eday+'&validfrom='+validfrom+'&creationtime='+creationtime+'&commonname='+commonname+'&issuername='+issuername+'&validto='+validto+'&keylength='+keylength+'&keyAlgorithm='+keyAlgorithm;//No I18N
            if(wild !="deploy")
            {
                reqParams+='&wildcard=wildcard';//NO I18N
            }
            if(sday!==""&&eday!==""&&!validateCriteria())
                    {
                return;
            }
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                locReplaceURL("/apiclient/ajaxResponse.jsp?RequestType=exportCsv&ReportType=WildcardCertificateReport"+reqParams);//NO I18N
            }else{
                messageNotification("messageNotifyFailure",I18N.getMsg("js.report.export.noDataAvailableToExport"));//No I18N
            }           
        },
        dataCheck:function()
        {
           var sday=App.ReportController.fromdate;
           var eday=App.ReportController.todate;
            App.ReportController.scheduleType="WildcardCertificateReport";//No I18N
            var app=this.get('controllers.application');
            if(sday!==""&&eday!==""&&!validateCriteria())
            {
                return;
            }
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                app.send('opendialog','EmailNotify');//NO I18N
            }else{
             messageNotification("messageNotifyFailure",I18N.getMsg("js.report.datacheck.noDataAvailable"));//No I18N
            }            
        }
    }
});

App.ReportDeployedServersController = Ember.ObjectController.extend({
     needs:['application','ReportWildcardCertificate'],//NO I18N
    actions : {
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        go: function(){
            var app=this.get('controllers.ReportWildcardCertificate');
            app.send('go','deploy');//NO I18N
            App.ReportController.scheduleType="DeployedServersReport";//No I18N
        },
        exportPdf:function()
        {
            if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
            var app=this.get('controllers.ReportWildcardCertificate');
            app.send('exportPdf','deploy');//NO I18N
            App.ReportController.scheduleType="DeployedServersReport";//No I18N
        },
        exportCsv:function()
        {
            if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
            var app=this.get('controllers.ReportWildcardCertificate');
            app.send('exportCsv','deploy');//NO I18N
            App.ReportController.scheduleType="DeployedServersReport";//No I18N
        },
        dataCheck:function()
        {
            var app=this.get('controllers.ReportWildcardCertificate');
            app.send('dataCheck');//NO I18N
            App.ReportController.scheduleType="DeployedServersReport";//No I18N
        }
    }
});

App.ReportSHA1CertificateController = Ember.ObjectController.extend({
     needs:['application','DashboardGraph'],//NO I18N
    actions : {
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        go: function(){
            if(validateCriteria())
            {
                var commonName=document.getElementById("gs_Common Name").value;
                var dnsName=document.getElementById("gs_DNS Name/FQDN").value;
                var org=document.getElementById("gs_Organization").value;
                var fromDate=document.getElementById("gs_FromDate").value;
                var expDate=document.getElementById("gs_ExpiryDate").value;
                var keyStrength=document.getElementById("gs_KeyStrength").value;
                var days=document.getElementById("gs_DaysToExpiry").value;
                var keyAlgorithm=document.getElementById("gs_keyAlgorithm").value;
                var signatureAlgorithm=document.getElementById("gs_signatureAlgorithm").value;
                var sday=App.ReportController.fromdate;
                var eday=App.ReportController.todate;   
                var reqParams='&resourcename='+commonName+'&SDAY='+sday+'&EDAY='+eday+'&domainname='+dnsName+'&organization='+org+'&expirydate='+expDate+'&keylength='+keyStrength+'&days='+days+'&keyAlgorithm='+keyAlgorithm+'&fromdate='+fromDate+'&signatureAlgorithm='+signatureAlgorithm;//No I18N
                App.ReportController.scheduleType="SHA1CertificateReport";//No I18N
                var ajaxRequestUrl = '/api/pki/Dashboard/Graph?type=certlist&data=sha1'; //No I18N
                getAjaxApiRequest(ajaxRequestUrl,reqParams,function(jsonData){
                    createSHA1dCertList(jsonData);
                });
            }
        },
        exportPdf:function()
        {
            if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            var app=this.get('controllers.DashboardGraph');
            app.send('exportSHA1Pdf',ids);//NO I18N
        },
        exportCsv:function()
        {
            if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            var app=this.get('controllers.DashboardGraph');
            app.send('exportCsv',ids);//NO I18N
        },
        dataCheck:function()
        {
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            var app=this.get('controllers.DashboardGraph');
            app.send('dataCheck',ids);//NO I18N
        }
    }
});

App.Report1024CertificateController = Ember.ObjectController.extend({
     needs:'application',//NO I18N
    actions : {
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        go: function(){
            if(validateCriteria())
            {
                var commonName=document.getElementById("gs_Common Name").value;
                var dnsName=document.getElementById("gs_DNS Name/FQDN").value;
                var org=document.getElementById("gs_Organization").value;
                var fromDate=document.getElementById("gs_FromDate").value;
                var expDate=document.getElementById("gs_ExpiryDate").value;
                var keyStrength=document.getElementById("gs_KeyStrength").value;
                var days=document.getElementById("gs_DaysToExpiry").value;
                var signatureAlgorithm=document.getElementById("gs_signatureAlgorithm").value;
                var keyAlgorithm=document.getElementById("gs_keyAlgorithm").value;
                var sday=App.ReportController.fromdate;
                var eday=App.ReportController.todate;   
                var reqParams='&commonName='+commonName+'&SDAY='+sday+'&EDAY='+eday+'&dnsName='+dnsName+'&org='+org+'&expDate='+expDate+'&keyStrength='+keyStrength+'&days='+days+'&keyAlgorithm='+keyAlgorithm+'&fromDate='+fromDate+'&signatureAlgorithm='+signatureAlgorithm;//No I18N
                App.ReportController.scheduleType="1024CertificateReport";//No I18N
                var ajaxRequestUrl = '/api/pki/Dashboard/Graph?type=certlist&data=1024'; //No I18N
                getAjaxApiRequest(ajaxRequestUrl,reqParams,function(jsonData){
                    createSHA1dCertList(jsonData);
                });
            }
        },
        exportPdf:function()
        {
            if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            var commonName=document.getElementById("gs_Common Name").value;
            var dnsName=document.getElementById("gs_DNS Name/FQDN").value;
            var org=document.getElementById("gs_Organization").value;
            var fromDate=document.getElementById("gs_FromDate").value;
            var expDate=document.getElementById("gs_ExpiryDate").value;
            var keyStrength=document.getElementById("gs_KeyStrength").value;
            var keyAlgorithm=document.getElementById("gs_keyAlgorithm").value;
            var signatureAlgorithm=document.getElementById("gs_signatureAlgorithm").value;
            var days=document.getElementById("gs_DaysToExpiry").value;
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate;   
            App.ReportController.scheduleType="1024CertificateReport";//No I18N
            if(sday!==""&&eday!==""&&!validateCriteria())
                        {
                    return;
                }
            var reqParams='&commonName='+commonName+'&SDAY='+sday+'&EDAY='+eday+'&dnsName='+dnsName+'&org='+org+'&expDate='+expDate+'&keyStrength='+keyStrength+'&days='+days+'&keyAlgorithm='+keyAlgorithm+'&fromDate='+fromDate+'&signatureAlgorithm='+signatureAlgorithm;//No I18N
            if(ids.length>0)
            {
                locReplaceURL("/apiclient/ajaxResponse.jsp?RequestType=exportPdf&ReportType=1024CertReport"+reqParams);//NO I18N
            }
            else{
                messageNotification("messageNotifyFailure",I18N.getMsg("js.report.export.noDataAvailableToExport"));//No I18N
            }
        },
        exportCsv:function()
        {
            if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            var commonName=document.getElementById("gs_Common Name").value;
            var dnsName=document.getElementById("gs_DNS Name/FQDN").value;
            var org=document.getElementById("gs_Organization").value;
            var fromDate=document.getElementById("gs_FromDate").value;
            var expDate=document.getElementById("gs_ExpiryDate").value;
            var keyStrength=document.getElementById("gs_KeyStrength").value;
            var days=document.getElementById("gs_DaysToExpiry").value;
            var signatureAlgorithm=document.getElementById("gs_signatureAlgorithm").value;
            var keyAlgorithm=document.getElementById("gs_keyAlgorithm").value;
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate;   
            App.ReportController.scheduleType="1024CertificateReport";//No I18N
            if(sday!==""&&eday!==""&&!validateCriteria())
                        {
                    return;
                }
            var reqParams='&commonName='+commonName+'&SDAY='+sday+'&EDAY='+eday+'&dnsName='+dnsName+'&org='+org+'&expDate='+expDate+'&keyStrength='+keyStrength+'&days='+days+'&keyAlgorithm='+keyAlgorithm+'&fromDate='+fromDate+'&signatureAlgorithm='+signatureAlgorithm;//No I18N
            if(ids.length>0)
            {
                locReplaceURL("/apiclient/ajaxResponse.jsp?RequestType=exportCsv&ReportType=1024CertReport"+reqParams);//NO I18N
            }
            else{
                messageNotification("messageNotifyFailure",I18N.getMsg("js.report.export.noDataAvailableToExport"));//No I18N
            }
        },
        dataCheck:function()
        {
            App.ReportController.scheduleType="1024CertificateReport";//No I18N
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate;    
            var app=this.get('controllers.application');
            if(sday!==""&&eday!==""&&!validateCriteria())
                        {
                    return;
                }
            if(ids.length>0)
            {
                app.send('opendialog','EmailNotify');//NO I18N
            }else{
             messageNotification("messageNotifyFailure",I18N.getMsg("js.report.datacheck.noDataAvailable"));//No I18N
            }
        }
    }
});

App.ReportSSLExpiryController = Ember.ObjectController.extend({
     needs:'application',//NO I18N
    actions : {
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        go: function(){
            if(validateCriteria())
            {
                var groupId="";
                var groupName="";
                if(window.userRole === "Administrator")
                {
                    var select = $('#GROUPS');
                    var group = select.attr("name");//NO I18N
                    groupId = select.val();
                    groupName = $( "#GROUPS option:selected" ).text();
                    if(groupId === 'allgroups')
                    {
                        groupId="";
                        groupName="";
                    }
                }
                var resourcename=document.getElementById("gs_Common Name").value;
                var description = document.getElementById("gs_Description").value;
                var domainname=document.getElementById("gs_DNS Name/FQDN").value;
                var organization=document.getElementById("gs_Organization").value;
                var fromdate=document.getElementById("gs_FromDate").value;
                var expirydate=document.getElementById("gs_ExpiryDate").value;
                var keylength=document.getElementById("gs_KeyStrength").value;
                var days=document.getElementById("gs_DaysToExpiry").value;
                var esday=App.ReportController.fromdate;
                var eeday=App.ReportController.todate;    
                var daysfilter=App.ReportController.days="";
                App.ReportController.scheduleType="SSLExpiryReport";//No I18N
                var ajaxRequestUrl = '/api/pki/Inventory/listsslSummary'; //No I18N
                var reqParams='&groupId='+groupId+'&groupName='+groupName+'&description='+description+'&ESDAY='+esday+'&EEDAY='+eeday+'&days='+days+'&daysfilter='+daysfilter+'&fromdate='+fromdate+'&resourcename='+resourcename+'&domainname='+domainname+'&organization='+organization+'&expirydate='+expirydate+'&keylength='+keylength;//No I18N
                getAjaxApiRequest(ajaxRequestUrl,reqParams,function(jsonData){
                    createSslExpiryList(jsonData);
                });
                                
            }
            
        },
        exportPdf:function()
            {
            if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
            var groupId="";
                var groupName="";
                if(window.userRole === "Administrator")
                {
                    var select = $('#GROUPS');
                    var group = select.attr("name");//NO I18N
                    groupId = select.val();
                    groupName = $( "#GROUPS option:selected" ).text();
                    if(groupId === 'allgroups')
                    {
                        groupId="";
                        groupName="";
                    }
                }
            var resourcename=document.getElementById("gs_Common Name").value;
            var description = document.getElementById("gs_Description").value;
            var domainname=document.getElementById("gs_DNS Name/FQDN").value;
            var organization=document.getElementById("gs_Organization").value;
            var fromdate=document.getElementById("gs_FromDate").value;
            var expirydate=document.getElementById("gs_ExpiryDate").value;
            var keylength=document.getElementById("gs_KeyStrength").value;
            var days=document.getElementById("gs_DaysToExpiry").value;
            var esday=App.ReportController.fromdate;
            var eeday=App.ReportController.todate;    
            var daysfilter=App.ReportController.days;
            App.ReportController.scheduleType="SSLExpiryReport";//No I18N
            var reqParams='&groupId='+groupId+'&groupName='+groupName+'&description='+description+'&ESDAY='+esday+'&EEDAY='+eeday+'&daysfilter='+daysfilter+'&days='+days+'&fromdate='+fromdate+'&resourcename='+resourcename+'&domainname='+domainname+'&organization='+organization+'&expirydate='+expirydate+'&keylength='+keylength;//No I18N
            if(esday!==""&&eeday!==""&&!validateCriteria())
            {
                return;
            }
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                locReplaceURL("/apiclient/ajaxResponse.jsp?RequestType=exportPdf&ReportType=SSLExpiryReport"+reqParams);//NO I18N
            }else{
                messageNotification("messageNotifyFailure",I18N.getMsg("js.report.export.noDataAvailableToExport"));//No I18N
            }                      
                       
        },
        exportCsv:function()
        {
            if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
            var groupId="";
                var groupName="";
                if(window.userRole === "Administrator")
                {
                    var select = $('#GROUPS');
                    var group = select.attr("name");//NO I18N
                    groupId = select.val();
                    groupName = $( "#GROUPS option:selected" ).text();
                    if(groupId === 'allgroups')
                    {
                        groupId="";
                        groupName="";
                    }
                }
            var resourcename=document.getElementById("gs_Common Name").value;
            var description = document.getElementById("gs_Description").value;
            var domainname=document.getElementById("gs_DNS Name/FQDN").value;
            var organization=document.getElementById("gs_Organization").value;
            var fromdate=document.getElementById("gs_FromDate").value;
            var expirydate=document.getElementById("gs_ExpiryDate").value;
            var keylength=document.getElementById("gs_KeyStrength").value;
            var days=document.getElementById("gs_DaysToExpiry").value;
            var esday=App.ReportController.fromdate;
            var eeday=App.ReportController.todate;
            var daysfilter=App.ReportController.days;
            App.ReportController.scheduleType="SSLExpiryReport";//No I18N
            var reqParams='&groupId='+groupId+'&groupName='+groupName+'&description='+description+'&ESDAY='+esday+'&EEDAY='+eeday+'&daysfilter='+daysfilter+'&days='+days+'&fromdate='+fromdate+'&resourcename='+resourcename+'&domainname='+domainname+'&organization='+organization+'&expirydate='+expirydate+'&keylength='+keylength;//No I18N
            if(esday!==""&&eeday!==""&&!validateCriteria())
            {
                return;
            }
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                locReplaceURL("/apiclient/ajaxResponse.jsp?RequestType=exportCsv&ReportType=SSLExpiryReport"+reqParams);//NO I18N
            }else{
                messageNotification("messageNotifyFailure",I18N.getMsg("js.report.export.noDataAvailableToExport"));//No I18N
            }           
        },
        dataCheck:function()
        {            
            var esday=App.ReportController.fromdate;
            var eeday=App.ReportController.todate;
            App.ReportController.scheduleType="SSLExpiryReport";//No I18N
            var app=this.get('controllers.application');
            if(esday!==""&&eeday!==""&&!validateCriteria())
            {
                return;
            }            
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                app.send('opendialog','EmailNotify');//NO I18N
            }else{
             messageNotification("messageNotifyFailure",I18N.getMsg("js.report.datacheck.noDataAvailable"));//No I18N
    }
        }
    }
});


App.ReportInventoryReportController = Ember.ObjectController.extend({
     needs:'application',//NO I18N
    actions : {
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        go: function() {
           if(validateCriteria())
            {
                var groupId="";
                var groupName="";
                if(window.userRole === "Administrator")
                {
                    var select = $('#GROUPS');
                    var group = select.attr("name");//NO I18N
                    groupId = select.val();
                    groupName = $( "#GROUPS option:selected" ).text();
                    if(groupId === 'allgroups')
                    {
                        groupId="";
                        groupName="";
                    }
                }
                var resourcename=document.getElementById("gs_ResourceName").value;
                var description = document.getElementById("gs_Description").value;
                var ipaddress=document.getElementById("gs_IPAddress").value;
                var resourcetype=document.getElementById("gs_ResourceType").value;
                var creationtime=document.getElementById("gs_CreationTime").value;
                var sday=App.ReportController.fromdate;
                var eday=App.ReportController.todate;
                App.ReportController.scheduleType="ResourceReport";//No I18N
                var ajaxRequestUrl = '/api/pki/Inventory/listSummary'; //No I18N
                var reqParams='&description='+description+'&groupId='+groupId+'&groupName='+groupName+'&resourcename='+resourcename+'&ipaddress='+ipaddress+'&resourcetype='+resourcetype+'&creationtime='+creationtime+'&scheduleType='+"ResourceReport"+'&SDAY='+sday+'&EDAY='+eday;//No I18N
                getAjaxApiRequest(ajaxRequestUrl,reqParams,function(jsonData){
                createInventoryList(jsonData);
                });
            }  
        },
        exportPdf:function()
        {
            if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
            var groupId="";
            var groupName="";
            if(window.userRole === "Administrator")
            {
                var select = $('#GROUPS');
                var group = select.attr("name");//NO I18N
                groupId = select.val();
                groupName = $( "#GROUPS option:selected" ).text();
                if(groupId === 'allgroups')
                {
                    groupId="";
                    groupName="";
                }
            }
            var resourcename=document.getElementById("gs_ResourceName").value;
            var description = document.getElementById("gs_Description").value;
            var ipaddress=document.getElementById("gs_IPAddress").value;
            var resourcetype=document.getElementById("gs_ResourceType").value;
            var creationtime=document.getElementById("gs_CreationTime").value;
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate;    
            App.ReportController.scheduleType="ResourceReport";//No I18N
            var ajaxRequestUrl = '/api/pki/Inventory/listSummary'; //No I18N
            var reqParams='&description='+description+'&groupId='+groupId+'&groupName='+groupName+'&resourcename='+resourcename+'&ipaddress='+ipaddress+'&resourcetype='+resourcetype+'&creationtime='+creationtime+'&scheduleType='+"ResourceReport"+'&SDAY='+sday+'&EDAY='+eday;//No I18N
            if(sday!==""&&eday!==""&&!validateCriteria())
            {
                return;
            }
           var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                locReplaceURL("/apiclient/ajaxResponse.jsp?RequestType=exportPdf&ReportType=InventoryReport"+reqParams);//NO I18N
            }else{
                messageNotification("messageNotifyFailure",I18N.getMsg("js.report.export.noDataAvailableToExport"));//No I18N
            }
            
        },
        exportCsv:function()
        {
            if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
            var groupId="";
            var groupName="";
            if(window.userRole === "Administrator")
            {
                var select = $('#GROUPS');
                var group = select.attr("name");//NO I18N
                groupId = select.val();
                groupName = $( "#GROUPS option:selected" ).text();
                if(groupId === 'allgroups')
                {
                    groupId="";
                    groupName="";
                }
            }
            var resourcename=document.getElementById("gs_ResourceName").value;
            var description = document.getElementById("gs_Description").value;
            var ipaddress=document.getElementById("gs_IPAddress").value;
            var resourcetype=document.getElementById("gs_ResourceType").value;
            var creationtime=document.getElementById("gs_CreationTime").value;
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate;
            App.ReportController.scheduleType="ResourceReport";//No I18N
            var ajaxRequestUrl = '/api/pki/Inventory/listSummary'; //No I18N
            var reqParams='&description='+description+'&groupId='+groupId+'&groupName='+groupName+'&resourcename='+resourcename+'&ipaddress='+ipaddress+'&resourcetype='+resourcetype+'&creationtime='+creationtime+'&scheduleType='+"ResourceReport"+'&SDAY='+sday+'&EDAY='+eday;//No I18N
            if(sday!==""&&eday!==""&&!validateCriteria())
            {
                return;
            }
           var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                      locReplaceURL("/apiclient/ajaxResponse.jsp?RequestType=exportCsv&ReportType=InventoryReport"+reqParams);//NO I18N
            }else{
                messageNotification("messageNotifyFailure",I18N.getMsg("js.report.export.noDataAvailableToExport"));//No I18N
            }
              
        },
        dataCheck:function()
        {
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate;
            var app=this.get('controllers.application');
            if(sday!==""&&eday!==""&&!validateCriteria())
            {
                return;
            }            
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                app.send('opendialog','EmailNotify');//NO I18N
            }else{
             messageNotification("messageNotifyFailure",I18N.getMsg("js.report.datacheck.noDataAvailable"));//No I18N
            }
        }
    }
});

App.ReportLandingServersReportController = Ember.ObjectController.extend({
    needs:'application',//NO I18N
   actions :{
       close: function() {
           return this.send('closeModal');//NO I18N
       },
       go: function() {
           if(validateCriteria())
           {
               var ServerName = document.getElementById("gs_ServerName").value;
               var PrimaryServer = document.getElementById("gs_PrimaryServer").value;
               var PrimaryUser = document.getElementById("gs_PrimaryUser").value;
               var SecondaryServer = document.getElementById("gs_SecondaryServer").value;
               var SecondaryUser = document.getElementById("gs_SecondaryUser").value;
               var CreatedBy = document.getElementById("gs_CreatedBy").value;
               var CreatedTime = document.getElementById("gs_CreatedTime").value;
               var Description = document.getElementById("gs_Description").value;
               var sday=App.ReportController.fromdate;
               var eday=App.ReportController.todate;
               var ajaxRequestUrl = '/api/pki/report/LandingServersReportView'; //No I18N
               var params = '&SDAY='+sday+'&EDAY='+eday+'&ServerName='+ServerName+'&PrimaryServer='+PrimaryServer+'&PrimaryUser='+PrimaryUser+'&SecondaryServer='+SecondaryServer+'&SecondaryUser='+SecondaryUser+'&CreatedBy='+CreatedBy+//NO I18N
                            '&CreatedTime='+CreatedTime+'&Description='+Description;//NO I18N
               getAjaxApiRequest(ajaxRequestUrl,params,function(jsonData){
                  createLandingServersReport(jsonData); 
               });
           }
       },
       exportPdf: function() {
           if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
            var ServerName = document.getElementById("gs_ServerName").value;
            var PrimaryServer = document.getElementById("gs_PrimaryServer").value;
            var PrimaryUser = document.getElementById("gs_PrimaryUser").value;
            var SecondaryServer = document.getElementById("gs_SecondaryServer").value;
            var SecondaryUser = document.getElementById("gs_SecondaryUser").value;
            var CreatedBy = document.getElementById("gs_CreatedBy").value;
            var CreatedTime = document.getElementById("gs_CreatedTime").value;
            var Description = document.getElementById("gs_Description").value;
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate;
            var params = '&SDAY='+sday+'&EDAY='+eday+'&ServerName='+ServerName+'&PrimaryServer='+PrimaryServer+'&PrimaryUser='+PrimaryUser+'&SecondaryServer='+SecondaryServer+'&SecondaryUser='+SecondaryUser+'&CreatedBy='+CreatedBy+//NO I18N
                            '&CreatedTime='+CreatedTime+'&Description='+Description;//NO I18N
            if(sday!==""&&eday!==""&&!validateCriteria())
            {
                return;
            }
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                locReplaceURL("/apiclient/ajaxResponse.jsp?RequestType=exportPdf&ReportType=LandingServersReport"+params);//NO I18N
            }
            else{
                messageNotification("messageNotifyFailure",I18N.getMsg("js.report.export.noDataAvailableToExport"));//No I18N
            }
       },
       exportCsv:function() {
           if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
            var ServerName = document.getElementById("gs_ServerName").value;
            var PrimaryServer = document.getElementById("gs_PrimaryServer").value;
            var PrimaryUser = document.getElementById("gs_PrimaryUser").value;
            var SecondaryServer = document.getElementById("gs_SecondaryServer").value;
            var SecondaryUser = document.getElementById("gs_SecondaryUser").value;
            var CreatedBy = document.getElementById("gs_CreatedBy").value;
            var CreatedTime = document.getElementById("gs_CreatedTime").value;
            var Description = document.getElementById("gs_Description").value;
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate;
            var params = '&SDAY='+sday+'&EDAY='+eday+'&ServerName='+ServerName+'&PrimaryServer='+PrimaryServer+'&PrimaryUser='+PrimaryUser+'&SecondaryServer='+SecondaryServer+'&SecondaryUser='+SecondaryUser+'&CreatedBy='+CreatedBy+//NO I18N
                            '&CreatedTime='+CreatedTime+'&Description='+Description;//NO I18N
            if(sday!==""&&eday!==""&&!validateCriteria())
            {
                return;
            }
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                locReplaceURL("/apiclient/ajaxResponse.jsp?RequestType=exportCsv&ReportType=LandingServersReport"+params);//NO I18N
            }
            else{
                messageNotification("messageNotifyFailure",I18N.getMsg("js.report.export.noDataAvailableToExport"));//No I18N
            }
       },
       dataCheck:function() {
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate;
            App.ReportController.scheduleType="LandingServersReport";//No I18N
            var app=this.get('controllers.application');
            if(sday!==""&&eday!==""&&!validateCriteria())
            {
                return;
            }
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                app.send('opendialog','EmailNotify');//NO I18N
            }else{
             messageNotification("messageNotifyFailure",I18N.getMsg("js.report.datacheck.noDataAvailable"));//No I18N
            }
       }        
   } 
});

App.ReportSSHResourceReportController = Ember.ObjectController.extend({
     needs:'application',//NO I18N
    actions : {
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        go: function() {
           if(validateCriteria())
            {
                var groupId="";
                var groupName="";
                if(window.userRole === "Administrator")
                {
                    var select = $('#GROUPS');
                    var group = select.attr("name");//NO I18N
                    groupId = select.val();
                    groupName = $( "#GROUPS option:selected" ).text();
                    if(groupId === 'allgroups')
                    {
                        groupId="";
                        groupName="";
                    }
                }
            var resourcename=document.getElementById("gs_ResourceName").value;
            var description = document.getElementById("gs_Description").value;
            var ipaddress=document.getElementById("gs_IPAddress").value;
            var creationtime=document.getElementById("gs_CreationTime").value;
            var landingserver=document.getElementById("gs_LSName").value;
            var isLs = document.getElementById("gs_isLS").value;
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate;
                App.ReportController.scheduleType="SSHResourceReport";//No I18N
                var ajaxRequestUrl = '/api/pki/Inventory/listsshSummary'; //No I18N
                var reqParams='&isLS='+isLs+'&landingServer='+landingserver+'&description='+description+'&groupId='+groupId+'&groupName='+groupName+'&resourcename='+resourcename+'&ipaddress='+ipaddress+'&creationtime='+creationtime+'&scheduleType='+"SSHResourceReport"+'&SDAY='+sday+'&EDAY='+eday;//No I18N
                getAjaxApiRequest(ajaxRequestUrl,reqParams,function(jsonData){
                    createSSHResourceList(jsonData);
                });
            }  
        },
        exportPdf:function()
        {
            if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
            var groupId="";
            var groupName="";
            if(window.userRole === "Administrator")
            {
                var select = $('#GROUPS');
                var group = select.attr("name");//NO I18N
                groupId = select.val();
                groupName = $( "#GROUPS option:selected" ).text();
                if(groupId === 'allgroups')
                {
                    groupId="";
                    groupName="";
                }
            }
            var resourcename=document.getElementById("gs_ResourceName").value;
            var description = document.getElementById("gs_Description").value;
            var ipaddress=document.getElementById("gs_IPAddress").value;
            var creationtime=document.getElementById("gs_CreationTime").value;
            var landingserver=document.getElementById("gs_LSName").value;
            var isLs = document.getElementById("gs_isLS").value;
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate;    
            App.ReportController.scheduleType="SSHResourceReport";//No I18N
            var reqParams='&isLS='+isLs+'&landingServer='+landingserver+'&description='+description+'&groupId='+groupId+'&groupName='+groupName+'&resourcename='+resourcename+'&ipaddress='+ipaddress+'&creationtime='+creationtime+'&scheduleType='+"SSHResourceReport"+'&SDAY='+sday+'&EDAY='+eday;//No I18N
            if(sday!==""&&eday!==""&&!validateCriteria())
            {
                return;
            }
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                locReplaceURL("/apiclient/ajaxResponse.jsp?RequestType=exportPdf&ReportType=SSHResourceReport"+reqParams);//NO I18N
            }
            else{
                messageNotification("messageNotifyFailure",I18N.getMsg("js.report.export.noDataAvailableToExport"));//No I18N
            }
            
        },
        exportCsv:function()
        {
            if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
            var groupId="";
            var groupName="";
            if(window.userRole === "Administrator")
            {
                var select = $('#GROUPS');
                var group = select.attr("name");//NO I18N
                groupId = select.val();
                groupName = $( "#GROUPS option:selected" ).text();
                if(groupId === 'allgroups')
                {
                    groupId="";
                    groupName="";
                }
            }
            var resourcename=document.getElementById("gs_ResourceName").value;
            var description = document.getElementById("gs_Description").value;
            var ipaddress=document.getElementById("gs_IPAddress").value;
            var creationtime=document.getElementById("gs_CreationTime").value;
            var landingserver=document.getElementById("gs_LSName").value;
            var isLs = document.getElementById("gs_isLS").value;
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate;
            App.ReportController.scheduleType="SSHResourceReport";//No I18N
            var reqParams='&isLS='+isLs+'&landingServer='+landingserver+'&description='+description+'&groupId='+groupId+'&groupName='+groupName+'&resourcename='+resourcename+'&ipaddress='+ipaddress+'&creationtime='+creationtime+'&scheduleType='+"SSHResourceReport"+'&SDAY='+sday+'&EDAY='+eday;//No I18N
            if(sday!==""&&eday!==""&&!validateCriteria())
            {
                return;
            }
           var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                locReplaceURL("/apiclient/ajaxResponse.jsp?RequestType=exportCsv&ReportType=SSHResourceReport"+reqParams);//NO I18N
            }else{
                messageNotification("messageNotifyFailure",I18N.getMsg("js.report.export.noDataAvailableToExport"));//No I18N
            }
              
        },
        dataCheck:function()
        {         
            var sday=App.ReportController.fromdate;
            var eday=App.ReportController.todate;
            App.ReportController.scheduleType="SSHResourceReport";//No I18N
            var app=this.get('controllers.application');
            if(sday!==""&&eday!==""&&!validateCriteria())
            {
                return;
            }            
                var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                app.send('opendialog','EmailNotify');//NO I18N
            }else{
             messageNotification("messageNotifyFailure",I18N.getMsg("js.report.datacheck.noDataAvailable"));//No I18N
            }
        }
    }
});

App.ReportUsersReportController = Ember.ObjectController.extend({
     needs:'application',//NO I18N
    actions : {
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        go: function() {
           if(validateCriteria())
            {
                var resourcename=document.getElementById("gs_ResourceName").value;                
                var username=document.getElementById("gs_UserName").value;
                var associatedkeys=document.getElementById("gs_AssociatedKeys").value;
                App.ReportController.scheduleType="UsersReport";//No I18N
                var ajaxRequestUrl = '/api/pki/Inventory/listUsers'; //No I18N
                var reqParams='&resourcename='+resourcename+'&username='+username+'&associatedkeys='+associatedkeys+'&scheduleType='+"UsersReport";//No I18N
                getAjaxApiRequest(ajaxRequestUrl,reqParams,function(jsonData){
                createInventoryList(jsonData);
                });
            }  
        },
        exportPdf:function()
        {
            if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
            var groupId="";
            var groupName="";
            if(window.userRole === "Administrator")
            {
                var select = $('#GROUPS');
                var group = select.attr("name");//NO I18N
                groupId = select.val();
                groupName = $( "#GROUPS option:selected" ).text();
                if(groupId === 'allgroups')
                {
                    groupId="";
                    groupName="";
                }
            }
                var resourcename=document.getElementById("gs_ResourceName").value;                
                var username=document.getElementById("gs_UserName").value;
                var associatedkeys=document.getElementById("gs_AssociatedKeys").value;
                App.ReportController.scheduleType="UsersReport";//No I18N
                var ajaxRequestUrl = '/api/pki/Inventory/listUsers'; //No I18N
            var reqParams='&groupName='+groupName+'&groupId='+groupId+'&resourcename='+resourcename+'&username='+username+'&associatedkeys='+associatedkeys+'&scheduleType='+"UsersReport";//No I18N
                var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                locReplaceURL("/apiclient/ajaxResponse.jsp?RequestType=exportPdf&ReportType=UsersReport"+reqParams);//NO I18N
                }else{
                messageNotification("messageNotifyFailure",I18N.getMsg("js.report.export.noDataAvailableToExport"));//No I18N
            }
              
        },
        exportCsv:function()
        {
            if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
            var groupId="";
            var groupName="";
            if(window.userRole === "Administrator")
            {
                var select = $('#GROUPS');
                var group = select.attr("name");//NO I18N
                groupId = select.val();
                groupName = $( "#GROUPS option:selected" ).text();
                if(groupId === 'allgroups')
                {
                    groupId="";
                    groupName="";
                }
            }
            var resourcename=document.getElementById("gs_ResourceName").value;                
            var username=document.getElementById("gs_UserName").value;
            var associatedkeys=document.getElementById("gs_AssociatedKeys").value;
            App.ReportController.scheduleType="UsersReport";//No I18N
            var ajaxRequestUrl = '/api/pki/Inventory/listUsers'; //No I18N
            var reqParams='&groupName='+groupName+'&groupId='+groupId+'&resourcename='+resourcename+'&username='+username+'&associatedkeys='+associatedkeys+'&scheduleType='+"UsersReport";//No I18N
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                locReplaceURL("/apiclient/ajaxResponse.jsp?RequestType=exportCsv&ReportType=UsersReport"+reqParams);//NO I18N
            }else{
                messageNotification("messageNotifyFailure",I18N.getMsg("js.report.export.noDataAvailableToExport"));//No I18N
            }
          
        },
        dataCheck:function()
        {
            var resourcename=document.getElementById("gs_ResourceName").value;                
            var username=document.getElementById("gs_UserName").value;
            var associatedkeys=document.getElementById("gs_AssociatedKeys").value;
            App.ReportController.scheduleType="UsersReport";//No I18N
            var ajaxRequestUrl = '/api/pki/Inventory/listUsers'; //No I18N
            var reqParams='&resourcename='+resourcename+'&username='+username+'&associatedkeys='+associatedkeys+'&scheduleType='+"UsersReport";//No I18N
            var app=this.get('controllers.application');
            var ids = jQuery("#reportView").jqGrid('getDataIDs');//NO I18N
            if(ids.length>0)
            {
                app.send('opendialog','EmailNotify');//NO I18N
            }else{
             messageNotification("messageNotifyFailure",I18N.getMsg("js.report.datacheck.noDataAvailable"));//No I18N
            }
        }
    }
});

function validateCriteria()
{
    
   var sday=App.ReportController.fromdate;
   var eday=App.ReportController.todate;
    var date=new Date();
    var currentyear=date.getFullYear();
    if((sday===""||sday===" ")&&(eday===""||eday===" "))
    {
        showAlert(I18N.getMsg("js.report.timelinecriteria.alert.Specifydate"));//No I18N
        //alert("hello");
        return false;
    }else if(sday=="")
    {
        showAlert(I18N.getMsg("js.report.timelineCriteria.alert.Specifyfromdate"));//No I18N
         return false;
    }else if(eday=="")
    {
        showAlert(I18N.getMsg("js.report.timelineCriteria.alert.Specifytodate"));//No I18N
         return false;
    }
    var dateArray=sday.split("/");
    var month=dateArray[0];
    var dd=dateArray[1];
    var year=dateArray[2];
    if(month>12||month<1||dd>31||dd<1)
    {
        showAlert(I18N.getMsg("js.report.timelineCriteria.alert.SpecifyValidfromdate"));//No I18N
        return false;
    }  
    var dateArray=eday.split("/");
    var month=dateArray[0];
    var dd=dateArray[1];
    var year=dateArray[2];
    if(month>12||month<1||dd>31||dd<1)
    {
        showAlert(I18N.getMsg("js.report.timelineCriteria.alert.SpecifyValidtodate"));//No I18N
        return false;
    }  
    var sd=new Date();
    sd=Date.parse(sday);
    var ed=new Date();
    ed=Date.parse(eday);
    if(ed<sd)
    {
        showAlert(I18N.getMsg("js.report.timelineCriteria.alert.ToDateshouldbeGreaterthanorEqualtoFromDate"));//No I18N
        return false;
    }
    return true;
}

function reportGroupCriteria()
{
    var select = $('#GROUPS');
    var group = select.attr("name");//NO I18N
    var groupId = select.val();
    var groupName = $( "#GROUPS option:selected" ).text();
    if(groupId === 'allgroups')
    {
        groupId="";
        groupName="";
    }
    if(group === "keys")
    {
        var keyname=document.getElementById("gs_KeyName").value;//NO I18N                
        var keytype=document.getElementById("gs_KeyType").value;
        var keylength=document.getElementById("gs_KeyLength").value;
        var fingerprint=document.getElementById("gs_FingerPrint").value;
        var createdby=document.getElementById("gs_CreatedBy").value;
        var creationtime=document.getElementById("gs_CreationTime").value;                
        var sday=App.ReportController.fromdate;
        var eday=App.ReportController.todate;
        var reqParams="groupName="+groupName+"&groupId="+groupId+"&keyname="+keyname+"&keytype="+keytype+"&keylength="+keylength+"&fingerprint="+fingerprint+"&createdby="+createdby+"&creationtime="+creationtime+"&SDAY="+sday+"&EDAY="+eday+"&scheduletype="+"PrivateKeyReport";//NO I18N
        var ajaxRequestUrl = '/api/pki/ssh/getSSHKeysReport'; //No I18N
        App.ReportController.scheduleType="PrivateKeyReport";//No I18N
        getAjaxApiRequest(ajaxRequestUrl,reqParams,function(jsonData){
            createKeyList(jsonData);
        });
    }
    else if(group === "users")
    {
        var resourcename=document.getElementById("gs_ResourceName").value;                
        var username=document.getElementById("gs_UserName").value;
        var associatedkeys=document.getElementById("gs_AssociatedKeys").value;
        App.ReportController.scheduleType="UsersReport";//No I18N
        var ajaxRequestUrl = '/api/pki/Inventory/listUsers'; //No I18N
        var reqParams='&groupName='+groupName+'&groupId='+groupId+'&resourcename='+resourcename+'&username='+username+'&associatedkeys='+associatedkeys+'&scheduleType='+"UsersReport";//No I18N
        getAjaxApiRequest(ajaxRequestUrl,reqParams,function(jsonData){
        createUsersList(jsonData);
        });
    }
    else if(group === "resources")
    {
        var description = document.getElementById("gs_Description").value;
        var resourcename=document.getElementById("gs_ResourceName").value;
        var ipaddress=document.getElementById("gs_IPAddress").value;
        var resourcetype=document.getElementById("gs_ResourceType").value;
        var creationtime=document.getElementById("gs_CreationTime").value;
        var sday=App.ReportController.fromdate;
        var eday=App.ReportController.todate;
        App.ReportController.scheduleType="ResourceReport";//No I18N
        var ajaxRequestUrl = '/api/pki/Inventory/listSummary'; //No I18N
        var reqParams='&description='+description+'&groupName='+groupName+'&groupId='+groupId+'&resourcename='+resourcename+'&ipaddress='+ipaddress+'&resourcetype='+resourcetype+'&creationtime='+creationtime+'&scheduleType='+"ResourceReport"+'&SDAY='+sday+'&EDAY='+eday;//No I18N
        getAjaxApiRequest(ajaxRequestUrl,reqParams,function(jsonData){
        createInventoryList(jsonData);
        });
    }
    else if(group === "sshResources")
    {
        var resourcename=document.getElementById("gs_ResourceName").value;
        var ipaddress=document.getElementById("gs_IPAddress").value;
        var creationtime=document.getElementById("gs_CreationTime").value;
        var sday=App.ReportController.fromdate;
        var eday=App.ReportController.todate;
        App.ReportController.scheduleType="SSHResourceReport";//No I18N
        var description = document.getElementById("gs_Description").value;
        var landingserver=document.getElementById("gs_LSName").value;
        var isLs = document.getElementById("gs_isLS").value;
        var ajaxRequestUrl = '/api/pki/Inventory/listsshSummary'; //No I18N
        var reqParams='&isLS='+isLs+'&landingServer='+landingserver+'&description='+description+'&groupName='+groupName+'&groupId='+groupId+'&resourcename='+resourcename+'&ipaddress='+ipaddress+'&creationtime='+creationtime+'&scheduleType='+"SSHResourceReport"+'&SDAY='+sday+'&EDAY='+eday;//No I18N
        getAjaxApiRequest(ajaxRequestUrl,reqParams,function(jsonData){
            createSSHResourceList(jsonData);
        });
    }
    else if(group === "sslCertificates")
    {
        var resourcename=document.getElementById("gs_Common Name").value;
        var description = document.getElementById("gs_Description").value;
        var domainname=document.getElementById("gs_DNS Name/FQDN").value;
        var organization=document.getElementById("gs_Organization").value;
        var fromdate=document.getElementById("gs_FromDate").value;
        var expirydate=document.getElementById("gs_ExpiryDate").value;
        var keylength=document.getElementById("gs_KeyStrength").value;
        var keyAlgorithm=document.getElementById("gs_keyAlgorithm").value;
        var signatureAlgorithm=document.getElementById("gs_signatureAlgorithm").value;
        var creationtime = document.getElementById("gs_CreationTime").value;
        var sday=App.ReportController.fromdate;
        var eday=App.ReportController.todate;        
        App.ReportController.scheduleType="SslCertificateReport";//No I18N
        var ajaxRequestUrl = '/api/pki/Inventory/listsslSummary'; //No I18N
        var reqParams='&groupName='+groupName+'&groupId='+groupId+'&description='+description+'&SDAY='+sday+'&EDAY='+eday+'&fromdate='+fromdate+'&creationtime='+creationtime+'&resourcename='+resourcename+'&domainname='+domainname+'&organization='+organization+'&expirydate='+expirydate+'&keylength='+keylength+'&keyAlgorithm='+keyAlgorithm+'&signatureAlgorithm='+signatureAlgorithm;//No I18N
        getAjaxApiRequest(ajaxRequestUrl,reqParams,function(jsonData){
            createSslList(jsonData);
        });
}
    else if(group === "sslExpiry")
    {
        var resourcename=document.getElementById("gs_Common Name").value;
        var description = document.getElementById("gs_Description").value;
        var domainname=document.getElementById("gs_DNS Name/FQDN").value;
        var organization=document.getElementById("gs_Organization").value;
        var fromdate=document.getElementById("gs_FromDate").value;
        var expirydate=document.getElementById("gs_ExpiryDate").value;
        var keylength=document.getElementById("gs_KeyStrength").value;
        var days=document.getElementById("gs_DaysToExpiry").value;
        var esday=App.ReportController.fromdate;
        var eeday=App.ReportController.todate;    
        var daysfilter=App.ReportController.days="";
        App.ReportController.scheduleType="SSLExpiryReport";//No I18N
        var ajaxRequestUrl = '/api/pki/Inventory/listsslSummary'; //No I18N
        var reqParams='&groupName='+groupName+'&groupId='+groupId+'&description='+description+'&ESDAY='+esday+'&EEDAY='+eeday+'&days='+days+'&daysfilter='+daysfilter+'&fromdate='+fromdate+'&resourcename='+resourcename+'&domainname='+domainname+'&organization='+organization+'&expirydate='+expirydate+'&keylength='+keylength;//No I18N
        getAjaxApiRequest(ajaxRequestUrl,reqParams,function(jsonData){
            createSslExpiryList(jsonData);
        });
    }
    else if(group==="sslVulnerabilities")
    {
        var resourcename=document.getElementById("gs_Common Name").value;
        var description = document.getElementById("gs_Description").value;
        var domainname=document.getElementById("gs_DNS Name/FQDN").value;
        var organization=document.getElementById("gs_Organization").value;
        var fromdate=document.getElementById("gs_FromDate").value;
        var expirydate=document.getElementById("gs_ExpiryDate").value;
        var keylength=document.getElementById("gs_KeyStrength").value;
        var keyAlgorithm=document.getElementById("gs_keyAlgorithm").value;
        var signatureAlgorithm=document.getElementById("gs_signatureAlgorithm").value;
        var creationtime = document.getElementById("gs_CreationTime").value;
        var sday=App.ReportController.fromdate;
        var eday=App.ReportController.todate;        
        App.ReportController.scheduleType="SSLVulnerabilitiesReport";//No I18N
        var ajaxRequestUrl = '/api/pki/Inventory/listsslSummary'; //No I18N
        var reqParams='&groupId='+groupId+'&groupName='+groupName+'&description='+description+'&SDAY='+sday+'&EDAY='+eday+'&fromdate='+fromdate+'&creationtime='+creationtime+'&resourcename='+resourcename+'&domainname='+domainname+'&organization='+organization+'&expirydate='+expirydate+'&keylength='+keylength+'&keyAlgorithm='+keyAlgorithm+'&signatureAlgorithm='+signatureAlgorithm;//No I18N
        getAjaxApiRequest(ajaxRequestUrl,reqParams,function(jsonData){
            createSslList(jsonData);
        });
    }
}

function locReplaceURL(url)
{
    if(kmpStandAlone)
    {
        location.replace(url);
    }else{
        location.replace("/pki"+url);//NO I18N
    }
}
