// $Id$
App.SSLMgmtRequestView = Ember.View.extend({
    templateName: 'RequestOpen',//No I18N
        didInsertElement: function(){
            App.Request.getResourceNames();
            if(!kmpStandAlone){
                selectKMPTab("ssl_certRequest");//NO I18N
            }
        }
                    });

App.RequestOpenView = Ember.View.extend({
    templateName: 'RequestOpen',//No I18N
        didInsertElement: function(){
            if(App.RequestCertController.flag)
            {
                App.RequestCertController.requestType="New_Cert_Req";//No I18N    
            App.Request.getResourceNames();
            }
            else
            {
                App.Request.getRequestDetails(App.RequestCertController.req_id);
            }
            if(!kmpStandAlone){
                selectKMPTab("ssl_certRequest");//NO I18N
        }
        }
                    });

App.RequestListView = Ember.View.extend({
    templateName: 'RequestList',//No I18N
        didInsertElement: function(){
            var controller = this.get('controller');
            App.Request.getRequestList(controller);
            if(!kmpStandAlone){
                selectKMPTab("ssl_certRequest");//NO I18N
        }
        }
});

App.CreateFormView = Ember.View.extend({
    templateName: 'CreateForm',//No I18N
        didInsertElement: function(){
             App.RequestCertController.isCSR=false;
            document.getElementById("selfSigned").checked=true;
                $("#cert_type").hide();
                $("#csrhelp").hide();
            $("#Cert_Title").text(I18N.getMsg("js.ssl.createCertificateTitle"));//No I18N    
        }
});

App.LetsEncryptView = Ember.View.extend({
    templateName: 'LetsEncrypt',//NO I18N
    didInsertElement: function(){
        App.Request.listLetsEncryptAccounts();
        if(!kmpStandAlone){
            selectKMPTab("ssl_letsencrypt");//NO I18N
    }
    }
});

App.AssignDefaultDNSView = Ember.View.extend({
   templateName:'AssignDefaultDNS',//NO I18N
   didInsertElement: function(){
       $(".modal-title").text(I18N.getMsg('dns.global.provider'));//NO I18N
   }
});

App.AddDefaultDNSView = Ember.View.extend({
   templateName:'AddDefaultDNS',//NO I18N
   didInsertElement: function(){
       App.RequestCertController.dns_id="";
       $(".modal-title").text(I18N.getMsg('dns.global.provider'));//NO I18N
       $(".modal-dialog").css({"width":"600px"});
       $(".modal-body").css({'max-height':'600px','overflow':'auto'}); 
       getDnsServersList();
   }
});

App.DNSProviderView = Ember.View.extend({
    templateName: 'DNSProvider',//NO I18N
    didInsertElement: function(){
        App.Request.defaultDNSServers();
    }
});

App.AddNewAccountView = Ember.View.extend({
    templateName: 'AddNewAccount',//NO I18N
    didInsertElement: function(){
        if(!kmpStandAlone){
            selectKMPTab("ssl_letsencrypt");//NO I18N
        }            
        
    }
});

App.WAgentsView = Ember.View.extend({
    templateName: 'WAgents',//NO I18N
    didInsertElement: function(){
        App.Request.WAgents();
    }
});

App.LETSMgmtView = Ember.View.extend({
	templateName: 'letsMgmt',//No I18N
		didInsertElement: function(){

                    }
});

App.NewRegistrationView = Ember.View.extend({
    templateName: 'NewRegistration',//NO I18N
    didInsertElement: function(){
        
    }
});

App.LetsEncryptDeployMappingView = Ember.View.extend({
   templateName: 'LetsEncryptDeployMapping',//NO I18N 
   didInsertElement: function(){
    App.Request.letsEncryptDomainMappings(App.RequestCertController.domain);
        if(!kmpStandAlone){
            selectKMPTab("ssl_letsencrypt");//NO I18N
   }
   }
});

App.LetsEncryptRequestView = Ember.View.extend({
    templateName: 'LetsEncryptRequest',//No I18N
        didInsertElement: function(){
            var ajaxRequestUrl = '/api/pki/letsencrypt/accountExists?'; //No I18N
            getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){ 
                if(jsonData.account === "false")
                {
                    $("#createRequest").hide();
                    $(":submit").attr("disabled", true);
                    vConfirmation(I18N.getMsg('letsencrypt.addorregister.account'),function(){//NO I18N
                        if(App.ApplicationController.isAdmin===true)
                        {
                            redirectUrl("LETSMgmt/LETSAccount");//NO I18N
                        }
                    });                    
                }                
            if(!kmpStandAlone){
                selectKMPTab("ssl_letsencrypt");//NO I18N
            }            
                
//                var url = window.location.href;
//                if(url.includes('?'))
//                {
//                    var domains = url.split("?");
//                    var domain_names=domains[1];
//                    $("#common_name").val(domain_names);
//                }
            });
        }
});

App.GoDaddyRevokeView = Ember.View.extend({
   templateName:'GoDaddyRevoke',//NO I18N
   didInsertElement: function(){
       $(".modal-title").text(I18N.getMsg('js.letsencrypt.revoke'));//NO I18N
   }
});

App.GoDaddyRenewView = Ember.View.extend({
   templateName:'GoDaddyRenew',//NO I18N
   didInsertElement: function(){
        $(".modal-title").text(I18N.getMsg('js.letsencrypt.renew'));//NO I18N
        $("#GoDaddyRenew .modal-dialog").css('width','700px');
        $("#GoDaddyRenew .modal-body").css('width','700px');    
        var grid = jQuery("#PendingCertList"); //No I18N
        var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
        var order_id = grid.jqGrid('getCell', selRowIds, 'ID'); //No I18N
        var ajaxUrl = '/api/pki/godaddy/renewDetails?order_id='+order_id; //No I18N  
        getAjaxApiRequest(ajaxUrl,"",function(jsonData){
            if(jsonData.Status === "Success")
            {            
                 var rootType = jsonData.rootType;
                 var certType = jsonData.product;
                 var period = jsonData.period;
                 var commonName = jsonData.CommonName;
                 var sanSize = jsonData.sanSize;
                 var san = jsonData.san;                 
                 var cert_type = certType.split("_");   
                 document.getElementById("common_name").value= commonName;
                 document.getElementById("Cert_Type").value=certType;
                 document.getElementById("san_slot").value=sanSize;
                 document.getElementById("san_slot").disabled=true;
                 document.getElementById("san_name").value=san;
                 document.getElementById("Root_Type").value=rootType;
                 document.getElementById("cert_period").value=period;
                if(cert_type[0]==="UCC")
                {                    
                    $("#sandiv").show();
                }          
            }
            else
            {
                document.getElementById("closeButton").click();
                messageNotification("messageNotifyFailure",jsonData.Message);//NO I18N                 
            }
        });            
   }
});

App.GoDaddyReissueView = Ember.View.extend({
   templateName:'GoDaddyReissue',//NO I18N
   didInsertElement: function(){
        $(".modal-title").text(I18N.getMsg('godaddy.reissuecertificate'));//NO I18N
        $("#GoDaddyReissue .modal-dialog").css('width','700px');
        $("#GoDaddyReissue .modal-body").css('width','700px');    
        var grid = jQuery("#PendingCertList"); //No I18N
        var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
        var order_id = grid.jqGrid('getCell', selRowIds, 'ID'); //No I18N
        var ajaxUrl = '/api/pki/godaddy/renewDetails?order_id='+order_id; //No I18N  
        getAjaxApiRequest(ajaxUrl,"",function(jsonData){
            if(jsonData.Status === "Success")
            {            
                 var rootType = jsonData.rootType;
                 var certType = jsonData.product;
                 var period = jsonData.period;
                 var commonName = jsonData.CommonName;
                 var sanSize = jsonData.sanSize;
                 var san = jsonData.san;                 
                 var cert_type = certType.split("_");   
                 document.getElementById("common_name").value= commonName;
                 document.getElementById("Cert_Type").value=certType;
                 document.getElementById("san_slot").value=sanSize;
                 document.getElementById("san_slot").disabled=true;
                 document.getElementById("san_name").value=san;
                 document.getElementById("Root_Type").value=rootType;                 
                if(cert_type[0]==="UCC")
                {                    
                    $("#sandiv").show();
                }          
            }
            else
            {
                document.getElementById("closeButton").click();
                messageNotification("messageNotifyFailure",jsonData.Message);//NO I18N                 
            }
        });            
   }
});

App.GoDaddyView = Ember.View.extend({
   templateName:'GoDaddy',//NO I18N
   didInsertElement: function(){
       var ajaxRequestUrl = '/api/pki/godaddy/godaddyAccountExists'; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){ 
            if(!jsonData.account)
            {                    
                $('#createOrderButton').hide();
                $("#alertAddAccount").show();
                vConfirmation(I18N.getMsg('godaddy.add.account'),function(){//NO I18N
                    if(App.ApplicationController.isAdmin===true)
                    {
                        document.getElementById("godaddyaccount").click();
                    }
                });                    
            }               
            else
            {
                $('#createOrderButton').show();
                $("#alertAddAccount").hide();
            }
        });                   
        App.Request.godaddyRequestsList();  
   }
});

App.GodaddyAddAccountView = Ember.View.extend({
   templateName:'GodaddyAddAccount',//NO I18N
   didInsertElement: function(){
       $(".modal-title").text(I18N.getMsg('godaddy.add.accounttitle'));//NO I18N
       var ajaxRequestUrl = '/api/pki/godaddy/godaddyAccount'; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){ 
            $("#key").val(jsonData.key);
        });
   }
});

App.GoDaddyOrderView = Ember.View.extend({
   templateName:'GoDaddyOrder',//NO I18N
   didInsertElement: function(){
       var ajaxRequestUrl = '/api/pki/godaddy/godaddyAccountExists'; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){ 
            if(!jsonData.account)
            {                 
                $("#createRequest").hide();
                $(":submit").attr("disabled", true);
                vConfirmation(I18N.getMsg('godaddy.add.account'),function(){//NO I18N
                    if(App.ApplicationController.isAdmin===true)
                    {
                        $("#godaddyaccount").attr("disabled", false);
                        document.getElementById("godaddyaccount").click();
                    }
                });                    
            }
            else
            {
       var ajaxRequestUrl = '/api/pki/godaddy/getLoggedInUserDetails'; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){ 
            $("#contact_firstname").val(jsonData.firstName);
            $("#contact_middlename").val(jsonData.middleName);
            $("#contact_lastname").val(jsonData.lastName);
            $("#contact_email").val($("<div>").html(jsonData.email).text());
        });
   }
});
   }
});

App.CreateTxtRecordView = Ember.View.extend({
   templateName:'CreateTxtRecord',//NO I18N
   didInsertElement: function(){
       $(".modal-title").text(I18N.getMsg('godaddy.createtxtrecord'));//NO I18N
       getDnsServersList();
   }
});

App.GoDaddyHistoryView = Ember.View.extend({
   templateName:'GoDaddyHistory',//NO I18N
   didInsertElement: function(){
       var order_id = App.RequestCertController.order_id;
       var ajaxUrl = '/api/pki/godaddy/getHistory?order_id='+order_id; //No I18N  
        getAjaxApiRequest(ajaxUrl,"",function(jsonData){
            var colNamesList = ['VersionId',I18N.getMsg('js.commonstr.certificatename'),I18N.getMsg("js.cert.sans"),I18N.getMsg('js.report.timeline.fromdate'),I18N.getMsg('js.report.timeline.todate'),I18N.getMsg("js.revoked.by"),I18N.getMsg("godaddy.revokereason"),I18N.getMsg('js.table.search')];//NO I18N
            var colModelList = [
                {name:'VERSION_ID',index:'VERSION_ID',hidden:true},//NO I18N
                {name:'CommonName',index:'CommonName'},//NO I18N
                {name:'San',index:'San'},//NO I18N
                {name:'VALID_FROM',index:'VALID_FROM'},//NO I18N
                {name:'VALID_TO',index:'VALID_TO'},//NO I18N
                { name: "RevokedBy",index:"RevokedBy"},//NO I18N
                { name: "RevokeReason",index:"RevokeReason"},//NO I18N
                { name: 'search',width:40,sortable: false,search:false,fixed:true}//NO I18N
            ];
            var defaultOptions={multiselect:true,rowNumNeeded:false,searchOption:true};
            loadJQgridWithData("#historyList", jsonData.historyList, colNamesList, colModelList, "", "#historyListPager", "GoDaddyHistory",defaultOptions);//No I18N     
        });
   }
});

App.GoDaddyOrderDetailsView = Ember.View.extend({
   templateName:'GoDaddyOrderDetails',//NO I18N
   didInsertElement: function(){
       var order_id = App.RequestCertController.order_id;
       var ajaxUrl = '/api/pki/godaddy/getOrderDetails?order_id='+order_id; //No I18N  
        getAjaxApiRequest(ajaxUrl,"",function(jsonData){
            var colModelList = [
                        { name: 'id',width:"0px"},//No I18N
                        { name: 'Key', index: 'Key',sortable: false}, //No I18N
                        { name: 'Value', index: 'Value',sortable: false}, //No I18N                        
                ];
            var dataArray = new Array();
            var colNamesList = ['',jsonData.CommonName,'']; //No I18N
            dataArray.push({"Key":I18N.getMsg('js.commonstr.certificatename'), "Value":jsonData.CommonName});//No I18N      
            var status = jsonData.Status;
            var cert_status = jsonData.CertStatus;
            if(status==="CERTIFICATE ISSUED" && cert_status==="saved")
            {
                status=I18N.getMsg("godaddy.cert.saved");//NO I18N
            }
            else if(status==="CERTIFICATE ISSUED" && cert_status==="pending")
            {
                status=I18N.getMsg("godaddy.liscence.count");//NO I18N
            }
            dataArray.push({"Key":I18N.getMsg('js.commonstr.status'),"Value":status});//NO I18N
            dataArray.push({"Key":I18N.getMsg('js.ssl.certificatetype'),"Value":jsonData.CertType});//NO I18N
            if(jsonData.San!==undefined)
            {
                dataArray.push({"Key":I18N.getMsg('js.cert.sans'),"Value":jsonData.San});//NO I18N
            }
            dataArray.push({"Key":I18N.getMsg('godaddy.san.period'),"Value":jsonData.Period});//NO I18N
            dataArray.push({"Key":I18N.getMsg('godaddy.san.roottype'),"Value":jsonData.RootType});//NO I18N                
            if(jsonData.ValidFrom!==undefined)
            {
                dataArray.push({"Key":I18N.getMsg('js.report.timeline.fromdate'),"Value":jsonData.ValidFrom});//NO I18N
                dataArray.push({"Key":I18N.getMsg('js.report.timeline.todate'),"Value":jsonData.ValidTo});//NO I18N
            }
            dataArray.push({"Key":I18N.getMsg('godaddy.contactname'),"Value":jsonData.ContactName});//NO I18N
            dataArray.push({"Key":I18N.getMsg('godaddy.contactmail'),"Value":jsonData.ContactEmail});//NO I18N
            dataArray.push({"Key":I18N.getMsg('godaddy.contactphone'),"Value":jsonData.ContactPhone});//NO I18N
            if(jsonData.OrgName!==undefined)
            {
                dataArray.push({"Key":I18N.getMsg('js.cert.org'),"Value":jsonData.OrgName});//NO I18N
            }
            if(jsonData.OrgAddressOne!==undefined)
            {
                dataArray.push({"Key":I18N.getMsg('godaddy.orgaddress1'),"Value":jsonData.OrgAddressOne});//NO I18N
            }
            if(jsonData.OrgAddressTwo!==undefined)
            {
                dataArray.push({"Key":I18N.getMsg('godaddy.orgaddress2'),"Value":jsonData.OrgAddressTwo});//NO I18N
            }
            if(jsonData.OrgPhone!==undefined)
            {
                dataArray.push({"Key":I18N.getMsg('godaddy.orgphone'),"Value":jsonData.OrgPhone});//NO I18N
            }
            if(jsonData.RevokedBy!==undefined)
            {
                dataArray.push({"Key":I18N.getMsg('js.revoked.by'),"Value":jsonData.RevokedBy});//NO I18N
                dataArray.push({"Key":I18N.getMsg('godaddy.revokereason'),"Value":jsonData.RevokeReason});//NO I18N
            }
            if(jsonData.SiteSeal!==undefined)
            {
                var siteSeal =jsonData.SiteSeal;
                siteSeal = siteSeal.replace(/</g,"&lt;");
                siteSeal = siteSeal.replace(/>/g,"&gt;");
                siteSeal = siteSeal.replace(/\"/g,"&quot;");                
                siteSeal = '<div style="white-space:normal;word-wrap:break-word">'+siteSeal+'</div>';//NO I18N
                dataArray.push({"Key":I18N.getMsg('godaddy.siteseal'),"Value":siteSeal});//NO I18N
            }
            var defaultOptions={multiselect:false,rowNumNeeded:false};
            loadJQgridWithData("#PKIInventoryDetailsList", dataArray, colNamesList, colModelList, "", "", "GoDaddyOrderDetails",defaultOptions,false);//No I18N
        });
   }
});

App.LetsEncryptRequestListView = Ember.View.extend({
    templateName: 'LetsEncryptRequestList',//No I18N
        didInsertElement: function(){
             var ajaxRequestUrl = '/api/pki/letsencrypt/accountExists?'; //No I18N
            getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){ 
                if(jsonData.account === "false")
                {                    
                    vConfirmation(I18N.getMsg('letsencrypt.addorregister.account'),function(){//NO I18N
                        if(App.ApplicationController.isAdmin===true)
                        {
                        redirectUrl("LETSMgmt/LETSAccount");//NO I18N
                        }
                    });                    
                }               
            });
            if(!kmpStandAlone){
                selectKMPTab("ssl_letsencrypt");//NO I18N
            }            
            App.Request.letsEncryptRequestsList();            
        }
});

App.LetsEncryptRequestHistoryView = Ember.View.extend({
    templateName: 'LetsEncryptRequestHistory',//NO I18N
    didInsertElement:function(){
        App.Request.letsEncryptRequestsHistory(App.RequestCertController.req_id);            
    }
});

App.AgentView = Ember.View.extend({
   templateName: 'Agent',//NO I18N
   didInsertElement: function(){
       $(".modal-title").text(I18N.getMsg('js.sshkey.deploy'));//NO I18N
       $(".modal-dialog").css({"width":"600px"});
       $(".modal-body").css({'max-height':'600px','overflow':'auto'});
       var ajaxRequestUrl = '/api/pki/letsencrypt/domainAgentView?';//NO I18N
       var params = 'domain='+App.RequestCertController.sdomain+'&agentid='+App.RequestCertController.agentid+"&challengeType="+App.RequestCertController.challengeType+"&dns_server="+App.RequestCertController.dns_server;//NO I18N
        getAjaxApiRequest(ajaxRequestUrl,params,function(jsonData){
            App.Request.agentsView(jsonData);
        });
   }
});


App.DeployStatusView = Ember.View.extend({
   templateName: 'DeployStatus',//NO I18N
    didInsertElement: function(){
        $(".modal-title").text(I18N.getMsg('challengefile.deply.title'));//NO I18N
    }
   });

App.ShowCertificateView = Ember.View.extend({
   templateName: 'ShowCertificate',//NO I18N
   didInsertElement: function(){
       var params = "req_id="+App.RequestCertController.req_id;//NO I18N
       var reqUrl = '/api/pki/letsencrypt/getCertificate';//NO I18N
        getAjaxApiRequest(reqUrl,params,function(jsonData){
            $(".modal-title").text(I18N.getMsg('letsencrypt.certificate.title'));//NO I18N
            $("#domainName").text(jsonData.domain);
            $("#newCert").html(jsonData.certificate); 
        });
   }
});

App.LetsEncryptChallengesView = Ember.View.extend({
   templateName: 'LetsEncryptChallenges',//NO I18N
   didInsertElement: function(){
       App.Request.letsEncryptRequestsChallenges(App.RequestCertController.req_id);
   }
});

App.CreatedCertListView = Ember.View.extend({
    templateName: 'CreatedCertList',//No I18N
        didInsertElement: function(){
            var controller = this.get('controller');
            App.Request.getGeneratedCerts(controller);
        }
});

App.SSLMgmtCreateCsrView = Ember.View.extend({
    templateName: 'CreateForm',//No I18N
        didInsertElement: function(){
            document.getElementById("cert_req").checked=true;
            $("#cert_type").hide();            
            $("#Cert_Title").text(I18N.getMsg("js.create.csr"));//No I18N    
            $("#forCSROnly").show();
            $("#export_cert_id").text("Export CSR");//No I18N
            $("#save_but").hide();
            $("#certhelp").hide();
            $("#isRootCheck").hide();
            $("#csrhelp").show();
        }
});

App.MailCSRmodalView=Ember.View.extend({
     templateName: 'MailCSRmodal',//No I18N
     didInsertElement: function(){
         $(".modal-title").text(I18N.getMsg("js.modaltitle.mailcsr"));//No I18N 
     }
});
